function AutoLabel(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage
	this._doc = gtdinboxPage.doc;
	this._searchers = [];
}

AutoLabel.prototype.checkAutoLabel = function(){
	// Begin the auto label check process (after a message is sent)
	// Test their are items in settings to auto label (settings.autoLabel = [{to,subject,snippet}])
	// Load threads for today that I have sent (after:2008/05/02 from:me -chat)
	// Find threads in those that match the auto label items
try{

	if( !this._gtdinboxPage.settings.autoLabel || this._gtdinboxPage.settings.autoLabel.length==0 ) return;
	
	var d = (new Date()).valueOf();
	d -= (1000*60*60*24);
	var dayAgo = new Date(d);
	var weekAgo = d * 7;
	var query = "after:" + dayAgo.getFullYear() + "/" + (dayAgo.getMonth() + 1) + "/" + dayAgo.getDate() + " from:me -chat";
	
	var labelsToRemove = {};
	
	
	var searcher = new Searcher(this._gtdinboxPage);
	searcher.search( query, GIPROTOTYPE.bind(this, function(threadList){
			try{
				var autoLabels = this._gtdinboxPage.settings.autoLabel;
				var counter = {count:0};
				for( var i = 0; i < autoLabels.length; i++ ){
					var thread = threadList.getThreadByRow(autoLabels[i].subject, autoLabels[i].snippet, autoLabels[i].names);
					if( thread ){ // Add a label to the thread using a progmatic call
						labelsToRemove[autoLabels[i].date] = true;
						for( var j = 0; j < autoLabels[i].labels.length; j++ ){
							counter.count++;
							this._gtdinboxPage.gmailDOM.addLabelToThread( thread.id, autoLabels[i].labels[j], GIPROTOTYPE.bind(this, function(){
									counter.count--;
									if( counter.count==0 ){
										// Execute a refresh
										for( var k = this._gtdinboxPage.settings.autoLabel.length - 1; k>=0; k-- ){
											if( labelsToRemove[this._gtdinboxPage.settings.autoLabel[k].date] ){
												this._gtdinboxPage.settings.autoLabel.splice(k,1);
											}
										}
										this._gtdinboxPage.saveSettings();
										this._gtdinboxPage.refreshCurrentView();
									}
								}), thread );
						}
					}
					if( autoLabels[i].date < weekAgo ) labelsToRemove[autoLabels[i].date] = true;
				}
				for( var k = this._gtdinboxPage.settings.autoLabel.length - 1; k>=0; k-- ){
					if( labelsToRemove[this._gtdinboxPage.settings.autoLabel[k].date] ){
						this._gtdinboxPage.settings.autoLabel.splice(k,1);
					}
				}
				this._gtdinboxPage.saveSettings();
			}catch(e){
				if( GTDDEBUGMODE ) alert("AutoLabel checkAutoLabel search\n" + e.toString());
			}
		}) );
	this._searchers.push(searcher);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("AutoLabel checkAutoLabel\n" + e.toString());
}

};

AutoLabel.prototype.addAutoLabel = function(nameStr, subjectStr, bodyStr, labels, initiate){
	if( !labels || labels.length==0 ) return;
	
	var autoLabel = {};
	autoLabel.subject = subjectStr;
	autoLabel.snippet = bodyStr.substr(0, 80);
	
	nameStr = nameStr.replace(";",",");
	var nameSplit = nameStr.split(",");
	var names = [];
	for( var i = 0; i < nameSplit.length; i++ ){
		var m = nameSplit[i].match(/\b[A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,4}\b/i);
		if( m ){
			names.push(m[0]);
		}
	}
	autoLabel.names = names;
	autoLabel.labels = labels;
	autoLabel.date = (new Date()).valueOf();
	
	if( !this._gtdinboxPage.settings.autoLabel ) this._gtdinboxPage.settings.autoLabel = [];
	this._gtdinboxPage.settings.autoLabel.push( autoLabel );
	this._gtdinboxPage.saveSettings();
	
	if( initiate ){
		setTimeout( GIPROTOTYPE.bind(this, function(){
				this.checkAutoLabel();
			}), 10000);
	}
};

AutoLabel.prototype.destroy = function(){
	for( var i = 0; i < this._searchers.length; i++ ){
		this._searchers[i].destroy();
	}
	this._searchers.length = 0;
	this._gtdinboxPage = null;
};