function CloseContacts(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._searcher = new Searcher(gtdinboxPage);
	this.contacts = [];
	this.contactsHash = {};
}

/*
CloseContacts.prototype.processContacts = function(threadList, contacts, fCallback){
	// If threadList, extract all contacts within it
	// Create a search of all messages sent to each contact (by me)
	// Parse the results into a bucket, and order by volume

try{
	if( threadList ){	// Load contacts from the thread list
		contacts = [];
		for( var i = 0; i < threadList._threads.length; i++ ){
			var thread = threadList._threads[i];
			var names = thread.getNames(null,true);
			for( var j = 0; j < names.length; j++ ){
				contacts.push( names[j][1] || names[j][0] );
			}
		}
	}
	
	var query = "(";
	for( var i = 0; i < contacts.length; i++ ){
		if( i > 0) query += " OR ";
		query += "to:" + contacts[i];
	}
	query += ") -is:chat";
	
	
	this.contacts.length = 0;
	this._searcher.search( query, GIPROTOTYPE.bind(this, function(tL){	// Parse the results into buckets
			this._searcher.renderThreadListByType("Contact", tL, null, null, null, GIPROTOTYPE.bind(this, function(type, length, buckets){ // Order the bucket by volume
					try{

						var rank = [];
						var rankHash = {};
						for( b in buckets ){
							var id = GIPROTOTYPE.padZero(buckets[b].seen, 5) + buckets[b].name;
							rank.push(id);
							rankHash[id] = buckets[b];
						}
						rank.sort().reverse();
						var contactList = [];
						for( var i = 0; i < rank.length; i++ ){
							var bucket = rankHash[rank[i]];
							if( bucket.seen > 10 ){
								bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-2.png";
							}else if( bucket.seen > 0 ){
								bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-1.png";
							}else{
								bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-0.png";
							}
							bucket.closenessTooltip = bucket.seen + " " + this._gtdinboxPage.stringBundle.getString("CloseContacts.SentEmails") + " " + bucket.displayName;
							contactList.push( bucket );
						}
						this.contacts = contactList;
						this.contactsHash = buckets;
						if( fCallback ) fCallback(contactList, buckets);
					}catch(e){
						if( GTDDEBUGMODE ) alert("CloseContacts processContacts renderThreadListByType-callback\n" + e.toString());
					}
				}));
		}));

}catch(e){
	if( GTDDEBUGMODE ) alert( "CloseContacts processContacts\n" + e.toString() );
}
};
*/

CloseContacts.prototype.processContacts = function(threadList, contacts, fCallback){
	// If threadList, extract all contacts within it
	// Create a search of all messages sent to each contact (by me)
	// Parse the results into a bucket, and order by volume

try{
	if( threadList ){	// Load contacts from the thread list
		contacts = [];
		for( var i = 0; i < threadList._threads.length; i++ ){
			var thread = threadList._threads[i];
			var names = thread.getNames(null,true);
			for( var j = 0; j < names.length; j++ ){
				contacts.push( names[j][1] || names[j][0] );
			}
		}
	}
	
	var countSearches = 0;
	var countSearched = 0;
	var searchToContactHash = {};
	var buckets = {};
	var seenContacts = {};
	
	for( var i = 0; i < contacts.length; i++ ){
		if( !seenContacts[contacts[i]] ){	
			seenContacts[contacts[i]] = true;
			var search = "to:" + contacts[i] + " -is:chat";
			searchToContactHash[search] = contacts[i];
			countSearches++;
			this._searcher.getNumberResults( search, GIPROTOTYPE.bind(this, function(searched, count){
					var contact = searchToContactHash[searched];
					var bucket = {seen:count, name:contact, displayName:contact};
					if( bucket.seen > 10 ){
						bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-2.png";
					}else if( bucket.seen > 0 ){
						bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-1.png";
					}else{
						bucket.closenessImgSrc = "chrome://gtdinbox/content/close-contact-0.png";
					}
					bucket.closenessTooltip = bucket.seen + " " + this._gtdinboxPage.stringBundle.getString("CloseContacts.SentEmails") + " " + bucket.displayName;
					buckets[contact] = bucket;
									
					
					if( ++countSearched>=countSearches ){	// all done
						// Sort the list into an array. Return the results.
						var rank = [];
						var rankHash = {};
						for( b in buckets ){
							var id = GIPROTOTYPE.padZero(buckets[b].seen, 5) + buckets[b].name;
							rank.push(id);
							rankHash[id] = buckets[b];
						}
						rank.sort().reverse();
						var contactList = [];
						for( var j = 0; j < rank.length; j++ ){
							contactList.push( rankHash[rank[j]] );
						}
						this.contacts = contactList;
						this.contactsHash = buckets;
						if( fCallback ) fCallback( contactList, buckets );
					}				
				}));
		}
	}


}catch(e){
	if( GTDDEBUGMODE ) alert( "CloseContacts processContacts\n" + e.toString() );
}
};

CloseContacts.prototype.mergeBuckets = function(realBuckets, closenessBuckets){
	for( b in closenessBuckets ){
		if( realBuckets[b] ){
			realBuckets[b].closeness = closenessBuckets[b].seen;
			realBuckets[b].closenessImgSrc = closenessBuckets[b].closenessImgSrc;
			realBuckets[b].closenessTooltip = closenessBuckets[b].closenessTooltip;
		}
	}
	return realBuckets;
};

CloseContacts.prototype.getZeroClosenessImg = function(){
	return "chrome://gtdinbox/content/close-contact-0.png";
};

CloseContacts.prototype.destroy = function(){
	if( !this._gtdinboxPage ) return;
	
	this._gtdinboxPage = null;
	this._searcher.destroy();
	this._searcher = null;
};