/* Copyright Andy Mitchell 2007. No warranties */

function ConversationUI(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = gtdinboxPage._labels;
	this._multiToOne = new MultiToOne(gtdinboxPage, 300);
	
	this._eventObservers = new GtdEventObservers(this);
	
	this._gtdinboxPage._moreActionsMenu.addEventHandler( this, "actionlist-manual-click", this.manualThreadLabelChange );
	//this._labels.addEventHandler( this, "refresh-labels", this.refreshLabels );
	
	this.threadListCustomUIs = [];
	
	this._searcher = new Searcher(gtdinboxPage);
}

ConversationUI.prototype.viewChange = function(gmail, callback){

try{
	// Make sure we're still embedded
	
	
	var doc = this._gtdinboxPage.gmailDOM.element("document", gmail);
	

	var match = this._doc.defaultView.top.location.href.match(/\/(#inbox|#search|#sent)(\/.+)?\/(.+)$/);
	var id = match? match[match.length-1] : "";

	this._threadActions = new ThreadActionsUI(this._gtdinboxPage);
	
	if( !this._gtdinboxPage.settings.ui.hide.finishButton ){
		// Add in the Finish button
		var fAddArchive = GIPROTOTYPE.bind(this, function(elArchive){
				if( elArchive ){
					var elFinish = this._threadActions.getFinishedButton();
					elFinish.className = elArchive.className;
					elArchive.parentNode.insertBefore( elFinish, elArchive.nextSibling );
					//elArchive.innerHTML = elArchive.innerHTML.replace(/<[^>]+>/g, "");	// Strip bold
				}
			});
		fAddArchive(this._gtdinboxPage.gmailDOM.element("archive-button"));
		fAddArchive(this._gtdinboxPage.gmailDOM.element("archive-button-footer"));
	}
	
	
	this._gtdinboxPage._threadList.getThreadById(id, GIPROTOTYPE.bind(this, function(thread){
			if( thread ){
				this.refresh(thread);
			}else{
				thread = new Thread(this._gtdinboxPage._threadList, id);
				var elSubject = this._gtdinboxPage.gmailDOM.element("conversation-subject");
				thread.subject = elSubject.innerHTML;
				this._gtdinboxPage._threadList.addThread(thread, true);
				this._gtdinboxPage._moreActionsMenu.getActiveLabels(this, GIPROTOTYPE.bind(this, function(activeLabels){
						thread.verifyLabels(activeLabels);
						this.refresh(thread);
					}));
			}
		}));
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationDeleteMoveNext ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-deletemovenext", this._gtdinboxPage.stringBundle.getString("Conversation.DeleteMoveNext"), this._gtdinboxPage.stringBundle.getString("Conversation.DeleteMoveNext.Tooltip"), GIPROTOTYPE.bind(this, this.deleteMoveNext) );
	if( !this._gtdinboxPage.settings.ui.hide.conversationBump ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-bump", this._gtdinboxPage.stringBundle.getString("Conversation.Bump"), this._gtdinboxPage.stringBundle.getString("Conversation.Bump.Tooltip"), GIPROTOTYPE.bind(this, this.bump) );
	if( !this._gtdinboxPage.settings.ui.hide.removeAllLabels ) this._gtdinboxPage._moreActionsMenu.addCustomEntry("cv-removealllabels", this._gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels"), this._gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels.Tooltip"), GIPROTOTYPE.bind(this, function(){

			try{
				var labelled = {count:0};
				var fOnDone = GIPROTOTYPE.bind(this, function(){
					if( labelled.found ){	// Refresh view since may have removed labels
						setTimeout( GIPROTOTYPE.bind(this._gtdinboxPage.gmailDOM, this._gtdinboxPage.gmailDOM.refreshView), 300 );
					}
				});
					
				this.thread.refreshData( GIPROTOTYPE.bind( this, function(){						
					try{
						var thread = this._gtdinboxPage._threadList._threadsHashId[this.thread.id];
						thread.removeLabel( GIPROTOTYPE.clone(thread.labels), fOnDone, "ajax" );
						
					}catch(e){
						if( GTDDEBUGMODE ) alert("conversationui viewChange removeAllLabels callback\n" + e.toString());
					}
				}) );
				
			}catch(e){
				if( GTDDEBUGMODE ) alert("conversationui viewChange removeAllLabels\n" + e.toString());
			}
		}));
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui viewChange\n" + e.toString());
}

};
	
ConversationUI.prototype.refresh = function(thread){
try{
	

	
	
	this.thread = thread;
	
	this.thread.initEventHandler();
	this.thread.eventHandlers.reset();	// get it exclusively for us
	
	this._gtdinboxPage._recentItems.addThread(this.thread);
	
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationLabels ){
		// Label Selection Header
		if( this.elH1 ){
			this._listenHeaderEvents(false);
		}
		this.elH1 = this._gtdinboxPage.gmailDOM.element("conversation-header");
		if( !this.elH1 ) return;
		//this._listenHeaderEvents(true);
		
		var elHeader = this.elH1.parentNode;
		if( elHeader.getElementsByTagName("DIV")[0] && elHeader.getElementsByTagName("DIV")[0].className.indexOf("conversation-header")>-1 ){	// already modified
			return;
		}
		
		var elConversationHeader = this._doc.createElement("DIV");
			elConversationHeader.className = "conversation-header";
		elHeader.appendChild( elConversationHeader );
		
		if( !this._labelSelect ){
			this._threadActions.refresh(this.thread);
			this._labelSelect = new LabelSelectUI( this._gtdinboxPage, null, null, this._threadActions ); 
			this._labelSelect.addEventHandler(this, "click-label", this.toggleLabel);

		}
		elConversationHeader.appendChild( this._labelSelect.el );
	}
	
	
	// Detect clicks to conversation
	if( this._elConversation ){
		this._eventObservers.stopObserving( this._elConversation, "click", this._clickConversation, false );
	}
	this._elConversation = this._gtdinboxPage.gmailDOM.element("ActiveViewElement");
	this._eventObservers.observe( this._elConversation, "click", this._clickConversation, false );
	
	
	
	
	// Add in Related Items
	if( GTDDEVMODE ){
		if( !this.elRelated ){
			this.elRelated = this._doc.createElement("DIV");
				this.elRelated.className = "conversation-related";
				this.elRelated.innerHTML = "<h3>" + this._gtdinboxPage.stringBundle.getString("Conversation.Related") + "</h3>";
			
			var elEmailsByAuthor = this._doc.createElement("DIV");
			this.showHiderEmailsByAuthor = new Showhider(this._gtdinboxPage, "conversation-emails-by-author", {doc: this._doc, 'elParent':this.elRelated, 'title':this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor"), 'elContent': elEmailsByAuthor, 'overrideShow':false});
			var elTasksByProject = this._doc.createElement("DIV");
			this.showHiderTasksByProject = new Showhider(this._gtdinboxPage, "conversation-tasks-by-project", {doc: this._doc, 'elParent':this.elRelated, 'title':this._gtdinboxPage.stringBundle.getString("Conversation.Related.TasksByProject"), 'elContent': elTasksByProject, 'overrideShow':false});		
			
			this.showHiderEmailsByAuthor.elNumberTasks = this._doc.createElement("SPAN");
				this.showHiderEmailsByAuthor.elNumberTasks.setAttribute("show-number-results", "1");
			this.showHiderEmailsByAuthor.elNumberOthers = this._doc.createElement("SPAN");
				this.showHiderEmailsByAuthor.elNumberOthers.setAttribute("show-number-results", "1");
			this.showHiderEmailsByAuthor.elTitleTxt.appendChild( this._doc.createTextNode(" (") );
			this.showHiderEmailsByAuthor.elTitleTxt.appendChild( this.showHiderEmailsByAuthor.elNumberTasks );
			this.showHiderEmailsByAuthor.elTitleTxt.appendChild( this._doc.createTextNode( " " + this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor.Tasks.HeaderSuffix") + ", ") );
			this.showHiderEmailsByAuthor.elTitleTxt.appendChild( this.showHiderEmailsByAuthor.elNumberOthers );
			this.showHiderEmailsByAuthor.elTitleTxt.appendChild( this._doc.createTextNode(" " + this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor.Others.HeaderSuffix") + ")") );
			this.showHiderTasksByProject.elNumberTasks = this._doc.createElement("SPAN");
				this.showHiderTasksByProject.elNumberTasks.setAttribute("show-number-results", "1");
			this.showHiderTasksByProject.elTitleTxt.appendChild( this._doc.createTextNode(" (") );
			this.showHiderTasksByProject.elTitleTxt.appendChild( this.showHiderTasksByProject.elNumberTasks );
			this.showHiderTasksByProject.elTitleTxt.appendChild( this._doc.createTextNode(")") );
			
			
			this.showHiderEmailsByAuthor.addEventHandler(this, "show", this.showShowHiderRelated);
			this.showHiderTasksByProject.addEventHandler(this, "show", this.showShowHiderRelated);
		}
		elRepliesFooter = this._gtdinboxPage.gmailDOM.element("conversation-below-reply");
		if( elRepliesFooter ) elRepliesFooter.appendChild( this.elRelated );
		this.refreshRelated();
	}
	
	
	if( !this._gtdinboxPage.settings.ui.hide.conversationReply ){
		// Hook up Reply to Self
		this.integrateReplyRows();
	}
	
	
	
	if( this.elConversationMessages ){
		this._listenMessageEvents(false);
	}
	
	this.elConversationMessages = this._gtdinboxPage.gmailDOM.element("conversation-messages");
	this._listenMessageEvents(true);
	
	this.refreshLabels();
	

	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui refresh\n" + e.toString());
}
};

ConversationUI.prototype.getRelatedSearch = function(type){
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var statuses = this._gtdinboxPage.settings.labels.types.Statuses.defaults;
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;

	
	var queryAuthors = "";
	var queryStatuses = "";
	var queryNoStatuses = "";
	if( type.indexOf("emails")==0 ){
		var names = this.thread.getNames(null, true);
		var emails = [];
		for( var i = 0; i < names.length; i++ ) emails.push(names[i][1]);
		queryAuthors = GIPROTOTYPE.restrictSearchToUser(emails, "OR");
	}
	queryStatuses += "(";
	queryNoStatuses += "(";
	for( d in statuses ){
		if( d!="Finished" ){
			queryStatuses += " " + GIPROTOTYPE.searchableLabel(statusPrefix + statuses[d]) + " OR ";
			queryNoStatuses += " -" + GIPROTOTYPE.searchableLabel(statusPrefix + statuses[d]) + " AND ";
		}
	}
	queryStatuses = queryStatuses.replace(/ OR $/, ") -" + GIPROTOTYPE.searchableLabel( statusPrefix + statuses.Finished ) );
	queryNoStatuses = queryNoStatuses.replace(/ AND $/, ")" );

	switch(type){
		case "emails-by-author-tasks":
			return (queryAuthors + " " + queryStatuses);
			break;
		case "emails-by-author-tasks-owed":
			var waitingOn = GIPROTOTYPE.searchableLabel(statusPrefix + statuses.WaitingOn);
			return (queryAuthors + " " + queryStatuses).replace( waitingOn, "");
		case "emails-by-author-tasks-delegated":
			var waitingOn = GIPROTOTYPE.searchableLabel(statusPrefix + statuses.WaitingOn);
			return (queryAuthors + " " + waitingOn);
		case "emails-by-author-others":
			return (queryAuthors + " " + queryNoStatuses + " -is:chat");
			break;
		case "emails-by-author":
			return queryAuthors + " -is:chat";
			break;
		case "tasks-by-project":
			var projectLabels = "";
			for( var i = 0; i < this.thread.labels.length; i++ ){
				if( this.thread.labels[i].indexOf(projectPrefix)==0 ) projectLabels += GIPROTOTYPE.searchableLabel(this.thread.labels[i]) + " OR ";
			}
			if( projectLabels ){
				projectLabels = projectLabels.replace(/ OR $/, "");
				projectLabels += " " + queryStatuses;
				return projectLabels;
			}else{
				return "";
			}
			break;
	}
};
ConversationUI.prototype.refreshRelated = function(){
// Clear out existing
	if( !GTDDEVMODE ) return;
	
	for( var i = 0; i < this.threadListCustomUIs.length; i++ ){
		this.threadListCustomUIs[i].destroy();
	}
	this.threadListCustomUIs.length = 0;
	this.showHiderEmailsByAuthor.show(false);
	this.showHiderTasksByProject.show(false);
	this.elRelated.style.display = "none";
	this.showHiderEmailsByAuthor.el.style.display = "none";
	this.showHiderTasksByProject.el.style.display = "none";
	this.showHiderEmailsByAuthor.elContent.innerHTML = "";
	this.showHiderTasksByProject.elContent.innerHTML = "";
	
	var related = {known:0, count:0};
	
	
	var queryEmailsByAuthorTasks = this.getRelatedSearch("emails-by-author-tasks");
	var queryEmailsByAuthor = this.getRelatedSearch("emails-by-author");
	var queryTasksByProject = this.getRelatedSearch("tasks-by-project");
	
	this.showHiderEmailsByAuthor.elNumberTasks.setAttribute("gtdSearch", queryEmailsByAuthorTasks );
	this.showHiderEmailsByAuthor.elNumberOthers.setAttribute("gtdSearch", queryEmailsByAuthor );
	this.showHiderTasksByProject.elNumberTasks.setAttribute("gtdSearch", queryTasksByProject );
	if( queryEmailsByAuthorTasks ) related.known++;
	if( queryEmailsByAuthor ) related.known++;
	if( queryTasksByProject ) related.known++;
	
	
	this._searcher.showNumberResultsForEl(this.elRelated, GIPROTOTYPE.bind(this, function(el, count){
			if( count>0 && el.parentNode==this.showHiderEmailsByAuthor.elTitleTxt ) count--;	// it's email and will include this msg
			if( count>0 ){
				while( el.parentNode && !GIPROTOTYPE.hasClassName(el, "showhider") ){
					el = el.parentNode;
				}
				if( GIPROTOTYPE.hasClassName(el, "showhider") ) el.style.display = "";
			}
			related.known--;
			related.count += count;
			if( related.known==0 && related.count>0 ){
				this.elRelated.style.display = "";
			}
		}), true);
		
};
ConversationUI.prototype.showShowHiderRelated = function(showHider){
	// Figure out which show hider it is
	// If emailsbyauthor, load all email threads and partition into Tasks and Others
	// If tasksbyproject, partition into buckets according to the most number of project labels on a thread
try{
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;	
	var statuses = this._gtdinboxPage.settings.labels.types.Statuses.defaults;
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;
	
	
	showHider.elContent.innerHTML = "<img src='chrome://gtdinbox/skin/indicator_medium.gif' class='loading' />";
	
	var fRender = GIPROTOTYPE.bind(this, function(threadList, threads, title){
			try{
					if( threadList._threads.length > 0 ){
						var imgs = showHider.elContent.getElementsByTagName("IMG");
						if( imgs && imgs.length > 0 && imgs[0].className=="loading" ) showHider.elContent.innerHTML = "";
										
						var elTitle = this._doc.createElement("DIV");
							elTitle.className = "title";
							elTitle.innerHTML = title;
						var threadListCustomUI = new ThreadListCustomUI(this._gtdinboxPage);
						threadListCustomUI.load( threadList, threads );
						showHider.elContent.appendChild( elTitle );
						showHider.elContent.appendChild( threadListCustomUI.el );
						this.threadListCustomUIs.push( threadListCustomUI );
					}
					
			}catch(e){
				if( GTDDEBUGMODE ) alert( "ConversationUI showShowHiderRelated fRender\n" + e.toString());
			}
		});
	
	switch( showHider._id ){
		case "conversation-emails-by-author":
			
			
			// Get the waiting on
			this._searcher.search( this.getRelatedSearch("emails-by-author-tasks-delegated"), GIPROTOTYPE.bind(this, function(threadList){
					fRender(threadList, null, this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor.Tasks.Delegated") );
				}));
			
			// Get the tasks		
			this._searcher.search( this.getRelatedSearch("emails-by-author-tasks-owed"), GIPROTOTYPE.bind(this, function(threadList){
					fRender(threadList, null, this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor.Tasks.Owe") );
				}));
				
				
			var queryEmailsByAuthorOthers = this.getRelatedSearch("emails-by-author-others");
			this._searcher.getNumberResults( queryEmailsByAuthorOthers, GIPROTOTYPE.bind(this, function(query, count){
				try{
					if( count>20 ){	// Too many, restrict by date
						var d = new Date( (new Date()).valueOf()-(90*(1000*60*60*24)) );
						queryEmailsByAuthorOthers += " after:" + d.getFullYear() + "/" + (d.getMonth() + 1) + "/" + d.getDate();
					}
					
					this._searcher.search( queryEmailsByAuthorOthers, GIPROTOTYPE.bind(this, function(threadList){
							fRender(threadList, null, this._gtdinboxPage.stringBundle.getString("Conversation.Related.EmailsByAuthor.Others") );						
						}));
				}catch(e){
					if( GTDDEBUGMODE ) alert( "ConversationUI showShowHiderRelated emailsbyauthor-others-count-callback\n" + e.toString());
				}
				}))
			
			break;
		case "conversation-tasks-by-project":
			this._searcher.search( this.getRelatedSearch("tasks-by-project"), GIPROTOTYPE.bind(this, function(threadList){
				showHider.elContent.innerHTML = "";
				try{
					var buckets = [];	// [{threads:[],projects:{}, projectCount:0}]
					var bucketRank = [];
					var bucketRankHash = {};
					
					for( var i = 0; i < threadList._threads.length; i++ ){
						var thread = threadList._threads[i];
						var bucket = null;
						var threadProjects = [];
						for( var j = 0; j < thread.labels.length; j++ ){
							if( thread.labels[j].indexOf(projectPrefix)==0 ){
								threadProjects.push( thread.labels[j] );
							}
						}
						for( var j = 0; j < buckets.length; j++ ){	// Look for project label matches:
							var innerMatch = true;
							for( var k = 0; k < threadProjects.length; k++ ){
								if( !buckets[j].projects[threadProjects[k]] ){
									innerMatch = false;
									break;
								}
								
							}
							if( innerMatch && threadProjects.length!=buckets[j].projectCount ){	// Still in, confirm not more projects on bucket than thread
								innerMatch = false;
							}
							if( innerMatch ){
								bucket = buckets[j];
								break;
							}
						}
						if( bucket ){
							bucket.threads.push(thread);
						}else{
							bucket = {threads:[thread], projects:{}, projectList: threadProjects, projectCount:threadProjects.length};
							for( var j = 0; j < threadProjects.length; j++ ) bucket.projects[ threadProjects[j] ] = true;
							buckets.push(bucket);
							var id = GIPROTOTYPE.padZero( threadProjects.length, 5 ) + threadProjects.join("");
							bucketRank.push(id);
							bucketRankHash[id] = bucket;
						}
					}
					
					// Now sort by #projects
					bucketRank.sort().reverse();
					
					for( var i = 0; i < bucketRank.length; i++ ){
						var bucket = bucketRankHash[bucketRank[i]];
						fRender( threadList, bucket.threads, bucket.projectList.join(", ") );
					}
					
				}catch(e){
					if( GTDDEBUGMODE ) alert( "ConversationUI showShowHiderRelated conversation-tasks-by-project-callback\n" + e.toString());
				}
				}));
			break;
	}

}catch(e){
	if( GTDDEBUGMODE ) alert( "ConversationUI showShowHiderRelated\n" + e.toString());
}
	
};

ConversationUI.prototype.integrateReplyRows = function(){
	// Integrate ReplyToSelf into visible rows
	
	var listening = this._listenMessageEvents();
	if( listening ) this._listenMessageEvents(false);
	var elRows = this._gtdinboxPage.gmailDOM.elements("conversation-reply-rows");
	for( var i = 0; i < elRows.snapshotLength; i++ ){
		var elRow = elRows.snapshotItem(i);
		var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow);
		if( row ){
			if( !row.elReplyToSelf ){
				/*
				// NO BUMP BECAUSE IT BRINGS IT BACK INTO INBOX -> UNNECESSARY CRUTCH
				if( i==elRows.snapshotLength-1 ){
					var elBump = this._doc.createElement("BUTTON");
						elBump.className = "gtd-bump";
						elBump.innerHTML = this._gtdinboxPage.stringBundle.getString("Conversation.Bump");
					row.elForward.parentNode.insertBefore(elBump, row.elForward.nextSibling);
				}
				*/
				this._eventObservers.observe(elRow, "mouseup", this._clickReplyRow, false);
				var elReplyToSelf = this._doc.createElement("TD");
				elReplyToSelf.innerHTML = "<div class='reply-to-self'><img name='reply-to-self' class='eChx3e INkyme' src='images/cleardot.gif' /><span name='reply-to-self'>" + this._gtdinboxPage.stringBundle.getString("Conversation.ReplyToSelf") + "</span></div>";
				row.elForward.parentNode.insertBefore(elReplyToSelf, row.elForward.nextSibling);
			}else if( !row.elTable ){	// Ensure it isn't highlighted
				row.elReplyToSelf.className = "";
			}
		}
	}
	if( listening ) this._listenMessageEvents(true);
	
	if( GTDDEVMODE ){
		// Take advantage of message refresh to move the related items down:
		elRepliesFooter = this._gtdinboxPage.gmailDOM.element("conversation-below-reply");
		if( elRepliesFooter ) elRepliesFooter.appendChild( this.elRelated );
	}
};

ConversationUI.prototype._listenMessageEvents = function(v){
	
	if( typeof v=="undefined" ){
		return this._listeningMessageEvents;
	}
	if( v ){
		this._eventObservers.observe( this.elConversationMessages, "DOMNodeInserted", this._modifyMessages, false );
		this._eventObservers.observe( this.elConversationMessages, "DOMNodeRemoved", this._modifyMessages, false );
	}else{
		this._eventObservers.stopObserving( this.elConversationMessages, "DOMNodeInserted", this._modifyMessages, false );
		this._eventObservers.stopObserving( this.elConversationMessages, "DOMNodeRemoved", this._modifyMessages, false );
	}
	this._listeningMessageEvents = v;
	
};
ConversationUI.prototype._listenHeaderEvents = function(v){
	
	if( typeof v=="undefined" ){
		return this._listeningHeaderEvents;
	}
	if( v ){
		this._eventObservers.observe( this.elH1, "click", this._clickHeader, false );
		this._eventObservers.observe( this.elH1, "DOMNodeInserted", this._modifyHeader, false );
		this._eventObservers.observe( this.elH1, "DOMNodeRemoved", this._modifyHeader, false );
	}else{
		this._eventObservers.stopObserving( this.elH1, "click", this._clickHeader, false );
		this._eventObservers.stopObserving( this.elH1, "DOMNodeInserted", this._modifyHeader, false );
		this._eventObservers.stopObserving( this.elH1, "DOMNodeRemoved", this._modifyHeader, false );
	}
	this._listeningHeaderEvents = v;
	
};

ConversationUI.prototype._modifyMessages = function(){
	this._multiToOne.process("modifyMessages", GIPROTOTYPE.bind(this, this.integrateReplyRows));
};

ConversationUI.prototype._modifyHeader = function(event){
	this._multiToOne.process("modifyHeader", GIPROTOTYPE.bind(this, this.refreshLabels));
};
ConversationUI.prototype._clickHeader = function(event){
	var el = GIPROTOTYPE.element(event);
	
	if( this._gtdinboxPage.gmailDOM.test("conversation-x",el) ){	// It's a remove
		this.refreshLabels();
	}	
};

ConversationUI.prototype.deleteMoveNext = function(){
	// Method #1: Record the current ID, click 'Older', and use GmailDOM to delete the thread id
	// Method #2: Extract search from url, load threads, find next thread; click Delete here and set gmail to load next url
	
try{
	// Click delete on this one:
	
	//var elDelete = this._gtdinboxPage.gmailDOM.element("delete-button");
	//if( !elDelete ) return;
	
	
	var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
	
	
	this._searcher.searchCurrentQuery( GIPROTOTYPE.bind( this, function(threadList,query){

		// Find the current thread id, then the next one
		for( var i = 0; i < threadList._threads.length; i++ ){
			if( threadList._threads[i].id==this.thread.id ){
				if( threadList._threads[i+1] ){
					threadActionsUI._clickDelete();
					//GIPROTOTYPE.doMouseEvent(this._doc, elDelete, "click");
					
					var id = threadList._threads[i+1].id;
					setTimeout( GIPROTOTYPE.bind(this, function(){
						this._gtdinboxPage.gmailDOM.loadThread( id );
						}), 1000 );
					break;
				}
			}
		};

	}));
	

}catch(e){
	//if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("Conversation UI deleteMoveNext\n" + e.toString());
}

};

ConversationUI.prototype.bump = function(){
try{
	var lightbox = null;
	lightbox = new GtdLightbox(this._gtdinboxPage, this._gtdinboxPage.doc.body);
	lightbox.setType( "processing", {msg:(this._gtdinboxPage.stringBundle.getString("Conversation.Bumping"))} );
	lightbox.active(true);


	var elRows = this._gtdinboxPage.gmailDOM.elements("conversation-reply-rows");
	if( elRows.snapshotLength==0 ) return;
	
	var elRow = elRows.snapshotItem( elRows.snapshotLength - 1 );
	
	var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
	if( !row ) return;

	GIPROTOTYPE.doMouseEvent(this._doc, row.elReplyToClick, "click");	// expand ite
	var fFollowUp = GIPROTOTYPE.bind(this, function(row2){
			try{
				if( !row2 ) row2 = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				row2.elText.value = this._gtdinboxPage._environment.email;
				GIPROTOTYPE.doMouseEvent(this._doc, row2.elSendButton, "click");
				setTimeout( GIPROTOTYPE.bind(this, function(){
					try{
						if(lightbox) lightbox.active(false);
						var el = this._gtdinboxPage.gmailDOM.element("inbox-link");
						GIPROTOTYPE.doMouseEvent(this._doc, el, "click");	// refresh
					}catch(e){
						if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow final timeout\n" + e.toString());
					}
				}), 4000 );
			}catch(e){
				if( lightbox ) lightbox.active(false);
			}
		});
	setTimeout( GIPROTOTYPE.bind(this, function(){
			var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
			if( row.elTable ){	// Loaded Reply
				fFollowUp(row);
			}else{	// Try again
				setTimeout( fFollowUp, 400 );
			}
		}), 100);
}catch(e){
	if( typeof lightbox!="undefined" && lightbox ) lightbox.active(false);
	if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow\n" + e.toString());
}
};

ConversationUI.prototype._clickConversation = function(event){
	var el = GIPROTOTYPE.element(event);
	
	// See if star was clicked & respond
	if( this._gtdinboxPage.settings.labels.starForNextAction && this._gtdinboxPage.gmailDOM.test("star", el) ){	// It's a star
		// Test to see if star is on/off and respond
		
		
		
		var settings = this._gtdinboxPage.settings;
		var labelNextAction = settings.labels.types.Statuses.prefix + settings.labels.types.Statuses.defaults.NextAction;
		if( this._gtdinboxPage.gmailDOM.test("star-on", el) ){	// its on, add label
			this.thread.addLabel(labelNextAction, null, "moreActions");
			//this._gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':true, 'threads':this.thread});
		}else{	// Off, make sure it's off
			this.thread.removeLabel(labelNextAction, null, "moreActions");
			//this._gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':false, 'threads':this.thread});
		}
	}

};

ConversationUI.prototype._clickReplyRow = function(event){
try{
	var el = GIPROTOTYPE.element(event);
	var elRow = el;
	while( elRow.parentNode && elRow.nodeName!="TR" ) elRow = elRow.parentNode;
	if( elRow.nodeName!="TR" ) return;
	
	var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
	if( !row ) return;

	if( el.getAttribute("name")=="reply-to-self" ){	// Clicked Reply to Self
		// Click Reply to setup the row correctly
		// Uncolour the other tabs
		// Hide From/To
		GIPROTOTYPE.doMouseEvent(this._doc, row.elReplyToClick, "click");	// refresh
		var fFollowUp = GIPROTOTYPE.bind(this, function(row2){
				if( !row2 ) row2 = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				row2.elReply.className = "";	// Remove colouration
				row2.elReplyToSelf.className = "reply-to-self-selected";
				row2.elFrom.style.display = "none";
				//row2.elTo.style.display = "none";
				this._lastEmailAddress = row2.elText.value;
				row2.elText.value = this._gtdinboxPage._environment.email.replace("@", "+action@");
			});
		setTimeout( GIPROTOTYPE.bind(this, function(){
				var row = this._gtdinboxPage.gmailDOM.parseElement("conversation-reply-row", elRow );
				if( row.elTable ){	// Loaded Reply
					fFollowUp(row);
				}else{	// Try again
					setTimeout( fFollowUp, 400 );
				}
			}), 100);
	}else if( this._gtdinboxPage.gmailDOM.test("conversation-reply-clicked-item", el) ){ // Clicked Reply or Forward
		// Uncolour ReplyToSelf tab
		// Show From/To
		row.elReplyToSelf.className = "";
		if( row.elTable ){
			row.elFrom.style.display = "";
			//row.elTo.style.display = "";
			if( this._lastEmailAddres ) row.elText.value = this._lastEmailAddress;
		}
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("Conversation UI clickReplyRow\n" + e.toString());
}
};

ConversationUI.prototype.refreshLabels = function(){

try{
	
	var listening = this._listenHeaderEvents();
	if( listening ) this._listenHeaderEvents(false);
	
	
	this._gtdinboxPage._threadListUI.uncheckOutOfView();
	
	this.thread.refreshData(GIPROTOTYPE.bind(this, function(){
		if( this._labelSelect ) this._labelSelect.refresh(this.thread);
		this.refreshRelated();
	}), "moreActions");
	
	
	if( listening ) this._listenHeaderEvents(true);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversation ui refreshLabels\n" + e.toString());
}

};

/*
ConversationUI.prototype.threadUpdate = function(){	
try{
	this.thread.verifyLabels( this._labels.getActiveLabels() );
	if( this._gtdinboxPage.view("view")!="cv" ) return;
	this._labelSelect.refresh(this.thread);
	this._labelSelect.newLabels( this.thread.getUnknownBodyLabels() );
}catch(e){
	if( GTDDEBUGMODE ) alert("conversation ui threadUpdate\n" + e.toString());
}
};
*/
ConversationUI.prototype.manualThreadLabelChange = function(event, label){
	// Called when user manually selects label on drop down
	// Kept seperate from Labels because ThreadList/Conversation would handle it differently

try{
	if( this._gtdinboxPage.view("view")!="cv" ) return;	// i should be active view
	
	if( this.thread ){
		if( label.act=="12" ){
			var callback = null;
			if( label.label==(this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished) ){	// clicked finish, archive it
				callback = GIPROTOTYPE.bind(this, function(){
						var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
						threadActionsUI._clickArchive();
					});
			}
			this.thread.addLabel(label.label, callback, null, true);
		}else if(label.act=="13"){
			this.thread.removeLabel(label.label, null, null, true);
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("ConversationUI manualThreadLabelChange\n" + e.toString());
}
};

ConversationUI.prototype.toggleLabel = function(e, label){
try{
	var labelname = label.labelname;
	
	if( this.thread.hasLabel( labelname ) ){
		this.thread.removeLabel( labelname, null, "moreActions" );
	}else{
		var fComplete = GIPROTOTYPE.bind(this, function(){
			if( label.doubleClick || (labelname==(this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished)) ){	// clicked finish, archive it
				var threadActionsUI = new ThreadActionsUI(this._gtdinboxPage, null, true);
				threadActionsUI._clickArchive();
			}
		});
		this.thread.addLabel( labelname, fComplete, "moreActions" );
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("conversationui toggleLabel\n" + e.toString());
}
};

ConversationUI.prototype.destroy = function(){
	if( this._labelSelect ) this._labelSelect.destroy();
	if( this._showHiderLabels) this._showHiderLabels.destroy();
	this._multiToOne.destroy();

	this._eventObservers.destroy();
	
	this.elH1 = null;
	this.thread = null;
	this._labels = null;
	this._doc = null;
	this._gtdinboxPage = null;
}