function Dashboard4(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	this._eventObservers = new GtdEventObservers(this);
	this._showHiders = {};
	
	this._buckets = {};
	this._searcher = new Searcher(this._gtdinboxPage);
	this._closeContacts = new CloseContacts(gtdinboxPage);
	this._threadListCustomUIs = []
	
try{
	
	this.el = this._doc.createElement("DIV");
		this.el.className = "dashboard";
	
	this._dashboardContexts = new DashboardContexts(this._gtdinboxPage, this.el);
	this._dashboardContexts.addEventHandler(this, "change-context", this._changeContext);
	
	this.elCombos = this._doc.createElement("DIV");
		this.elCombos.className = "combos";
	this.el.appendChild( this.elCombos );
	
	this.createCombo("Tasks");
	this.createCombo("Projects");
	this.createCombo("Contact");
	this.createCombo("Reviews");
	this.createCombo("Recent");
	var showHiderMore = this.createCombo("MoreCmds");
	GIPROTOTYPE.addClassName( showHiderMore.elContent, "more-cmds" );
	
	
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	this.elCombos.appendChild(elClear);
	
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	this.el.appendChild(elClear);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard4 create\n" + e.toString());
}
}
Dashboard4.prototype.createCombo = function(name){
try{
	// Create a showhider, look up the title from the stringbundle, and store it in the showhiders collection
	var elContent = this._doc.createElement("DIV");
	var showHider = new ShowhiderCombo(this._gtdinboxPage, "Dashboard." + name, {title:this._gtdinboxPage.stringBundle.getString("Dashboard." + name), 'elContent':elContent, 'elParent':this.elCombos});
	showHider.addEventHandler(this, "show", this._showShowHider);
	
	this._eventObservers.observe(elContent, "click", this._clickShowHiderContent, false );
	
	showHider.name = name;
	this._showHiders[name] = showHider;
		
	return showHider;
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard4 createCombo\n" + e.toString());
}
};


Dashboard4.prototype.viewChange = function(gmail){
	// Ensure the Dashboard is integrated into this view
try{
	if( this._gtdinboxPage.view("view")!="tl" && this._gtdinboxPage.view("view")!="cv" ) return;
	
	var elHeader = this._gtdinboxPage.gmailDOM.element("actions-header");
	for( var i = 0; i < elHeader.childNodes.length; i++ ){
		if( GIPROTOTYPE.hasClassName(elHeader.childNodes[i], "dashboard") ) return;	// Already in
	}
	
	elHeader.insertBefore( this.el, elHeader.firstChild );
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard4 viewChange\n" + e.toString());
}
};

Dashboard4.prototype._changeContext = function(){
	// Hide all combos
	for( name in this._showHiders ) this._showHiders[name]._show(false);
};

















Dashboard4.prototype._showShowHider = function(showHider){
	// Refresh the view for this show hider
	
try{
	// Hide all the others
	for( name in this._showHiders ) if( this._showHiders[name]!=showHider && this._showHiders[name]._show() ) this._showHiders[name]._show(false);

	var status = this._gtdinboxPage.getStatusData();
	
	/*
	var statusPrefix = this._gtdinboxPage.settings.labels.types.Statuses.prefix;
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;
	
	var statusFinished = this._gtdinboxPage.settings.labels.types.Statuses.prefix + this._gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;
	*/
	
	showHider.elContent.innerHTML = "";
	

	var fCallback = GIPROTOTYPE.bind(this, function(type, count, buckets){
			this._buckets[type] = buckets;
		});
	
	switch(showHider.name){
		case "Tasks":
			var parentSearch = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " ";
			showHider.elContent.innerHTML = "";
			var statusLabels = this._labels.getLabelsArray("Statuses");
			var statusStr = parentSearch;
			for( var i = 0; i < statusLabels.length; i++ ) if(statusLabels[i]!=status.Finished && statusLabels[i]!=status.SomeDay) statusStr += ((i>0)? " OR ":"") + GIPROTOTYPE.searchableLabel(statusLabels[i]);
			statusStr += " -" + GIPROTOTYPE.searchableLabel(status.Finished);
			this._addItem( "Tasks", null, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.ShowAllTasks"), null, statusStr, null, true, null, true );
			
			var labels = GIPROTOTYPE.clone(this._labels.getLabelsArray("Statuses"));	
			var settingsStatus = this._gtdinboxPage.settings.labels.types.Statuses;
			var labelSearch = "";
			for( d in settingsStatus.defaults ){ // Process defaults
				var label = settingsStatus.prefix + settingsStatus.defaults[d];
				for( var i = 0; i < labels.length; i++ ){
					if( labels[i]==label ){
						if( d!="Finished" ){
							if( d=="Action" ){
								labelSearch = "(" + GIPROTOTYPE.searchableLabel(label) + " OR " + GIPROTOTYPE.searchableLabel(status.NextAction) + ")";
							}else{
								labelSearch = GIPROTOTYPE.searchableLabel(label);
							}
							labelSearch += parentSearch + " -" + GIPROTOTYPE.searchableLabel(status.Finished);
							var title = this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks." + d) || label.replace(status.prefix, "");
							this._addItem( "Tasks", label, title, null, labelSearch, null, true, null, true );
						}
						labels.splice(i,1);
						i--;
					}
				}
			}
			for( var i = 0; i < labels.length; i++ ){	// And the rest
				var label = labels[i];
				this._addItem( "Tasks", label, label.replace(status.prefix,""), null, parentSearch + GIPROTOTYPE.searchableLabel(label) + " -" + GIPROTOTYPE.searchableLabel(status.Finished), null, true, null, true);
			}
			//this._addItem( showHider.elContent, this._gtdinboxPage.stringBundle.getString("Dashboard.Tasks.Personal"), null, parentSearch + "<gtdinbox.personalemail> " + GIPROTOTYPE.searchableLabel(status.Action) + " -" + GIPROTOTYPE.searchableLabel(status.Finished), null, true);
			
			this._searcher.showNumberResultsForEl(showHider.elContent);
			break;
		case "Projects":
			// Read all unfinished actions that also have a project
			// Process, to see which projects rank highest (appear most)
			// Also store which projects have the oldest tasks and most recent
			// Rank
			
			var query = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " -" + GIPROTOTYPE.searchableLabel(status.Finished) + " ";
			query += status.orQuery;
			query += " (";
			var labels = this._labels.getLabelsArray("Projects");
			for( var i = 0; i < labels.length; i++ ) query += GIPROTOTYPE.searchableLabel(labels[i]) + " OR ";
			query = query.replace(/ OR $/,")");
						
			this.renderHeader(showHider.elContent, "Projects", ["recent", "name"]);
			showHider.elResults = this._doc.createElement("DIV");
				showHider.elResults.className = "results-container";
			showHider.elContent.appendChild( showHider.elResults );
			
			this._searcher.search(query, GIPROTOTYPE.bind(this, function(threadList){
					this._searcher.renderThreadListByType("Projects", threadList, "recent", GIPROTOTYPE.bind(this, this._addTitle), GIPROTOTYPE.bind(this, this._addItem), fCallback);
				}));
			
			//this._createShowHiderContentForRankedActionBasedLabels(showHider, "Projects", query, this._projects);
			break;
		case "Contact":
			// Read all unfinished actions
			// Process, to see which contacts rank highest (appear most)
			// Also store which contacts have the oldest tasks and most recent
			// Rank
			
			var query = GIPROTOTYPE.searchableLabel(this._dashboardContexts.context()) + " -" + GIPROTOTYPE.searchableLabel(status.Finished) + " ";
			query += status.orQuery;
			var after = new Date( (new Date()).valueOf() - (1000*60*60*24*180) );
			query += " after:" + after.getFullYear() + "/" + (after.getMonth() + 1) + "/" + after.getDate();
			
			this.renderHeader(showHider.elContent, "Contact", ["recent", "name", "closeness"]);
			showHider.elResults = this._doc.createElement("DIV");
				showHider.elResults.className = "results-container";
			showHider.elContent.appendChild( showHider.elResults );
			
			var fCallback = GIPROTOTYPE.bind(this, function(type, count, buckets){	// Load the closeness for each contact
				// Load these contacts into a closeness metric; and for each contact, update the item in the combo. 
				try{
					this._buckets[type] = buckets;
				}catch(e){
					if( GTDDEBUGMODE ) alert("Dashboard4 _showShowHider Contact CloseContact-callback\n" + e.toString());
				}
			});
			
			this._searcher.search(query, GIPROTOTYPE.bind(this, function(threadList){
					this._searcher.renderThreadListByType("Contact", threadList, "recent", GIPROTOTYPE.bind(this, this._addTitle), GIPROTOTYPE.bind(this, this._addItem), fCallback, null, null, true);
				}));
			
			//this._contacts = {};
			//this._createShowHiderContentForRankedActionBasedLabels(showHider, "Contact", query, this._contacts);
			break;
		case "Recent":
			showHider.elContent.innerHTML = "";
			var projects = this._gtdinboxPage._recentItems.projects();
			if( projects.length > 0 ){
				this._addTitle("Recent", this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.RecentProjects"));
				for( var i = 0; i < projects.length; i++ ){
					this._addItem("Recent", projects[i], projects[i].replace(this._gtdinboxPage.settings.labels.types.Projects.prefix,""), null, GIPROTOTYPE.searchableLabel(projects[i]) );
				}
			}
			
			var threads = this._gtdinboxPage._recentItems.threads();
			if( threads.length > 0 ){
				this._addTitle("Recent", this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.RecentThreads"));
				for( var i = 0; i < threads.length; i++ ){
					this._addItem("Recent", null, threads[i].subject ).setAttribute("gtdThread", threads[i].id);
				}
			}
			
			if( threads.length==0 && projects.length==0 ){
				this._addTitle("Recent", this._gtdinboxPage.stringBundle.getString("Dashboard.Recent.NoItems"));
			}

			break;
		case "Reviews":
			var knownIds = {};
	
			var reviews = this._gtdinboxPage.settings.reviews;
			if( reviews ){
				var categories = {};
				var statusDefaults = this._gtdinboxPage.settings.labels.types.Statuses.defaults;
				
				for( var i = 0; i < reviews.length; i++ ){
					var title = reviews[i].title;
					if( !title && reviews[i].titleKey ) title = this._gtdinboxPage.stringBundle.getString(reviews[i].titleKey);
					
					var category = reviews[i].category;
					if( !category && reviews[i].categoryKey ) category = this._gtdinboxPage.stringBundle.getString(reviews[i].categoryKey);
					if( !category ) category = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Misc");
					
					var search = reviews[i].search;
					// Look for variables 
					search = this._gtdinboxPage.replaceGtdVariables(search);
					
					if( title && !knownIds[reviews[i].id] ){
						if( !categories[category] )	categories[category] = this._addTitle("Reviews", category);
						categories[category] = this._addItem("Reviews", null, title, null, search, null, null, categories[category].nextSibling);
						knownIds[reviews[i].id] = true;
					}
				}		
			}
			
			/*
			// Add Modify
			this._addTitle( "Reviews", this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.Options"), true );
			var elModify = this._addItem( "Reviews", null, this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews") );
			elModify.title = this._gtdinboxPage.stringBundle.getString("Dashboard.Reviews.ModifyReviews.Tooltip");
			elModify.style.fontStyle = "italic";
			elModify.setAttribute("gtd.act", "modifyreviews");
			*/
			
			break;
		case "MoreCmds":
			this._addItem( "MoreCmds", null, this._gtdinboxPage.stringBundle.getString("Dashboard.MoreCmds.PrioritiseByContacts") ).setAttribute("gtd.act", "prioritiseByContact");
			break;
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard4 _showShowHider\n" + e.toString());
}
};

/*
Dashboard4.prototype._renderCloseContacts = function(contacts, contactsHash, showHider){
	// For each bucket in contacts, find the associated row in the combo
	
	for( var i = 0; i < contacts.length; i++ ){
		for( var j = 0; j < showHider.elResults.childNodes.length; j++ ){
			var el = showHider.elResults.childNodes[j];
			if( el.getAttribute("gtdName")==contacts[i].name ){
				var elImg = this._doc.createElement("IMG");
					elImg.className = "closeness";
					elImg.src = contacts[i].closenessImgSrc;
					elImg.title = contacts[i].closenessTooltip;
				var elName = GIPROTOTYPE.getElementsByClassName(el, "left")[0];
				elName.insertBefore(elImg, elName.firstChild );
			}
		}
	}
}
*/

Dashboard4.prototype.renderHeader = function(elCombo, type, items){
	
	var elRankings = this._doc.createElement("DIV");
		elRankings.className = "rankings";
		elRankings.setAttribute("gtdRankingType", type);
	
	for( var i = 0; i < items.length; i++ ){
		var el = this._doc.createElement("DIV");
			el.className = "ranking";
			el.innerHTML = this._gtdinboxPage.stringBundle.getString("Dashboard.Rankings." + items[i]);
			el.setAttribute("gtdRanking", items[i]);
			if( i==0 ) el.className += " selected";
		elRankings.appendChild( el );
	}
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	elRankings.appendChild( elClear );
	
	this._eventObservers.observe(elRankings, "mousedown", this._clickRanking, false);
	
	
	elCombo.appendChild( elRankings );
	return elRankings;		
};

Dashboard4.prototype._clickRanking = function(event, el){
	// Decide what ranking type was clicked; and process
	
try{
	if( !el ) el = GIPROTOTYPE.element(event);
	
	var lastRankingId = (new Date()).valueOf();
	
	var elRankings = el.parentNode;
	if( elRankings.className!="rankings" ) return;
	
	elRankings.setAttribute("gtdLastRankingId", lastRankingId);
	
	// Clear out old selection:
	for( var i = 0; i < elRankings.childNodes.length; i++ ){
		GIPROTOTYPE.removeClassName(elRankings.childNodes[i], "selected");
	}
	GIPROTOTYPE.addClassName(el, "selected");
	
	var type = elRankings.getAttribute("gtdRankingType");
	var rank = el.getAttribute("gtdRanking");
	var showHider = this._showHiders[type];
	if( showHider.elResults ) showHider.elResults.innerHTML = "";
	
	if( rank=="closeness" ){
		showHider.elResults.innerHTML = "<img src='chrome://gtdinbox/skin/indicator_medium.gif'/>";
		var contacts = [];
		var buckets = this._buckets[type]
		for( b in buckets ) contacts.push(b);
		this._closeContacts.processContacts(null, contacts, GIPROTOTYPE.bind(this, function(contacts, contactsHash){
			if( elRankings.getAttribute("gtdLastRankingId")!=lastRankingId ) return;
			showHider.elResults.innerHTML = "";
			this._closeContacts.mergeBuckets(buckets, contactsHash);
			this._searcher.renderRankedBuckets(type, buckets, GIPROTOTYPE.bind(this, this._addTitle), GIPROTOTYPE.bind(this, this._addItem), GIPROTOTYPE.bind(this, function(){
			
				// Add images:
				for( var i = 0; i < contacts.length; i++ ){
					for( var j = 0; j < showHider.elResults.childNodes.length; j++ ){
						var el = showHider.elResults.childNodes[j];
						if( el.getAttribute("gtdName")==contacts[i].name ){
							var elImg = this._doc.createElement("IMG");
								elImg.className = "closeness";
								elImg.src = contacts[i].closenessImgSrc;
								elImg.title = contacts[i].closenessTooltip;
							var elName = GIPROTOTYPE.getElementsByClassName(el, "left")[0];
							elName.insertBefore(elImg, elName.firstChild );
						}
					}
				}
			
				}), rank, true);
		}));
	}else{
		this._searcher.renderRankedBuckets(type, this._buckets[type], GIPROTOTYPE.bind(this, this._addTitle), GIPROTOTYPE.bind(this, this._addItem), null, rank, true);
	}
	
 	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard4 _clickRanking\n" + e.toString());
}
};



Dashboard4.prototype._addTitle = function(type, elTitle, superTitle){

try{
	if( typeof elTitle == "string" ){
		var title = elTitle;
		elTitle = this._doc.createElement("DIV");
			elTitle.innerHTML = title;
	}
	GIPROTOTYPE.addClassName(elTitle, "title");
	if( superTitle ) GIPROTOTYPE.addClassName(elTitle, "super-title");
	
	var showHider = this._showHiders[type];
	var elCombo = showHider.elResults || showHider.elContent;
	elCombo.appendChild( elTitle );
	return elTitle;
	
}catch(e){
	if( GTDDEBUGMODE ) alert( "Dashboard4 _addTitle\n" + e.toString() );
}

};

Dashboard4.prototype._addItem = function(type, name, displayName, title, search, bucket, showNumberResults, insertBefore, previewThreads){
try{
	var showHider = this._showHiders[type];
	var elCombo = showHider.elResults || showHider.elContent;

	if( !search && name ){
		search = (type=="Contact")? GIPROTOTYPE.restrictSearchToUser(name,true) : GIPROTOTYPE.searchableLabel(name);
	}

	var el = this._doc.createElement("DIV");
		el.className = "line-item";
		el.setAttribute("gtdName", name);
		if( type!="Contact" ) el.setAttribute("gtdLabelName", name);
		if( search ) el.setAttribute("gtdSearch", search );
		if( title ) el.title = title;
		el.setAttribute("gtdType", type);
	
	// Create html:
	var html = [];
	html.push( "<div><div class='left'>" + (displayName || name) + "</div>" );
	if( search ){
		html.push( "<div class='commands'>" );
		if( search && previewThreads ) html.push( "<img class='show-threads' src='chrome://gtdinbox/content/show-threads.png' title='" + this._gtdinboxPage.stringBundle.getString("FilterPopup.Tooltip.ShowThreads") + "'  />" );
		if( search || name ) html.push( "<img class='expander global-expander' src='chrome://gtdinbox/content/filter-extend.png' gtdSearch='" + search + "' gtdType='" + type + "' gtdName='" + name + "' " + (type=="Contact"? "":("gtdLabeName='" + name + "'")) + " />" );
		html.push( "</div>" );
	}
	html.push( "<div style='clear:both'></div>" );
	if( bucket ){
		//var d = new Date(bucket.oldest);
		//html.push( "<div class='details'>" + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.Earliest") + ": " + d.getFullYear() + "/" + (d.getMonth() + 1) + "/" + d.getDate() + "</div>");
		var daysAgo = parseInt(((new Date()).valueOf() - bucket.oldest) / (1000*60*60*24));
		html.push( "<div class='details'>" + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.Earliest") + ": " + daysAgo + " " + this._gtdinboxPage.stringBundle.getString("Dashboard.LineItems.DaysAgo") + "</div>");
	}
	el.innerHTML = html.join("");
	
	var elTitle = GIPROTOTYPE.getElementsByClassName(el, "left")[0];	
	if( search && showNumberResults ){
		elTitle.setAttribute("gtdSearch", search );
		elTitle.setAttribute("show-number-results", "1");
	}
	
	// Append it:
	if( insertBefore ){
		elCombo.insertBefore( el, insertBefore );
	}else{
		elCombo.appendChild( el );
	}
	
	if( previewThreads && search ){	// Create a thread preview
		var elPreview = this._doc.createElement("DIV");
			elPreview.className = "show-threads-preview-box";
			elPreview.style.display = "none";
		if( el.nextSibling ){
			el.parentNode.insertBefore( elPreview, el.nextSibling );
		}else{
			el.parentNode.appendChild( elPreview );
		}
	}
	
	return el;
	
}catch(e){
	if( GTDDEBUGMODE ) alert( "Dashboard4 _addItem\n" + e.toString() );
}
};








Dashboard4.prototype._clickShowHiderContent = function(event){
	if( event.button!=0 ) return;
	
	
		
	var el = GIPROTOTYPE.element(event);	
	
	// Test commands:
	if( el.className.indexOf("expander")>-1 ) return;	// It's a popout filter, handled by FilterEnvironment
	if( el.className.indexOf("ranking")>-1 ) return;	// It's a ranking
	
	// Hide all the other showhiders
	for( name in this._showHiders ) this._showHiders[name]._show(false);

	
	// Preview threads:
	if( el.nodeName=="IMG" && el.className=="show-threads" ){
		GIPROTOTYPE.stop(event);
		var elLink = el.parentNode;
		while( elLink.parentNode && elLink.className.indexOf("line-item")==-1 ){
			elLink = elLink.parentNode;
		}
		if( !elLink.parentNode ) return;
		
		var elPreview = elLink.nextSibling;
		while( elPreview.nextSibling && elPreview.className!="show-threads-preview-box" ) elPreview = elPreview.nextSibling;
		
		if( elPreview.className!="show-threads-preview-box" ) return;
		
			if( elPreview.innerHTML=="" ){	// Load it
				this._searcher.search( elLink.getAttribute("gtdSearch"), GIPROTOTYPE.bind(this, function(threadList){
					if( threadList._threads.length > 0 ){
						var threadListCustomUI = new ThreadListCustomUI(this._gtdinboxPage );
						threadListCustomUI.load( threadList, null, {excludeNames:true, excludeDate:true, excludeLabels:true, tooltipNames:true, tooltipDate:true} );
						this._threadListCustomUIs.push( threadListCustomUI );
						elPreview.appendChild(threadListCustomUI.el);
					}
				}));
			}
			if( elPreview.style.display=="none" ){
				elPreview.style.display = "";
			}else{
				elPreview.style.display = "none";
			}
	
		return;
	}
	
	// Find line-item element:
	while( el.parentNode && el.className.indexOf("line-item")==-1 ){
		el = el.parentNode;
	}
	if( el.className.indexOf("line-item")==-1 ) return;
	
	
	if( el.getAttribute("gtd.act")=="modifyreviews" ){
		this._gtdinboxPage._lightbox.setType( "modifyreviews" );
		this._gtdinboxPage._lightbox.active(true);
		return;
	}
	if( el.getAttribute("gtd.act")=="prioritiseByContact" ){
		if( !this._prioritiseByContacts ) this._prioritiseByContacts = new PrioritiseByContacts(this._gtdinboxPage);
		this._prioritiseByContacts.refresh();
		this._prioritiseByContacts.show(true, event);
		return;
	}
	
	
	if( el.getAttribute("gtdThread") ){
		var url = this._gtdinboxPage.gmailDOM.local("domain") + "#inbox/" + el.getAttribute("gtdThread");
		if( event.button==0 ){
			this._doc.defaultView.top.location.href = url;
		}else if(event.button==1){
			gBrowser.selectedTab = gBrowser.addTab(url);
		}
		return;
	};
	
	
	
	var searchStr = el.getAttribute("gtdSearch");
	if( !searchStr ){
		var label = {name:el.getAttribute("gtdName"), labelname:el.getAttribute("gtdLabelName"), 'el':el}
		if( label.labelname ){
			this._gtdinboxPage._searchBoxUI.search(GIPROTOTYPE.searchableLabel(label.labelname));
		}
		return;
	}
	GIPROTOTYPE.stop(event);
	
	searchStr = GIPROTOTYPE.parseSearchString(searchStr);
	
	if( searchStr.indexOf("contacts.close")>-1 || searchStr.indexOf("contacts.multipleRecipients")>-1 ){
		// Special search
		// 1) Retrieve all threads for this search
		// 2) If contacts.close, extract all contacts and detect closeness
		// 3) Shortlist the ThreadList; depending on +/- of the special terms
		// 4) Build a new search string unique to threadList (a combination of from/to and unique subject/snippet items)
		
		// Activate the lightbox
		this._gtdinboxPage._lightbox.setType( "searching", {msg:'Searching'} );
		this._gtdinboxPage._lightbox.active(true);
		
		this._searcher.search(searchStr.replace(/(\-)?contacts\.close\s/, "").replace(/(\-)?contacts\.multipleRecipients\s/, ""), GIPROTOTYPE.bind(this, function(threadList){
			
				if( searchStr.indexOf("contacts.multipleRecipients")>-1 ){
					// Pay attention if a single msg in a thread has multiple recipients and wasn't sent by me
					var multiRecipStr = "";
					var seenRecips = {};
					if( searchStr.indexOf("-contacts.multipleRecipients")>-1 ){	// Ensure no multiple recips
						for( var i = threadList._threads.length -1; i >= 0; i-- ){
							var thread = threadList._threads[i];
							for( b in thread.body ){
								if( thread.body[b].recipients.length > 1 && !environment.emails[thread.body[b].sender[1]] ){
									for( var j = 0; j < thread.body[b].recipients.length; j++ ){
										if( !seenRecips[thread.body[b].recipients[j][1]] ){
											if( multiRecipStr!="" ) multiRecipStr += " AND ";
											multiRecipStr += "-to:" + thread.body[b].recipients[j][1];	
											seenRecips[thread.body[b].recipients[j][1]] = true;
										}
									}
								}
							}
						}
						searchStr = searchStr.replace("-contacts.multipleRecipients", "(" + multiRecipStr + ")" );
					}else{	// include any multi recips
						for( var i = threadList._threads.length -1; i >= 0; i-- ){
							var thread = threadList._threads[i];
							for( b in thread.body ){
								if( thread.body[b].recipients.length > 1 && !environment.emails[thread.body[b].sender[1]] ){
									for( var j = 0; j < thread.body[b].recipients.length; j++ ){
										if( !seenRecips[thread.body[b].recipients[j][1]] ){
											if( multiRecipStr!="" ) multiRecipStr += " OR ";
											multiRecipStr += "to:" + thread.body[b].recipients[j][1];	
											seenRecips[thread.body[b].recipients[j][1]] = true;
										}
									}
								}
							}
						}
						searchStr = searchStr.replace("contacts.multipleRecipients", "(" + multiRecipStr + ")" );
					}
					
				}
				if( searchStr.indexOf("contacts.close")>-1 ){
					this._closeContacts.processContacts(threadList, null, GIPROTOTYPE.bind(this, function(contactList, contactHash){
							// Extract all threads with(out) these contacts
							var closeContactStr = "(";
							if( searchStr.indexOf("-contacts.close")>-1 ){	// include all unclose contacts								
								for( var i = 0; i < contactList.length; i++ ){
									if( i > 0 ) closeContactStr += " AND ";
									closeContactStr += "-from:" + contactList[i].name;
								}
								closeContactStr += ")";
								searchStr = searchStr.replace("-contacts.close", closeContactStr);
							}else{	// include all close contacts
								for( var i = 0; i < contactList.length; i++ ){
									if( i > 0 ) closeContactStr += " OR ";
									closeContactStr += "from:" + contactList[i].name;
								}
								closeContactStr += ")";
								searchStr = searchStr.replace("contacts.close", closeContactStr);
							}
							this._gtdinboxPage._lightbox.active(false);
							this._gtdinboxPage._searchBoxUI.search(searchStr);
						}));
				}else{
					this._gtdinboxPage._lightbox.active(false);
					this._gtdinboxPage._searchBoxUI.search(searchStr);
				}
				
			})); 
		
		return;
	}else{
		this._gtdinboxPage._searchBoxUI.search(searchStr);
	}
		
	
};



Dashboard4.prototype.destroy = function(){
	if( this._gtdinboxPage==null ) return;
	
	this._eventObservers.destroy();
	this._gtdinboxPage = null;
	this._searcher.destroy();
	this._closeContacts.destroy();
	if( this._prioritiseByContacts ) this._prioritiseByContacts.destroy();
	
	for( name in this._showHiders ){
		this._showHiders[name].destroy();
	}
	
	for( var i = 0; i < this._threadListCustomUIs.length; i++ ){
		this._threadListCustomUIs[i].destroy();
	}
};