function Dashboard5(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = gtdinboxPage.doc;
	this._labels = this._gtdinboxPage._labels;
	this._eventObservers = new GtdEventObservers(this);
	this._showHiders = [];
	
	this._taskPane = new TaskPaneUI(gtdinboxPage);
}


Dashboard5.prototype.viewChange = function(gmail){
	// Ensure the Dashboard is integrated into this view
try{
	if( this._gtdinboxPage.view("view")!="tl" && this._gtdinboxPage.view("view")!="cv" ) return;

	var elMoreActions = this._gtdinboxPage.gmailDOM.element("action-combo");
	if( !elMoreActions.nextSibling || elMoreActions.nextSibling.className.indexOf("dashboard")==-1 ){	// Not found
		// Create a showhider, look up the title from the stringbundle, and store it in the showhiders collection
		var elContent = this._doc.createElement("DIV");
		var showHider = new ShowhiderCombo(this._gtdinboxPage, "Dashboard.ShowHider", {title:this._gtdinboxPage.stringBundle.getString("Dashboard"), 'elContent':elContent});
		showHider.addEventHandler(this, "show", this._showShowHider);
		showHider.el.className += " dashboard-combo-tasks dashboard-combo";
					
		// Insert position:
		if( elMoreActions.nextSibling ){
			elMoreActions.parentNode.insertBefore( showHider.el, elMoreActions.nextSibling );
		}else{
			elMoreActions.parentNode.appendChild( showHider.el );
		}
		
		this._showHiders.push( showHider );
		
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard5 viewChange\n" + e.toString());
}
};


Dashboard5.prototype._showShowHider = function(showHider){
	// Refresh the view for this show hider
	
try{
	var dims = GIPROTOTYPE.getDimensions(this._doc.body, this._doc);
	if( (dims.height-150) < 800 ){
		showHider.elContent.style.maxHeight = (dims.height-200) + "px";
	}

	showHider.elContent.appendChild( this._taskPane.el );
	this._taskPane.refresh();
}catch(e){
	if( GTDDEBUGMODE ) alert("Dashboard5 _showShowHider\n" + e.toString());
}
};



/*
Dashboard5.prototype._clickShowHiderContent = function(event){
	if( event.button!=0 ) return;
	var el = GIPROTOTYPE.element(event);	
	
	// Test commands:
	if( el.className.indexOf("expander")>-1 ) return;	// It's a popout filter, handled by FilterEnvironment
	if( el.className.indexOf("ranking")>-1 ) return;	// It's a ranking
	
};
*/


Dashboard5.prototype.destroy = function(){
	if( this._gtdinboxPage==null ) return;
	
	this._eventObservers.destroy();
	this._gtdinboxPage = null;
	
	this._taskPane.destroy();
	for( var i = 0; i < this._showHiders.length; i++ ) this._showHiders[i].destroy();
	this._showHiders.length = 0;
	
};