/* Copyright Andy Mitchell 2007. No warranties */

var GTDDEBUGMODE = false;
var GTDDEBUGMODE_DB = false;
var GTDDEVMODE = false;

function GTDInboxBrowser(){

try{
	var browser_appcontent = window.document.getElementById("appcontent");
	this.db = new GTDInboxDB("gtdinbox.sqlite");
	this.options = new GtdFFOptions();
	
	this.stringBundle = document.getElementById("gtd-string-bundle");
	//this._locale = this.stringBundle.getString("localename");

	
	if( GTDDEBUGMODE && this.options.getOption("char", "gtdinbox.debugMode")=="1" ){
		GTDDEBUGMODE = true;
	}else{
		GTDDEBUGMODE = false;
	}
	if( this.options.getOption("char", "gtdinbox.forceDebugMode")=="1" ){
		GTDDEBUGMODE = true;
	}
	if( this.options.getOption("char", "gtdinbox.devMode")=="1" ){
		GTDDEVMODE = true;
	}
	
		
	
	// Setup event handlers
	var fNewPage = this.createFNewPage();
	browser_appcontent.addEventListener("DOMContentLoaded", fNewPage, false);
	
	// Tab Events
	var tabContainer = gBrowser.tabContainer;
	var fTabClose = function(event){
			var currentBrowser = event.target.linkedBrowser;
			if( currentBrowser ){	// useful to block iframes
				var tabGTD = currentBrowser.gtdinboxPage;
				if( tabGTD ) tabGTD.unload();
			}
		};
	tabContainer.addEventListener("TabClose", GIPROTOTYPE.bind(this, fTabClose), false);
	

}catch(e){
	if( GTDDEBUGMODE ) alert("GTDInboxBrowser constructor\n" + e.toString());
}
}

GTDInboxBrowser.prototype.getLocalHtmFile = function(filename){
	//return "chrome://gtdinbox/content/locale/" + this._locale + "/" + filename + ".htm";
	return "chrome://gtdinbox/locale/" + filename + ".htm";
};



GTDInboxBrowser.prototype.createFNewPage = function(){
	var gtdinboxBrowser = this;
	var fNewPage = function(event){
		
			var currentBrowser = gBrowser.getBrowserForDocument(event.originalTarget);
			if( currentBrowser ){	// useful to block iframes
				try{
				
				var loc = event.originalTarget.location;
					var newUrl = loc.href;
					var gtdinboxPage = null;
					if( currentBrowser ){
						var tabGTD = currentBrowser.gtdinboxPage;
						if( tabGTD ) tabGTD.unload();
					}
					if( /^http(s?):\/\/mail.google.com/.test(newUrl) ){
						gtdinboxPage = new GTDInboxPage(gtdinboxBrowser, event.originalTarget);	// create new one:
						//gtdinboxBrowser.checkOptions();	// TODO DITCH THIS
					}else if( /gtdinbox\/locale\/printer\.htm/.test(newUrl) ){
						var printView = new PrinterUI(gtdinboxBrowser, event.originalTarget);
					}else if( /gtdinbox\/content\/printview\.htm/.test(newUrl) ){
						var printView = new PrintViewUI(gtdinboxBrowser, event.originalTarget);
					}
				}catch(e){if( GTDDEBUGMODE ) alert("fNewPage\n" + e.toString())}
			}
		};
	return fNewPage;
};




GTDInboxBrowser.prototype.getBrowserFromEvent = function(event){gBrowser.getBrowserForDocument(event.originalTarget);}; 



