/* Copyright Andy Mitchell 2007. No warranties */

function GTDInboxPage(gtdinboxBrowser, doc){
try{
	GIPROTOTYPE.gtdinboxPage = this;

	this.id = (new Date()).valueOf();
	this.gtdinboxBrowser = gtdinboxBrowser;
	this.db = gtdinboxBrowser.db;
	this.sp = new StoredProceduresGTD(this);
	this.stringBundle = gtdinboxBrowser.stringBundle;
		this.stringBundle.getStringSafe = function(key, failSafe){
				var str = "";
				try{
					str = gtdinboxBrowser.stringBundle.getString(key);
				}catch(e){}
				if( !str ) str = failSafe;
				return str;
			};
	this.eventObservers = new GtdEventObservers(this);
	
	this.doc = doc;
	this.mainDoc = doc; 
	this.window = doc.defaultView;
	this.unsafeWindow = this.window.wrappedJSObject;
	this.attachToBrowser();
	
		
	this._gtdFrame = this.doc.location.href.match(/gtd\=(\d+)/i);
	if( this._gtdFrame ) this._gtdFrame = this._gtdFrame[1];	// a unique id	
	
	this.viewChangeCallbacks = {};	// in form {type} = [func];
	
	
	/*
	var window = pageDoc.defaultView;
	var unsafeWindow = window.wrappedJSObject;
	if( window && unsafeWindow ){
		window.addEventListener('load', function() {
		if (unsafeWindow.gmonkey) {
			unsafeWindow.gmonkey.load('1', function(gmail) {
			function setViewType() {
				var str = '';
				switch (gmail.getActiveViewType()) {
				case 'tl': str = 'Threadlist'; break;
				case 'cv': str = 'Conversation'; break;
				case 'co': str = 'Compose'; break;
				case 'ct': str = 'Contacts'; break;
				case 's': str = 'Settings'; break;
				default: str = 'Unknown';
				}
				module.setContent(str);
			}
			var module = gmail.addNavModule('View Monitor');
			gmail.registerViewChangeCallback(setViewType);
			setViewType();
			});
		}
		}, true);
	}
	*/
	
	
	var onLoad = GIPROTOTYPE.bind( this, function() {
		try{
			var lateLoad = (gtdinboxBrowser.options.getOption("char", "gtdinbox.lateLoad", "0")=="1");
			
			var iL = GIPROTOTYPE.bind(this, function(){
				this.initLocal();
			});
			//if( !lateLoad ) setTimeout( iL, 500 );
			setTimeout( iL, 1000 );
			//setTimeout( iL, 2000 );
			//if( !lateLoad ) iL();
		}catch(e){
			if( GTDDEBUGMODE ) alert("gtdinboxpage windowLoaded init\n" + e.toString());
		}
	});
	
	
	this.windowLoaded = false;
	this.window.addEventListener('load', onLoad, true);

	setTimeout(onLoad, 30000);	// act as a fail safe
	

	setTimeout( GIPROTOTYPE.bind(this, function(){	// Show error if it fails to load
			if( !this._isInit && this.unsafeWindow.top.location.href.indexOf("attid")==-1 && this.unsafeWindow.top.location.href.indexOf("support")==-1 ){	// attid appears on files loaded
				var doc = this.unsafeWindow.document;
				var elDiv = doc.createElement("DIV");
				elDiv.setAttribute("style", "position: absolute; text-align: center; width: 100%; z-index: 10000; top: 26px;");
				elDiv.innerHTML = "<div style='width:400px;margin:auto;font-size:0.7em;text-align:center;background-color:rgb(255,255,204);-moz-border-radius:6px;'><a href='http://gtdinbox.com/faq.htm'>" + this.stringBundle.getString("GTDInboxPage.FailLoad") + "</a>&nbsp;[<span onclick='this.parentNode.parentNode.removeChild(this.parentNode)' style='color:red;font-weight:bold;cursor:pointer;'>x</span>]</div>";		
				
				var elSpan = elDiv.getElementsByTagName("SPAN")[0];
				this.eventObservers.observe(elSpan, "click", function(){
						elDiv.parentNode.removeChild( elDiv );
					}, false);
				
				if( (!doc.body || doc.body.nodeName=="FRAMESET") && this.unsafeWindow.frames[0] ){	// Gmail 1
					this.unsafeWindow.frames[0].document.body.appendChild( elDiv );
				}else{
					doc.body.appendChild( elDiv );
				}
			}
		}), 60000 );

	
}catch(e){
	if( GTDDEBUGMODE ) alert("gtdinboxpage constructor\n" + e.toString());
}
};

GTDInboxPage.prototype.initLocal = function(callbackCount){
	if( callbackCount && callbackCount > 2 ) return;
	try{
		
			if( !this._threadList ) this._threadList = new ThreadList(this);
	
			if( this.unsafeWindow && this.unsafeWindow.top && this.unsafeWindow.top.js && this.unsafeWindow.top.js.gmonkey ){
				//this.windowLoaded==false && !this.unsafeWindow.top.gtdinboxLoaded
				
				if( (gtdinboxBrowser.options.getOption("char", "gtdinbox.noPreview", "0")=="1") ){	// No override eval
					this.unsafeWindow.top.gtdPreventOverride = true;
				}
				
				if( !this.unsafeWindow.top.GTDCallBack ){
					this.unsafeWindow.top.GTDCallBack = GIPROTOTYPE.bind(this, function(g){
						this._gmail = g;
						this.viewChange(g);
					
					});
				}
				if( !this.unsafeWindow.top.GTDInterceptEval ){
					this.unsafeWindow.top.GTDInterceptEval = GIPROTOTYPE.bind(this, function(a, s){
						try{
							if( !((typeof a == "object") && (typeof a.length == "number")) ) return;
							a = a[0];
							this.dataChange(a, s);
						}catch(e){}
					});
				}
					
				//if( !this.unsafeWindow.top.gtdLocalRegisteredViewChange || !this.unsafeWindow.top.gtdLocalLoaded ){
					this.unsafeWindow.gtdinboxFrame = this._gtdFrame? true:false;
					var elScript = this.doc.createElement("SCRIPT");
					
					var js = GTDFileIO.readFromUrl( "chrome://gtdinbox/content/GTDInboxLocal.js" );
					//elScript.src = "chrome://gtdinbox/content/GTDInboxLocal.js";
					elScript.innerHTML = js;
					this.doc.getElementsByTagName("HEAD")[0].appendChild(elScript);
				//}
			}else{
				var iL = GIPROTOTYPE.bind(this, function(){
					if( !callbackCount ) callbackCount = 0;
					this.initLocal(++callbackCount);
				});
				setTimeout( iL, 150 );
			}
	}catch(e){
		if( GTDDEBUGMODE ) alert("gtdinboxpage windowLoaded init 2\n" + e.toString());
	}
};

GTDInboxPage.prototype.init = function(){
try{
	if( !this._isInit ){
			this.getSettings();
			
			
			this._recentItems = new RecentItems(this);
			
			
			this.gtdServer = new GtdServer(this);
			
			
			this.remoteErrorCheck = new RemoteErrorCheck(this);		
			this.remoteErrorCheck.checkServerMessages();	// Look for updates
			
			/*
			// Remote Error Check: Replace Gmail DOM
			try{
				// Check in this memory space, not sure why
				if( this.settings.remoteErrorCheck ){
					var version = this.settings.lastVersion;
					var knownGmailDomVersion = this.settings.remoteErrorCheck.currentGmailDomVersion;
					var knownGmailDomRevision = this.settings.remoteErrorCheck.currentGmailDomRevision;
					if( version<=knownGmailDomVersion ){	// needs update
						var file = this.remoteErrorCheck._getFileFromDB("gmailDOM");
						if( file ) eval(file);
					}
				}
			}catch(e){
				if( GTDDEBUGMODE ) alert("RemoteErrorCheck testOverwriteObjects\n" + e.toString());
			}
			*/
						
					
			//if( !this.unsafeWindow.console ){
			//	this.unsafeWindow.console = {log: function(){}, trace: function(){}};
			//}
			
				
			if( !this._gmail || !this._gmail.getActiveViewElement ){
				if( GTDDEBUGMODE ) alert("gtdinboxPage GTDCallBack - could not find gmail");
				return;	// error
			}
		
			this.doc = this._gmail.getActiveViewElement().ownerDocument;
			GIPROTOTYPE._gtdinboxPage = this;
			
			this.gmailDOM = new GmailDOM(this);
			this.gmailDOM.viewChange(this._gmail);
		
			this.install();
		
						
			this.windowLoaded = true;
			this.unsafeWindow.top.gtdinboxLoaded = true;
			this._isInit = true;
			
			if( this._gtdFrame ){	// Strip it of surrounding elements (its a popup)
				
				try{
					var el = this._gmail.getMastheadElement();
					el.style.display = "none";
					var el = this._gmail.getFooterElement();
					el.style.display = "none";
					var el = this._gmail.getNavPaneElement();
					el.style.display = "none";
				}catch(e){}	// Something in the Gmail calls can fail
				
			}
		
		
			this._createAboutBox();
			
			this._perfLogger = new PerfLogger(this);
			if( GTDDEBUGMODE ) this.unsafeWindow.top.perfLogger = this._perfLogger;
			
			
			this._moreActionsMenu = new MoreActionsMenu(this);
			
			var elNav = this.gmailDOM.element("NavPaneElement", this._gmail);
			this._asyncPopuper = new AsyncPopuper(this, elNav.ownerDocument.body);
			//this._contactFilterPopuper = new ContactFilterPopuper(this, elNav.ownerDocument.body);
			GIPROTOTYPE.decodeEntities("0", this.doc);	// initialise it
			this.addCSS(this.gmailDOM.element("document", this._gmail));
			//this.addCSS(this.doc);
			this._environment = new Environment(this, this.gmailDOM.element("MastheadElement", this._gmail));
			this._labels = new Labels(this);
				this._labels.addEventHandler( this, "refresh-labels", this._refreshLabels );
			this._labels.load(elNav);
			this._threadListUI = new ThreadListUI(this);
			this._threadListPopupUI = new ThreadListPopupUI(this, this.doc.body, true);
			this._composeUI = new ComposeUI(this);
			this._conversationUI = new ConversationUI(this);
			if( !this.settings.ui.hide.dashboard ){
				if( GTDDEVMODE ){
					this._dashboard = new Dashboard5(this);
				}else{
					this._dashboard = new Dashboard2(this);
				}
			}
			if( !this.settings.ui.hide.rightClick ) this._filterEnvironment = new FilterEnvironment(this);
			this._labelsUI = new SettingsGmail(this);
			this._contactsUI = new ContactsUI(this);
			this._printButtonUI = new PrintButtonUI(this);
			this._searchBoxUI = new SearchBoxUI(this);
			
			this._lightbox = new GtdLightbox(this, this.doc.body);
			this._autoLabel = new AutoLabel(this);
			
			if( this.showMsg ){
				if( this.showMsg=="updateFrom1" ){
					this._lightbox.setType( "update", {updateLabels:true} );
				}else{
					this._lightbox.setType( this.showMsg );
				}
				this._lightbox.active(true);
				this.showMsg = null;	// ensure doesn't show again on reload
			}
			
			if( this.unsafeWindow && this.unsafeWindow.top ) this.unsafeWindow.top.bulkMailer = new BulkMailer(this);
			
			
			if( !this.settings.doNotPreload ) this.preLoadInbox(5000);
			
			/*
			this.searcher = new Searcher(this);
			this.unsafeWindow.top.gtdSearch = GIPROTOTYPE.bind(this, function(s){ this.searcher.search(s, GIPROTOTOTYPE.bind(this, function(tL){this.unsafeWindow.console.log(tl)})) });
			this.unsafeWindow.top.gtdGetNumberResults = GIPROTOTYPE.bind(this, function(s,c){ this.searcher.getNumberResults(s,c) });
			this.unsafeWindow.top.gtdTimeGetNumberResults = GIPROTOTYPE.bind(this, function(){ this.searcher.timeGetNumberResults() });
			this.unsafeWindow.top.gtdGetThreadData = GIPROTOTYPE.bind(this, function(){ this.gmailDOM.getThreadData(["119c9403ec9f1ca4"], this._threadList, function(){}) });
			*/
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("init\n" + e.toString());
}
};
GTDInboxPage.prototype.attachToBrowser = function(){
	this.browser = gBrowser.getBrowserForDocument( this.doc );
	this.browser.gtdinboxPage = this;
};
GTDInboxPage.prototype.addCSS = function(doc){
	var elLink = this.doc.createElement("LINK");
	elLink.type = "text/css";
	elLink.href = "chrome://gtdinbox/skin/gtdinbox.css";	
	elLink.rel = "stylesheet";
	doc.getElementsByTagName("HEAD")[0].appendChild( elLink );
	/*
	var elStyle = this.doc.createElement("STYLE");
	elStyle.type = "text/css";
	elStyle.innerHTML = GTDFileIO.readFromUrl( "chrome://gtdinbox/skin/gtdinbox.css" );
	doc.getElementsByTagName("HEAD")[0].appendChild( elStyle );
	*/
};

GTDInboxPage.prototype._createAboutBox = function(){
	this.elAbout = this._gmail.addNavModule("GTDInbox");
	
	var el = this.doc.createElement("DIV");
		el.className = "gtdinbox-about";
	this.elAbout.appendChild( el );
	
	
	// Create the warning box (hidden)
	this.elLabelsWarning = this.doc.createElement("DIV");
		this.elLabelsWarning.className = "labels-warning";
		this.elLabelsWarning.style.display = "none";
	el.appendChild( this.elLabelsWarning );
	var elWarningTitle = this.doc.createElement("DIV");
		elWarningTitle.className = "title";
		elWarningTitle.innerHTML = this.stringBundle.getString("Sidebar.About.Warning");
	this.elLabelsWarning.appendChild( elWarningTitle );
	var elWarningResolve = this.doc.createElement("DIV");
		elWarningResolve.className = "resolve";
		elWarningResolve.innerHTML = this.stringBundle.getString("Sidebar.About.Warning.Resolve");
	this.elLabelsWarning.appendChild( elWarningResolve );
	var elWarningDetail = this.doc.createElement("DIV");
		elWarningDetail.className = "detail";
		elWarningDetail.innerHTML = this.stringBundle.getString("Sidebar.About.Warning.Detail");
	this.elLabelsWarning.appendChild( elWarningDetail );
	
	this.elUpdate = this.doc.createElement("DIV");
		this.elUpdate.className = "new-releases";
		this.elUpdate.style.display = "none";
	el.appendChild( this.elUpdate );
	var elUpdateTitle = this.doc.createElement("DIV");
		elUpdateTitle.className = "title";
		elUpdateTitle.innerHTML = this.stringBundle.getString("Sidebar.About.Update.Title");
	this.elUpdate.appendChild( elUpdateTitle );
	this.elUpdate_NewRelease = this.doc.createElement("DIV");
		this.elUpdate_NewRelease.innerHTML = "<span>" + this.stringBundle.getString("Sidebar.About.Update.NewRelease") + "</span><a href='#'></a>";
		this.elUpdate_NewRelease.style.display = "none";
		this.elUpdate.appendChild( this.elUpdate_NewRelease);
	this.elUpdate_NewBeta = this.doc.createElement("DIV");
		this.elUpdate_NewBeta.innerHTML = "<span>" + this.stringBundle.getString("Sidebar.About.Update.BetaRelease") + "</span><a href='#'></a>";
		this.elUpdate_NewBeta.style.display = "none";
		this.elUpdate.appendChild( this.elUpdate_NewBeta);
	
	this.elMiniPatch = this.doc.createElement("BUTTON");
		this.elMiniPatch.className = "mini-patch";
		this.elMiniPatch.style.display = "none";
		
	
	this.elVersionWarning = this.doc.createElement("DIV");
		this.elVersionWarning.className = "version-warning";
		this.elVersionWarning.innerHTML = "<a href='http://blog.gtdinbox.com' target='_blank'>" + this.stringBundle.getString("Sidebar.About.VersionWarning") + "</a>";
		this.elVersionWarning.style.display = "none";
	el.appendChild( this.elVersionWarning );
	
	
		
	
	/*
	this.elAtWarning = this.doc.createElement("DIV");
		this.elAtWarning.className = "at-warning";
		this.elAtWarning.style.display = "none";
		this.elAtWarning.innerHTML = this.stringBundle.getString("Sidebar.About.AtWarning") + "<br/><button>" + this.stringBundle.getString("Sidebar.About.AtWarning.Resolve") + "</button>";
	el.appendChild( this.elAtWarning );
	setTimeout( GIPROTOTYPE.bind(this, function(){
			var noPreview = (gtdinboxBrowser.options.getOption("char", "gtdinbox.noPreview", "0")=="1");
			if( !this.gmailDOM.local("at") ){
				this.elAtWarning.style.display = "";
			}
		}), 30000);
	*/
	
	
	
	/*
	var elOptions = this.doc.createElement("BUTTON");
		elOptions.className = "";
	elOptions.innerHTML = this.stringBundle.getString("Sidebar.About.Options");	
	el.appendChild(elOptions);
	*/
	
	var elDonate = this.doc.createElement("DIV");
		elDonate.className = "donate";
	elDonate.innerHTML = "<a href='http://gtdinbox.com/donate.htm' target='_blank'><img src='https://www.paypal.com/en_US/i/btn/x-click-butcc-donate.gif' style='border:none' title=\"" + this.stringBundle.getString("Sidebar.About.Donate") + "\"/></a>";
	el.appendChild(elDonate);
		
	var elStore = this.doc.createElement("BUTTON");
		elStore.className = "store-button";
	elStore.innerHTML = this.stringBundle.getString("Sidebar.About.Store");
	el.appendChild(elStore);


	var elContainer = this.doc.createElement("DIV");
	var elBlog = this.doc.createElement("A");
		elBlog.className = "options";
		elBlog.href = "http://blog.gtdinbox.com";
		elBlog.setAttribute("target", "_blank");
	elBlog.innerHTML = this.stringBundle.getString("Sidebar.About.Blog");	
	elContainer.appendChild( elBlog );
	el.appendChild(elContainer);
	
	var elContainer = this.doc.createElement("DIV");
	var elBlog = this.doc.createElement("A");
		elBlog.className = "options";
		elBlog.href = "http://forum.productivefox.com";
		elBlog.setAttribute("target", "_blank");
	elBlog.innerHTML = this.stringBundle.getString("Sidebar.About.Forum");	
	elContainer.appendChild( elBlog );
	el.appendChild(elContainer);
	
	var elContainer = this.doc.createElement("DIV");
	var elGettingStarted = this.doc.createElement("A");
		elGettingStarted.className = "options";
		elGettingStarted.href = "http://gtdinbox.com/support.htm";
		elGettingStarted.setAttribute("target", "_blank");
	elGettingStarted.innerHTML = this.stringBundle.getString("Sidebar.About.GettingStarted");	
	elContainer.appendChild(elGettingStarted);
	el.appendChild(elContainer);
	
	var elContainer = this.doc.createElement("DIV");
	var elDisclaimer = this.doc.createElement("A");
		elDisclaimer.className = "options";
		elDisclaimer.href = "#";
	elDisclaimer.innerHTML = this.stringBundle.getString("Sidebar.About.Disclaimer");	
	elContainer.appendChild( elDisclaimer );
	el.appendChild(elContainer);
	
	// Load the News:
	if( !this.settings.recentNewsItems ) this.settings.recentNewsItems = {};
	var elNews = this.doc.createElement("DIV");
	elNews.className = "news";
	elNews.innerHTML = "<span>" + this.stringBundle.getString("Sidebar.About.News") + "</span>";	
	var newItems = 0;
	var url = "http://www.google.com/uds/Gfeeds?v=1.0&output=json&q=" + encodeURIComponent("http://feeds.feedburner.com/ProductiveFirefox");
	var callback = GIPROTOTYPE.bind(this, function(jsonStr){
			var rss = gtdJson.parse(jsonStr);
			if( rss.responseData ){
				var entries = rss.responseData.feed.entries;
					if( entries.length > 3 ) entries.length = 3;
				var elUl = this.doc.createElement("UL");
				for( var i = 0; i < entries.length; i++ ){
					var elLi = this.doc.createElement("LI");
					elLi.innerHTML = "<a href=\"" + entries[i].link + "\" target='_blank'>" + entries[i].title + "</a>";
					elLi.title = entries[i].contentSnippet;
					elUl.appendChild( elLi );
					if( !this.settings.recentNewsItems[entries[i].link] ){
						this.settings.recentNewsItems[entries[i].link] = true;
						GIPROTOTYPE.addClassName(elLi, "new-item");
						newItems++;
					}
				}
				if( newItems > 0 ){
					elNews.firstChild.innerHTML += " [" + newItems + "]";
					elNews.firstChild.className = "new-item";
				}
				elNews.appendChild(elUl);
			}
			if( newItems > 0 ) this.saveSettings();
			el.appendChild( elNews );
		});
	var req = new XMLHttpRequest();
	req.open('GET', url, true);
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(aEvt){
		try{
		if (req.readyState==4) {
			if( req.status==200 ){
				callback(req.responseText);
			}
		}
		}catch(e){
			if( GTDDEBUGMODE ) alert("GTDInboxPage news statechange\n" + e.toString());
		}
	});
	req.send(null);
	
	
	
	/*
	var elDebug = this.doc.createElement("DIV");
		elDebug.className = "options";
		elDebug.style.display = "none";
	elDebug.innerHTML = this.stringBundle.getString("Sidebar.About.Debug");
	el.appendChild(elDebug);
	*/
		
	

	
	
	/*
	var elLogo = this.doc.createElement("A");
		elLogo.className = "pf-logo";
		elLogo.href = "http://productivefirefox.com";
		elLogo.setAttribute("target", "_blank");
		elLogo.innerHTML = "<img src=\"chrome://gtdinbox/content/pf-logo-small.png\" style='border:none'/>";
	el.appendChild( elLogo );
	*/
	
		
	//this.eventObservers.observe(elOptions, "mouseup", this._showOptions, false);
	//elOptions.addEventListener("mousedown", GIPROTOTYPE.bind(this, function(){this._showLb('options')}), true);
	elStore.addEventListener("mousedown", GIPROTOTYPE.bind(this, function(){this._showLb('store')}), true);
	elDisclaimer.addEventListener("mousedown", GIPROTOTYPE.bind(this, function(){this._showLb('disclaimer')}), true);
	//this.elAtWarning.getElementsByTagName("BUTTON")[0].addEventListener("mousedown", GIPROTOTYPE.bind( this, function(){this._showLb('resolve-limited')}), true);
	//elGettingStarted.addEventListener("mousedown", GIPROTOTYPE.bind(this, function(){this._showLb('gettingstarted')}), true);
	//elDebug.addEventListener("mousedown", GIPROTOTYPE.bind(this, function(){this._showLb('debug')}), true);
	this.elLabelsWarning.addEventListener("mousedown", GIPROTOTYPE.bind(this, this._clickLabelsWarning), true);
};
GTDInboxPage.prototype._refreshLabels = function(){
	// Called after labels box refreshes
	// Test for presence of at least one default status label, if not found, show warning box

try{
	var labelsHash = this._labels.getLabelsHash();
	var types = this.settings.labels.types;
	var found = false;
	for(d in types.Statuses.defaults){
		if( labelsHash[types.Statuses.prefix + types.Statuses.defaults[d]] ){
			found = true;
			break;
		}
	}
	
	if( this.settings.ui.hide.noLabelWarning ) found = true;	// make sure it doesn't show.
	
	this.elLabelsWarning.style.display = found? "none" : "";

}catch(e){
	if( GTDDEBUGMODE ) alert("gtdinboxpage _refreshLabels\n" + e.toString());
}
};
GTDInboxPage.prototype._clickLabelsWarning = function(event){
	// Detect if clicked a link, if so, do something
try{
	var el = GIPROTOTYPE.element(event);
	
	if( GIPROTOTYPE.hasClassName(el, "warning.labels") ){
		var el = this.gmailDOM.element("edit-labels");
		if( el ) GIPROTOTYPE.doMouseEvent(this.gmailDOM.element("document"), el, "click");
	}else if( GIPROTOTYPE.hasClassName(el, "warning.options") ){
		this._showLb("options");
	};
}catch(e){
	if( GTDDEBUGMODE ) alert("gtdinboxpage _clickLabelsWarning\n" + e.toString());
}
};
GTDInboxPage.prototype._showLb = function(name){
try{
	if( !(typeof name=="string") ) return;
	this._lightbox.setType( name );
	this._lightbox.active(true);
}catch(e){
	if( GTDDEBUGMODE ) alert("gtdinboxpage _showOptions\n" + e.toString());
}
};


GTDInboxPage.prototype.view = function(name){
	name = name || "view";
	switch(name){
		case "gtdviewid":
			return this._viewid;
			break;
		case "view":
			return this._gmail.getActiveViewType();
			break;
	};
};

GTDInboxPage.prototype.viewChange = function(gmail){
try{
	if( !gmail ){
		if( GTDDEBUGMODE ) alert("gtdinboxpage viewChange\nCould not find gmail");
		return;
	}

	var viewType = gmail.getActiveViewType();
	this._gmail = gmail;
	
	
	var elActive = gmail.getActiveViewElement();
	this._viewid = (new Date()).valueOf();
	if( elActive ) elActive.setAttribute("gtdviewid", this._viewid);
	
	if( !this._isInit ){
		if( viewType ){	// is loaded
			this.init();
		}else{	// not ready to load
			return;
		}
	}
	
	
	
	this.eventObservers.reset();
	//if( this._labels ) this._labels.viewChange(gmail);
	if( this._moreActionsMenu ) this._moreActionsMenu.viewChange(gmail);
	if( this.gmailDOM ) this.gmailDOM.viewChange(gmail);
	if( this._dashboard ) this._dashboard.viewChange(gmail);
	
	switch(viewType){
		case "tl":	// threadlist
			this._threadListUI.viewChange( gmail );
			this._printButtonUI.viewChange( gmail );
			break;
		case "cv":	// conversation
			this._conversationUI.viewChange(gmail);
			break;
		case "co":	// compose
			if( this._composeUI ) this._composeUI.viewChange(gmail);
			break;
		case "ct":	// contacts
			this._filterEnvironment.viewChange(gmail);
			this._contactsUI.viewChange(gmail);
			this._asyncPopuper.viewChange(gmail);
			break;
		case "s":	// settings
			this._labelsUI.viewChange(gmail);
			break;
	}
	
	// Do call backs:
	if( this.viewChangeCallbacks[viewType] ){
		for( var i = 0; i < this.viewChangeCallbacks[viewType].length; i++ ){
			this.viewChangeCallbacks[viewType][i]();
		}
	}
	if( this.viewChangeCallbacks["all"] ){
		for( var i = 0; i < this.viewChangeCallbacks["all"].length; i++ ){
			this.viewChangeCallbacks["all"][i]();
		}
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("viewChange\n" + e.toString());
}
};
GTDInboxPage.prototype.addViewChangeCallback = function(viewType, func){
	if( !this.viewChangeCallbacks[viewType] ) this.viewChangeCallbacks[viewType] = [];
	this.viewChangeCallbacks[viewType].push(func);
};

GTDInboxPage.prototype.dataChange = function(a, s){
	try{
		if( this._threadList ) this._threadList.parseAjaxResponse(a);
		if( this._environment ) this._environment.parseAjaxResponse(a);
		//this._labels.parseAjaxResponse(a);
		
		//this.unsafeWindow.console.log( a );
		
		
		// Execute a Refresh when all data objects loaded for first time (only for Inbox; useful for auto label)
		if( this._threadList ){
			if( !this._firstFullLoad && this._threadList._threads.length>0 && this._threadList._threads.length==this._threadListUI.rowCount ){
				this._firstFullLoad = true;
				this._threadListUI.refresh(null, true);
			}
			
			/*
			var el = this.doc.createElement("DIV");
			el.innerHTML = this._threadList._threads.length;
			if( s.indexOf("Piers")>-1 ) el.innerHTML += " *";
			this.elAbout.appendChild(el);
			
			var el = this.doc.createElement("DIV");
			el.innerHTML = s;
			this.doc.body.appendChild(el);
			*/
		}
	}catch(e){
		if( GTDDEBUGMODE ) alert("dataChange\n" + e.toString());
	}
};


GTDInboxPage.prototype.refreshCurrentView = function(){
	switch( this.view("view") ){
		case "tl":
			var el = this.gmailDOM.element("threadlist-refresh");
			if( el ) GIPROTOTYPE.doMouseEvent(this.doc, el, "click");
			break;
	}
};

GTDInboxPage.prototype.replaceGtdVariables = function(search){
	var statusPrefix = this.settings.labels.types.Statuses.prefix;
	var statusDefaults = this.settings.labels.types.Statuses.defaults;

	var variables = search.match(/<\?\=([^>]+?)>/g);
	if( variables ){
		for( var j = 0; j < variables.length; j++ ){
			var variableData = variables[j].match(/<\?\=([^>]+?)>/);
			if( variableData.length > 1 ){
				var args = variableData[1].split(".");
				var substitute = "";
				switch(args[0]){
					case "DaysAgo":
						substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - (1000*60*60*24*parseInt(args[1])) );
						break;
					case "MonthsAgo":
						substitute = GIPROTOTYPE.searchDate( (new Date()).valueOf() - ((1000*60*60*24*31)*parseInt(args[1])) );
						break;
					case "DefaultStatus":
						substitute = GIPROTOTYPE.searchableLabel(statusPrefix + statusDefaults[args[1]]);
						break;
				}
				search = search.replace(variables[j], substitute);
			}
		}
	}
	return search;
};

/*
GTDInboxPage.prototype.search = function(str){
	var elInput = this.gmailDOM.element("search-box");
	var elSubmit = this.gmailDOM.element("search-button");
	
	elInput.value = str;
	GIPROTOTYPE.doMouseEvent( this.doc, elSubmit, "click");
};
*/

GTDInboxPage.prototype.getStatusData = function(incAdditional){
	var status = {};	// Cache for tidier code
	status.prefix = this.settings.labels.types.Statuses.prefix;
	status.NextAction = status.prefix + this.settings.labels.types.Statuses.defaults.NextAction;
	status.Action = status.prefix + this.settings.labels.types.Statuses.defaults.Action;
	status.WaitingOn = status.prefix + this.settings.labels.types.Statuses.defaults.WaitingOn;
	status.SomeDay = status.prefix + this.settings.labels.types.Statuses.defaults.SomeDay;
	status.Finished = status.prefix + this.settings.labels.types.Statuses.defaults.Finished;
	status.orQuery = "((" + GIPROTOTYPE.searchableLabel(status.NextAction) + " OR " + GIPROTOTYPE.searchableLabel(status.Action) + " OR " + GIPROTOTYPE.searchableLabel(status.WaitingOn) + " OR " + GIPROTOTYPE.searchableLabel(status.SomeDay) + ") -" + GIPROTOTYPE.searchableLabel(status.Finished) + ")";
	if( incAdditional ){
		status.additional = [];
			var statusLabels = this._labels.getLabelsArray("Statuses");
			for( var i = 0; i < statusLabels.length; i++ ){
				if( statusLabels[i]!=status.NextAction && statusLabels[i]!=status.Action && statusLabels[i]!=status.WaitingOn && statusLabels[i]!=status.SomeDay && statusLabels[i]!=status.Finished ){
					status.additional.push( statusLabels[i] );
				}
			}
		var searchableAdditional = [];
		for( var i = 0; i < status.additional.length; i++ ) searchableAdditional.push( GIPROTOTYPE.searchableLabel( status.additional[i] ) );
		status.orQueryAll = "((" + GIPROTOTYPE.searchableLabel(status.NextAction) + " OR " + GIPROTOTYPE.searchableLabel(status.Action) + " OR " + GIPROTOTYPE.searchableLabel(status.WaitingOn) + " OR " + GIPROTOTYPE.searchableLabel(status.SomeDay) + searchableAdditional.join(" OR ") + ") -" + GIPROTOTYPE.searchableLabel(status.Finished) + ")";
	}
	
	return status;
};

GTDInboxPage.prototype.preLoadInbox = function(timeDelay){	
	// Load the inbox into the thread list
	if( timeDelay ){
		setTimeout( GIPROTOTYPE.bind( this, this.preLoadInbox ), timeDelay );
		return;
	}
try{
	var range = this.gmailDOM.parseElement( "threadlist-range", this.gmailDOM.element("threadlist-range") );
	var searchStr = this.gmailDOM.extractSearchQuery();
	
	this.gmailDOM.search(searchStr, this._threadList, range.start, range.end - range.start, GIPROTOTYPE.bind(this, function(searchArray, query, threadList, currentOffset){
			try{
				threadList.parseAjaxResponse(searchArray[0]);
			
			}catch(e){
				if( GTDDEBUGMODE ) alert( "GTDInboxPage preLoadInbox callback\n" + e.toString() );
			}
		}));
		
}catch(e){
	if( GTDDEBUGMODE ) alert( "GTDInboxPage preLoadInbox\n" + e.toString() );
}

};

GTDInboxPage.prototype.safelyEval = function(js){

	js = "var result = (" + js + ")";
	var sb = Components.utils.Sandbox("http://www.productivefirefox.com");
	try{
		Components.utils.evalInSandbox( js, sb );
	}catch(e){
		if( GTDDEBUGMODE ) alert("GTDInboxPage evalInSandbox\n" + e.toString() + "\n" + js);
		return;
	}
	
	if( typeof sb.result!="object" ) return;
	return sb.result;
	
};

/* 
	SETTINGS
	Localised to each email account. Called on page load.
*/

GTDInboxPage.prototype.saveSettings = function(tmpGmailDOM){
	
	tmpGmailDOM = tmpGmailDOM || this.gmailDOM;
		
	var fullSettings = gtdJson.parse( this.gtdinboxBrowser.options.getOption("char", "gtdinbox.settings", "{}") ) || {};
	var email = tmpGmailDOM.local("email-address");
	fullSettings[email] = this.settings;
	
	var s = gtdJson.stringify( fullSettings );
	this.gtdinboxBrowser.options.setOption( "char", "gtdinbox.settings", s );
}
GTDInboxPage.prototype.getSettings = function(){
	this.settings = gtdJson.parse( this.gtdinboxBrowser.options.getOption("char", "gtdinbox.settings", "{}") ) || {};
	
	var tmpGmailDOM = new GmailDOM(this, this._gmail);	// Instantiate new because of conflict with updated GmailDOM
	var email = tmpGmailDOM.local("email-address");
	if( !this.settings[email] ) this.settings[email] = {};
	this.settings = this.settings[email];	// pick the bit relevant to me
	
	
	var defaultSettings = this.createDefaultSettings();
	
	GIPROTOTYPE.extend(this.settings, defaultSettings);
	this.saveSettings(tmpGmailDOM);
		
};
GTDInboxPage.prototype.createDefaultSettings = function(){
	var defaultSettings = {};	// defaults
	defaultSettings.labels = {};
	defaultSettings.labels.types = {};
	defaultSettings.labels.types["Statuses"] = {prefix: "S/", defaults: {NextAction:'Next Action', Action:'Action', WaitingOn:'Waiting On', SomeDay:'Some Day', Finished:'Finished'}};
	defaultSettings.labels.types["Projects"] = {prefix: "P/"};
	defaultSettings.labels.types["Contexts"] = {prefix: "C/"};
	defaultSettings.labels.types["References"] = {prefix: "R/"};
	defaultSettings.labels.types["Old"] = {name:"Old Items", prefix: "Old/"};
	defaultSettings.labels.types["Misc"] = {prefix: ""};
	defaultSettings.labels.starForNextAction = false;
	defaultSettings.labels.onlyOneStatus = true;
	defaultSettings.async = {};
	defaultSettings.async.popupNewTab = false;
	defaultSettings.showHiders = {};
	defaultSettings.showHiders.rememberOpenClose = true;
	defaultSettings.labelSelect = {};
	defaultSettings.labelSelect.showHidersKeepClosed = {};
	defaultSettings.labelSelect.showHidersKeepClosed.Contexts = true;
	defaultSettings.labelSelect.showHidersKeepClosed.Projects = true;
	defaultSettings.labelSelect.showHidersKeepClosed.References = true;
	defaultSettings.labelSelect.showHidersKeepClosed.Old = true;
	defaultSettings.labelSelect.showHidersKeepClosed.Misc = true;
	defaultSettings.showLabelTreeNodes = {};
	defaultSettings.showLabelTreeNodes.rememberOpenClose = true;
	defaultSettings.remoteErrorCheck = {};
	defaultSettings.reviews = [];
	defaultSettings.reviews.push( {id:'lessThanOneWeek', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.LessThanOneWeek', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) after:<?=DaysAgo.7> -<?=DefaultStatus.Finished>', inbuilt:true} );
	defaultSettings.reviews.push( {id:'moreThanOneWeekLessThanOneMonth', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.MoreThanOneWeekLessThanOneMonth', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) before:<?=DaysAgo.7> after:<?=MonthsAgo.1> -<?=DefaultStatus.Finished>', inbuilt:true} );
	defaultSettings.reviews.push( {id:'moreThanOneMonth', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.MoreThanOneMonth', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) before:<?=MonthsAgo.1> -<?=DefaultStatus.Finished>', inbuilt:true} );
	defaultSettings.reviews.push( {id:'finishedLastThreeMonths', categoryKey:'Dashboard.Reviews.Categories.RecentComplete', titleKey:'Dashboard.Reviews.FinishedLastThreeMonths', search:'before:<?=MonthsAgo.3> <?=DefaultStatus.Finished>', inbuilt:true} );
	defaultSettings.ui = {};
	defaultSettings.ui.hide = {};
	defaultSettings.ui.inlineSelector = {};
	defaultSettings.ui.showCounts = {'Statuses':true};
	defaultSettings.searchBox = {};
	defaultSettings.searchBox.list = ["From,from:,prefix", "To,to:,prefix", "Files,has:attachment", "Inbox,in:inbox", "Sent,in:sent", "LastWeek,after:<?=DaysAgo.7>", "Actions,(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>)", "WaitingOn,<?=DefaultStatus.WaitingOn>"];
	
	
	return defaultSettings;
};
GTDInboxPage.prototype.install = function(reset){
try{
	var lastVersion = this.settings.lastVersion || 0;
	
	if( !reset && lastVersion==2.094 ) return;
	if( reset ) lastVersion = 0;
	
	
	if( lastVersion < 1.90 ){
		this.gtdinboxBrowser.options.setOption("char", "gtdinbox.debugMode", "1");
		}
	if( lastVersion < 1.94 ){
		this.settings.labels.starForNextAction = true;
		this.settings.labels.onlyOneStatus = true;
		this.settings.labels.types.Statuses.defaults.Finished = "Finished";
		
		var fAddLabel = GIPROTOTYPE.bind(this, function(){
			if( !this._labels.hasLabel( this.settings.labels.types.Statuses.prefix + "Finished" ) ){
				var finalCallback = GIPROTOTYPE.bind(this, function(){
					var el = this.gmailDOM.element("inbox-link");
					GIPROTOTYPE.doMouseEvent(this.doc, el, "click");	// refresh
				});
				//if( this.gmailDOM.local("at") ) this.gmailDOM.addLabel( this.settings.labels.types.Statuses.prefix + "Finished", null, finalCallback);
			}
		});
		setTimeout(fAddLabel, 4000);
		
		lastVersion = 1.94;
	}
	if( lastVersion < 1.98 ){
		this.settings.showLabelTreeNodes = {};
		this.settings.showLabelTreeNodes.rememberOpenClose = true;
		
		lastVersion = 1.98;
	}
	
	if( lastVersion < 2.00 ){
		
		if( !this.settings.labelSelect ) this.settings.labelSelect = {};
		this.settings.labelSelect.showHidersKeepClosed = {};
		this.settings.labelSelect.showHidersKeepClosed.Contexts = true;
		this.settings.labelSelect.showHidersKeepClosed.Projects = true;
		this.settings.labelSelect.showHidersKeepClosed.References = true;
		this.settings.labelSelect.showHidersKeepClosed.Old = true;
		this.settings.labelSelect.showHidersKeepClosed.Misc = true;
		lastVersion = 2.00;
	}
	
	if( lastVersion < 2.01 ){
		var fRow = GIPROTOTYPE.bind(this, function(statement){
				if( statement.getInt64(0)==5 ){	// All up to date with db already
					this.settings.lastDbVersion = 1.98;
				}
			});
		this.db.select( "Select count(name) as countName from SQLite_Master WHERE name = 'auto_labelled' OR name = 'thread_labels' OR name = 'recent_news_items' OR name = 'threads' OR name = 'labels'", fRow );
		this.gtdinboxBrowser.options.setOption("char", "gtdinbox.debugMode", "0");
		lastVersion = 2.01;
	}
	
	if( lastVersion < 2.02 ){
		this.settings.atLocation = null;
		
		lastVersion = 2.02;
	}
	
	if( lastVersion < 2.03 ){
		this.settings.remoteErrorCheck = {};
		lastVersion = 2.03;
	}
	
	if( lastVersion < 2.04 ){
		this.db.execute("DELETE FROM autoupdated_js");
		lastVersion = 2.04;
	}
	
	if( lastVersion < 2.08 ){
		var reviews = [];
		reviews.push( {id:'lessThanOneWeek', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.LessThanOneWeek', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) after:<?=DaysAgo.7> -<?=DefaultStatus.Finished>', inbuilt:true} );
		reviews.push( {id:'moreThanOneWeekLessThanOneMonth', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.MoreThanOneWeekLessThanOneMonth', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) before:<?=DaysAgo.7> after:<?=MonthsAgo.1> -<?=DefaultStatus.Finished>', inbuilt:true} );
		reviews.push( {id:'moreThanOneMonth', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.MoreThanOneMonth', search:'(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) before:<?=MonthsAgo.1> -<?=DefaultStatus.Finished>', inbuilt:true} );
		reviews.push( {id:'finishedLastThreeMonths', categoryKey:'Dashboard.Reviews.Categories.RecentComplete', titleKey:'Dashboard.Reviews.FinishedLastThreeMonths', search:'before:<?=MonthsAgo.3> <?=DefaultStatus.Finished>', inbuilt:true} );
		
		if( this.settings.reviews ){
			for( var i = 0; i < reviews.length; i++ ){
				this.settings.reviews.push( reviews[i] );
			}
		}else{
			this.settings.reviews = reviews;
		}
		
		lastVersion = 2.08;
	}
	
	if( lastVersion < 2.09 ){
		for( var i = 0; i < this.settings.reviews.length; i++ ){
			if( this.settings.reviews[i].id=="finishedLastThreeMonths" ){
				this.settings.reviews[i].search = "(<?=DefaultStatus.NextAction> OR <?=DefaultStatus.Action>) before:<?=MonthsAgo.1> -<?=DefaultStatus.Finished>";
				break;
			}
		}
		lastVersion = 2.09;
	}
	if( lastVersion < 2.091 ) lastVersion = 2.091;
	if( lastVersion < 2.092 ){
		
		this.settings.ui = {hide:{},inlineSelector:{}};	
		lastVersion = 2.092;
	}
	if( lastVersion < 2.093 ){
		var reviews = [];
		reviews.push( {id:'unread', categoryKey:'Dashboard.Reviews.Categories.AgingActions', titleKey:'Dashboard.Reviews.Unread', search:'is:unread', inbuilt:true} );
		
		if( this.settings.reviews ){
			for( var i = 0; i < reviews.length; i++ ){
				this.settings.reviews.push( reviews[i] );
			}
		}else{
			this.settings.reviews = reviews;
		}
		
		this.settings.ui.inlineSelector.Statuses = true;
		this.settings.ui.inlineSelector.RecentProjects = true;
		this.settings.ui.hideShowhidersAfterClick = true;
		
		lastVersion = 2.093;
	}
	if( lastVersion < 2.0931 ){
		
		if( !this.settings.ui ) this.settings.ui = {};
		if( !this.settings.ui.showCounts ) this.settings.ui.showCounts = {};
		this.settings.ui.showCounts.Statuses = true;
		this.settings.ui.showCounts.Projects = true;
		this.settings.ui.showCounts.Contexts = true;
		lastVersion = 2.0931;
	}
	if( lastVersion < 2.094 ){
		lastVersion = 2.094;
	}
	
	
	// Detect what update screen to show
	if( this.settings.welcomeMsgLastVersion ){	// Shown it before. Check version.
		if( (this.settings.welcomeMsgLastVersion < lastVersion) && (this.settings.lastVersion < 2.094) ){
			this.showMsg = "update";
		}
	}else{	// Never shown before
		if( this.gtdinboxBrowser.options.getOption("char", "Gtd.InstallOptionsComplete") ){	// install before
			this.showMsg = "updateFrom1";
		}else{
			this.showMsg = "setup";
		}
	}
	this.settings.welcomeMsgLastVersion = lastVersion;
	
		
	// Finally, record our update:
	this.gtdinboxBrowser.options.setOption("char", "gtdinbox.lastVersion", lastVersion);
	
	this.settings.lastVersion = lastVersion;
	this.saveSettings();
	
	this.installDb();
	
}catch(e){
	if( GTDDEBUGMODE ) alert("GtdinboxBrowser install\n" + e.toString());
}
};

GTDInboxPage.prototype.installDb = function(reset){
	
	var fRow = GIPROTOTYPE.bind(this, function(statement){
			if( statement.getInt64(0)<5 ){	// Corrupted database. Rebuild it.
				this.settings.lastDbVersion = 0;
			}
		});
	this.db.select( "Select count(name) as countName from SQLite_Master WHERE name = 'auto_labelled' OR name = 'thread_labels' OR name = 'recent_news_items' OR name = 'threads' OR name = 'labels'", fRow );
	
	var lastVersion = this.settings.lastDbVersion || 0;
	
	if( !reset && lastVersion==1.99 ) return;
	if( reset ) lastVersion = 0;
		
	if( lastVersion < 1.90 ){
	
		this.db.execute("DROP TABLE IF EXISTS project_label_activity");
		this.db.execute("CREATE TABLE project_label_activity (label VARCHAR(50) NOT NULL, thread VARCHAR(20) NOT NULL, contact VARCHAR(100) NOT NULL, date INTEGER)");
	
		this.createTable("auto_labelled", false, "label VARCHAR(255), msgid VARCHAR(25) NOT NULL", ["msgid, account"]);
		
		this.createTable("thread_labels", false, "thread VARCHAR(25), label VARCHAR(255)", null, ["thread, label"]);
		this.createTable("thread_contacts", false, "thread VARCHAR(25), contact VARCHAR(150), type INTEGER", null, ["thread, contact"]);	// type is 0: sender, 1: recipient	
			
		lastVersion = 1.90;
	}
	if( lastVersion < 1.93 ){
		this.createTable("contact_emails", false, "contact_name VARCHAR(150), contact_email VARCHAR(150)", null, ["contact_name, contact_email"]);
			
		lastVersion = 1.93;
	}
	if( lastVersion < 1.98 ){
		this.createTable("recent_news_items", false, "url VARCHAR(255)");
		lastVersion = 1.98;
	}
	if( lastVersion < 1.99 ){
		this.createTable("autoupdated_js", false, "filename VARCHAR(255), file TEXT");
		lastVersion = 1.99;
	}
	
	this.settings.lastDbVersion = lastVersion;
	this.saveSettings();
};

GTDInboxPage.prototype.createTable = function(name, useId, fields, indices, uniqueIndices){
	if( useId ) fields = "id INTEGER PRIMARY KEY AUTOINCREMENT, " + fields;
	fields += ", account VARCHAR(100), date INTEGER, session INTEGER, session_modified INTEGER";	// session/date used for server syncing; when it comes (upload, make sure both sessions are set. if update, set session_modified to null; and issue 'update' command when sent to server). 
	
	this.db.execute("DROP TABLE IF EXISTS " + name);
	this.db.execute("CREATE TABLE " + name + " (" + fields + ")");
	var ic = 0;
	if( indices ){
		for( var i = 0; i < indices.length; i++ ){
			this.db.execute("CREATE INDEX " + name + "_idx" + ic++ + " ON " + name + "(" + indices[i] + ")");
		}
	}
	if( uniqueIndices ){
		for( var i = 0; i < uniqueIndices.length; i++ ){
			this.db.execute("CREATE UNIQUE INDEX " + name + "_idx" + ic++ + " ON " + name + "(" + uniqueIndices[i] + ")");
		}
	}
};




GTDInboxPage.prototype.unload = function(){
	// Clear up variables
	try{
	
	if( !this.doc && !this.browser ) return;

	if( this._threadList ) this._threadList.destroy();
	this._threadList = null;
	if( this._labels ) this._labels.destroy();
	if( this._threadListUI ) this._threadListUI.destroy();
	this.eventObservers.destroy();
	if( this._asyncPopuper ) this._asyncPopuper.destroy();
	if( this._contactFilterPopuper ) this._contactFilterPopuper.destroy();
	if( this._filterEnvironment ) this._filterEnvironment.destroy();
	if( this._environment ) this._environment.destroy();
	if( this._composeUI ) this._composeUI.destroy();
	if( this._conversationUI ) this._conversationUI.destroy();
	if( this._lightbox ) this._lightbox.destroy();
	if( this._dashboard ) this._dashboard.destroy();
	if( this._autoLabel ) this._autoLabel.destroy();

	this.browser.gtdinboxPage = null;
	delete this.browser.gtdinboxPage;
	
	this.unsafeWindow = null;
	this.gtdinboxBrowser = null;
	this.window = null;
	this.tab = null;
	this.browser = null;
	this.doc = null;

	}catch(e){if( GTDDEBUGMODE ) alert("gtdinboxPage unload\n" + e.toString())}
};

