function GtdServer(gtdinboxPage, userAuthKey){
	this._gtdinboxPage = gtdinboxPage;
	this._userAuthKey = userAuthKey;
	this._xmlHttpRequest = new GIXMLHttpRequest(gtdinboxPage);
	this._rootUrl = "http://quux.foo-bar.biz/";	// TODO 
}

GtdServer.prototype.userAuthKey = function(v){
	if( typeof v=="undefined" ) return this._userAuthKey;
	this._userAuthKey = v;
};

GtdServer.prototype.createUserAuthKey = function(email, password, autoApprove){
	userAuthKey = "Basic " + GtdBase64.encode(email + ":" + password);
	if( autoApprove ) this._userAuthKey = userAuthKey;
	return userAuthKey;
};

GtdServer.prototype.verifyUserAuthKey = function(userAuthKey, fCallback){
	userAuthKey = userAuthKey || this._userAuthKey;
	
	var fSuccess = function(req){
			fCallback(true,req);
		};
	var fFail = function(req){
			fCallback(false,req);
		};
	var url = this._rootUrl + "downloads/latest";
	var params = {headers:{"Authorization":userAuthKey, "Accept":"application/json"}};
	this._xmlHttpRequest.process(url, params, fSuccess, fFail);
};

GtdServer.prototype.getSettings = function(fCallback, userAuthKey){
	userAuthKey = userAuthKey || this._userAuthKey;
	var fSuccess = function(req){
		var o = this._gtdinboxPage.safelyEval(req.responseText);
		fCallback(o);
	};
	var fFail = function(req){ fCallback(null) };
	
	var url = this._rootUrl + "parameters/gtdsettings";
	var params = {headers:{"Authorization":userAuthKey, "Accept":"application/json"}};
	this._xmlHttpRequest.process(url, params, fSuccess, fFail);
};

GtdServer.prototype.uploadSettings = function(settings, fCallback, userAuthKey){
	userAuthKey = userAuthKey || this._userAuthKey;
	// See if it already exists
	this.getSettings( GIPROTOTYPE.bind(this, function(success, req){
			var url = this._rootUrl;
			var params = null;
			if( success ){	// exists
				url += "parameters/gtdsettings";
				params = {type:"PUT", data:"data=" + gtdJson.stringify(settings)};
			}else{
				url += "parameters";
				params = {type:"POST", data:"token=gtdsettings&data=" + gtdJson.stringify(settings)};
			}
			params.headers = {"Authorization":userAuthKey, "Accept":"application/json"};
						
			var fSuccess = function(req){
				if( fCallback ) fCallback(true);
			};
			var fFail = function(req){ if( fCallback ) fCallback(false); };

			this._xmlHttpRequest.process(url, params, fSuccess, fFail);
		}));
	
};

GtdServer.prototype.getLatestReleases = function(fCallback, userAuthKey){
	/*
		{
			"version3Beta": {
				"displayVersion": "1.4", 
				"updatedAt": "June 21, 2008 14:50", 
				"url": "http://localhost:8080/uploaded_files/0000/0017/filethis.txt", 
				"createdAt": "June 21, 2008 14:50", 
				"id": 17, 
				"version": "1.4", 
				"description": "a file", 
				"filename": "filethis.txt"
			}, 
			"release21Beta": {
				"displayVersion": "1.9.4", 
				"updatedAt": "June 15, 2008 16:13", 
				"url": "http://localhost:8080/uploaded_files/0000/0013/yslow-0.9.4-fx.xpi", 
				"createdAt": "March 23, 2008 02:45", 
				"id": 13, 
				"version": "1.94", 
				"description": "another fucking update to the beta", 
				"filename": "yslow-0.9.4-fx.xpi"
			}
		}
	*/
	userAuthKey = userAuthKey || this._userAuthKey;
	var fSuccess = function(req){
		var o = this._gtdinboxPage.safelyEval(req.responseText);
		fCallback(o);
	};
	var fFail = function(req){ fCallback(null) };
	
	var url = this._rootUrl + "downloads/latest";
	var params = {headers:{"Authorization":userAuthKey, "Accept":"application/json"}};
	this._xmlHttpRequest.process(url, params, fSuccess, fFail);
};

