function InlineLabelSelector(gtdinboxPage, title){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = this._gtdinboxPage.doc;
	this._title = title;

try{	
	
	this.el = this._doc.createElement("DIV");
	this.el.className = "labels label-selector-quickchoices";
	
	this.elTitle = this._doc.createElement("DIV");
		this.elTitle.className = "label-quickchoice-title";
		this.elTitle.innerHTML = title;
	this.el.appendChild( this.elTitle );
	
	this.elLabels = this._doc.createElement("DIV");
		this.elLabels.className = "label-selector-quickchoices-labels";
	this.el.appendChild( this.elLabels );
	
	var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
	this.el.appendChild( elClear );
	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("InlineLabelSelector create\n" + e.toString());
}
	
};

InlineLabelSelector.prototype.refresh = function(labels, prefix){
	// labels is an array of label strings to display
	
try{
	if( !prefix ) prefix = "";
	
	this.elLabels.innerHTML = "";
	if( labels.length==0 ){
		this.el.style.display = "none";
	}else{
		this.el.style.display = "";
		for( var i = 0; i < labels.length; i++ ){
			var elLabel = this._doc.createElement("DIV");
			elLabel.innerHTML = labels[i].replace(prefix,"");
			elLabel.setAttribute("gtdname", labels[i].replace(prefix,""));
			elLabel.setAttribute("gtdlabelname", labels[i]);
			elLabel.className = "label-quickchoice";
			this.elLabels.appendChild( elLabel ); 
			if( i < (labels.length-1) ){
				var elSplit = this._doc.createElement("DIV");
					elSplit.className = "label-quickchoice-split";
					elSplit.innerHTML = ", ";
				this.elLabels.appendChild( elSplit );
			}
		};
		var elClear = this._doc.createElement("DIV");
		elClear.style.clear = "both";
		this.elLabels.appendChild( elClear );
	}

}catch(e){
	if( GTDDEBUGMODE ) alert("InlineLabelSelector refresh\n" + e.toString());
}
};

InlineLabelSelector.prototype.destroy = function(){
	this._gtdinboxPage = null;
	this._doc = null;
};