/* Copyright Andy Mitchell 2007. No warranties */

function LabelSelectUI(gtdinboxPage, elParent, createWithAjax, threadActions, hideNewLabel ){
	this.gtdinboxPage = gtdinboxPage;
	this.doc = gtdinboxPage.doc;
	this.settings = gtdinboxPage.settings;
	this._labels = gtdinboxPage._labels;
	this.GtdEventObservers = new GtdEventObservers(this);
	this.eventHandlers = new GtdEventHandlers_Mutator(this);
	this._showHiders = [];
	this._inlineSelectors = [];
	this._optionsShortList = {maxSelected:100, maxBody:100, maxRecentByName:3, maxRecent:3};
	this._createWithAjax = createWithAjax;
	this._threadActions = threadActions;
	this._hideNewLabel = hideNewLabel || false;
	
	
	this._labelActiveHash = {};
	this._types = [];
	for( t in this.settings.labels.types ){
		if( t!="Old" ) this._types.push(t);
	}

	this.create(elParent);
}


LabelSelectUI.prototype.create = function(elParent){

	this.el = this.doc.createElement("DIV");
		this.el.className = "label-selector";
	if( elParent ) elParent.appendChild( this.el );
	
	//this.inlineStatuses = new InlineLabelSelector(this.gtdinboxPage, this.gtdinboxPage.stringBundle.getString("LabelSelectUI.Statuses") );
	//this.el.appendChild( this.inlineStatuses.el );
	/*
	this.elStatusesContainer = this.doc.createElement("DIV");
		this.elStatusesContainer.className = "labels label-selector-quickchoices label-selector-statuses";
		this.elStatusesContainer.innerHTML = "<div class='label-quickchoice-title'>" + this.gtdinboxPage.stringBundle.getString("LabelSelectUI.Statuses") + ": </div>";
	
	this.elStatuses = this.doc.createElement("DIV");
		this.elStatuses.className = "label-selector-quickchoices-labels";
	this.elStatusesContainer.appendChild( this.elStatuses );
	var elClear = this.doc.createElement("DIV");
		elClear.style.clear = "both";
	this.elStatusesContainer.appendChild( elClear );
	*/
	
	//this.inlineRecentProjects = new InlineLabelSelector(this.gtdinboxPage, this.gtdinboxPage.stringBundle.getString("LabelSelectUI.RecentProjects") );
	//this.el.appendChild( this.inlineRecentProjects.el );
	
	/*
	this.elRecentProjectsContainer = this.doc.createElement("DIV");
		this.elRecentProjectsContainer.className = "labels label-selector-quickchoices label-selector-recent-projects";
		this.elRecentProjectsContainer.innerHTML = "<div class='label-quickchoice-title'>" + this.gtdinboxPage.stringBundle.getString("LabelSelectUI.RecentProjects") + ": </div>";
	this.el.appendChild( this.elRecentProjectsContainer );
	this.elRecentProjects = this.doc.createElement("DIV");
		this.elRecentProjects.className = "label-selector-quickchoices-labels";
	this.elRecentProjectsContainer.appendChild( this.elRecentProjects );
	var elClear = this.doc.createElement("DIV");
		elClear.style.clear = "both";
	this.elRecentProjectsContainer.appendChild( elClear );
	*/
	
	this.elInlineSelectors = this.doc.createElement("DIV");
		this.elInlineSelectors.className = "inline-selectors";
	this.el.appendChild( this.elInlineSelectors );
	
	this.elCombos = this.doc.createElement("DIV");
		this.elCombos.className = "showhider-combos";
	this.el.appendChild( this.elCombos );
	
	this.elActionsContainer = this.doc.createElement("DIV");
		this.elActionsContainer.className = "actions";
	this.el.appendChild( this.elActionsContainer );
	if( !this._hideNewLabel ){
		this.elCreate = this.doc.createElement("BUTTON");
			this.elCreate.innerHTML = this.gtdinboxPage.stringBundle.getString("LabelSelectUI.NewLabel");
			this.elCreate.className = "create-label";
			this.GtdEventObservers.observe(this.elCreate, "click", this.clickCreate, false);
		this.elActionsContainer.appendChild( this.elCreate );
		
	}
	var elClear = this.doc.createElement("DIV");
		elClear.style.clear = "both";
	this.el.appendChild( elClear );
	
	this.GtdEventObservers.observe( this.el, "mousedown", this.clickLabel, false);
	
	this.refresh();
};


LabelSelectUI.prototype.refresh = function(thread){
	try{
		if( thread ){
			this.thread = thread;
			this._optionsShortList.thread = thread;
		}
		
		// Rebuild UI
		if( this._lastRefresh && this._labels._lastRefresh && this._labels._lastRefresh<=this._lastRefresh ){	// No change to labels. Just remove any selections (and update Recent)
			
		}else{
			//this.inlineStatuses.refresh( this._labels.getLabelsArray("Statuses", true), this.gtdinboxPage.settings.labels.types.Statuses.prefix);
			/*
			this.elStatuses.innerHTML = "";
			var statusLabels = this._labels.getLabelsArray("Statuses", true); 
			if( statusLabels.length==0 ){
				this.elStatusesContainer.style.display = "none";
			}else{
				this.elStatusesContainer.style.display = ""
				var statusPrefix = this.gtdinboxPage.settings.labels.types.Statuses.prefix;
				for( var i = 0; i < statusLabels.length; i++ ){
					var elStatus = this.doc.createElement("DIV");
					elStatus.innerHTML = statusLabels[i].replace(statusPrefix,"");
					elStatus.setAttribute("gtdname", statusLabels[i].replace(statusPrefix,""));
					elStatus.setAttribute("gtdlabelname", statusLabels[i]);
					elStatus.className = "label-quickchoice";
					this.elStatuses.appendChild( elStatus );
					if( i < (statusLabels.length-1) ){
						var elSplit = this.doc.createElement("DIV");
							elSplit.className = "label-quickchoice-split";
							elSplit.innerHTML = ", ";
						this.elStatuses.appendChild( elSplit );
					}
				};
				var elClear = this.doc.createElement("DIV");
				elClear.style.clear = "both";
				this.elStatuses.appendChild( elClear );
			}
			*/
		
			for( var i = 0; i < this._showHiders.length; i++ ) this._showHiders[i].destroy();
			this._showHiders.length = 0;
			for( var i = 0; i < this._inlineSelectors.length; i++ ) this._inlineSelectors[i].destroy();
			this._inlineSelectors.length = 0;
			this.elInlineSelectors.innerHTML = "";
			this.elCombos.innerHTML = "";
			var types = GIPROTOTYPE.clone(this._types);
			for( var i = 0; i < types.length; i++ ){
				var t = types[i];
				if( t=="Statuses" ) types.splice(i+1, 0, "RecentProjects");
					if( this.gtdinboxPage.settings.ui.inlineSelector[t] ){
						var inlineSelector = null;
						if( t=="RecentProjects" ){
							inlineSelector = new InlineLabelSelector(this.gtdinboxPage, this.gtdinboxPage.stringBundle.getString("Labels.RecentProjects") ); 
							inlineSelector.refresh( this._labels.getRecentProjectLabels(this._optionsShortList) );
							this.uiRecentProjects = {'inlineSelector':inlineSelector};
						}else{
							inlineSelector = new InlineLabelSelector(this.gtdinboxPage, this.gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + t, t) ); 
							inlineSelector.refresh( this._labels.getLabelsArray(t, true), this.gtdinboxPage.settings.labels.types[t].prefix );
						}
						this.elInlineSelectors.appendChild( inlineSelector.el );
						this._inlineSelectors.push( inlineSelector );
					}else{
						var elLabels = null; 
						if( t=="RecentProjects" ){
							elLabels = this.doc.createElement("DIV");
							elLabels.className = "labels-group";
							elLabels.innerHTML = "<div class='title'>" + this.gtdinboxPage.stringBundle.getString("Labels.RecentProjects") + "</div><div class='labels'></div>";
						}else{
							elLabels = this._labels.getLabelsEl(t);
						}
						var showHider = new ShowhiderCombo(this.gtdinboxPage, "label-" + t, {doc:this.doc, type:"attach", el:elLabels, titleClass:"title", show:true});
						showHider.labelTypeName = t;
						elLabels.style.display = (showHider.elContent.innerHTML.length==0)? "none" : "";
						this.elCombos.appendChild( showHider.el );
						this._showHiders.push( showHider );
						if( t=="RecentProjects" ) this.uiRecentProjects = {'showHider':showHider};
					}
				//}
			}
			this._lastRefresh = (new Date()).valueOf();
		}
		
		// Rebuild Recent Projects
		if( this.uiRecentProjects ){
			var recentLabels = this._labels.getRecentProjectLabels(this._optionsShortList);
			if( this.uiRecentProjects.inlineSelector ){
				if( recentLabels.length==0 ){
					this.uiRecentProjects.inlineSelector.el.style.display = "none";
				}else{
					this.uiRecentProjects.inlineSelector.el.style.display = "";
					this.uiRecentProjects.inlineSelector.refresh( recentLabels );
				}
			}else if( this.uiRecentProjects.showHider ){
				if( recentLabels.length==0 ){
					this.uiRecentProjects.showHider.el.style.display = "none";
				}else{
					this.uiRecentProjects.showHider.el.style.display = "";
					this.uiRecentProjects.showHider.elContent.innerHTML = "";
					for( var i = 0; i < recentLabels.length; i++ ){
						var el = this.doc.createElement("DIV");
							el.className = "label";
							el.setAttribute("gtdLabelName", recentLabels[i]);
							el.setAttribute("gtdLabelFullName", recentLabels[i]);
							el.innerHTML = recentLabels[i];
						this.uiRecentProjects.showHider.elContent.appendChild(el);
					}
					var elClear = this.doc.createElement("DIV");
					elClear.style.clear = "both";
					this.uiRecentProjects.showHider.elContent.appendChild( elClear );
				}
				
			}
		}
		
		//this.inlineRecentProjects.refresh( this._labels.getRecentProjectLabels(this._optionsShortList) );
		
		/*
		this.elRecentProjects.innerHTML = "";
		var labels = this._labels.getRecentProjectLabels(this._optionsShortList);
		if( labels.length==0 ){
			this.elRecentProjectsContainer.style.display = "none";
		}else{
			this.elRecentProjectsContainer.style.display = "";
			for( var i = 0; i < labels.length; i++ ){
				var el = this.doc.createElement("DIV");
					el.className = "label-quickchoice";
					el.setAttribute("gtdLabelName", labels[i]);
					el.setAttribute("gtdLabelFullName", labels[i]);
					el.innerHTML = labels[i];
				this.elRecentProjects.appendChild(el);
				
				if( i < (labels.length-1) ){
					var elSplit = this.doc.createElement("DIV");
						elSplit.className = "label-quickchoice-split";
						elSplit.innerHTML = ", ";
					this.elRecentProjects.appendChild( elSplit );
				}
			}
			var elClear = this.doc.createElement("DIV");
			elClear.style.clear = "both";
			this.elRecentProjects.appendChild( elClear );
		}
		*/
		
		/*
		var showHiderProject = this.getShowHiderByType("Projects");
		if( showHiderProject ){
			var elLabelsProject = showHiderProject.elContent;
			// Strip out old:
			for( var i = elLabelsProject.childNodes.length - 1; i >= 0; i-- ){
				if( GIPROTOTYPE.hasClassName( elLabelsProject.childNodes[i], "recent-project" ) ){
					elLabelsProject.removeChild( elLabelsProject.childNodes[i] );
				}
			}
			// Add new:
			var labels = this._labels.getRecentProjectLabels(this._optionsShortList);
			if( labels.length > 0 ){
				var firstChild = elLabelsProject.firstChild;
				var el = this.doc.createElement("DIV");
					el.className = "title recent-project";
					el.innerHTML = "Recent Projects";
				elLabelsProject.insertBefore( el, firstChild );
				for( var i = 0; i < labels.length; i++ ){
					var el = this.doc.createElement("DIV");
						el.className = "label recent-project";
						el.setAttribute("gtdLabelName", labels[i]);
						el.setAttribute("gtdLabelFullName", labels[i]);
						el.innerHTML = labels[i];
					elLabelsProject.insertBefore( el, firstChild );
				}
				var el = this.doc.createElement("DIV");
					el.className = "title recent-project";
					el.innerHTML = "Projects";
				elLabelsProject.insertBefore( el, firstChild );
			}
		}
		*/
		
		// Choose selected:
		if( this.thread ) this.selected( this.thread.labels );
		
		
	}catch(e){
		if( GTDDEBUGMODE ) alert("labelselectui refresh\n" + e.toString());
	}
};

LabelSelectUI.prototype.getShowHiderByType = function(t){
	for( var i = 0; i < this._showHiders.length; i++ ){
		if( this._showHiders[i].labelTypeName==t ){
			return this._showHiders[i];
		}
	}
};
LabelSelectUI.prototype.getLabelsByName = function(labelname){
	// Use XPath to get the label
	var labelsList = this.doc.evaluate( "//div[starts-with(@class,'label-selector')]//div[starts-with(@class,'labels')]//div[@gtdlabelname='" + labelname + "']", this.doc.body, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var labelEls = [];
	for( var i = 0; i < labelsList.snapshotLength; i++ ) labelEls.push( labelsList.snapshotItem(i) );
	return labelEls;
};

LabelSelectUI.prototype.clickLabel = function(event){
	if( event.button!=0 ) return;
	
	var hadLastEventDetail = this._lastEventDetail;
	this._lastEventDetail = event.detail;
	if( !hadLastEventDetail ) setTimeout( GIPROTOTYPE.bind(this, function(){this.processClickLabel(event)}), 200 );
};
LabelSelectUI.prototype.processClickLabel = function(event){
	// Broadcast to subscribers the label that was clicked
try{
	
	var el = GIPROTOTYPE.element(event);
	
	var lastEventDetail = this._lastEventDetail;
	this._lastEventDetail = null;
	
	var label = {name:el.getAttribute("gtdName"), labelname:el.getAttribute("gtdLabelName"), 'el':el, doubleClick:(lastEventDetail>1)}
	if( !label.labelname ) return;
	this.eventHandlers.broadcast("click-label", label);
	
	if( this._showHiders["Statuses"] ) this._showHiders["Statuses"]._show(false);
	
	if( this.settings.ui.hideShowhidersAfterClick ) for( var i = 0; i < this._showHiders.length; i++ ) this._showHiders[i]._show(false);	// hide the show hiders	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("labelselectui clickLabel\n" + e.toString());
}
};

LabelSelectUI.prototype.selected = function(labels){

try{
	
	if( typeof labels=="undefined" ){
		this.refreshShowHiderTitles();
		var clabels = [];
		for( label in this._labelActiveHash ) clabels.push(label);
		return clabels;
	}
	if( typeof labels=="string" ){
		labels = [labels];
	}
	
	var cHash = {};
	for( label in this._labelActiveHash ) cHash[label] = true;
	
	var typeCount = {};
	
	for( var i = 0; i < labels.length; i++ ){
		for( var j = 0; j < this._types.length; j++ ){
			if( labels[i].indexOf(this.gtdinboxPage.settings.labels.types[this._types[j]].prefix)==0 ){	
				if( typeCount[this._types[j]] ){
					typeCount[this._types[j]].count++;
					typeCount[this._types[j]].lastLabel = labels[i];
				}else{
					typeCount[this._types[j]] = {count:1, lastLabel: labels[i]};
				}
			}
		}
		
		
		if( cHash[labels[i]] ){	// exists, strip it from known hash
			delete cHash[labels[i]];
		}
		// Create (or refresh existing - because in 2d array)
		var elLabels = this.getLabelsByName(labels[i]);
		if( elLabels ){
			for( var j = 0; j < elLabels.length; j++ ){
				GIPROTOTYPE.addClassName( elLabels[j], "selected" );
			}
			this._labelActiveHash[labels[i]] = true;
		}
	}
	
	// Everything remaining in cHash is to be removed
	for( l in cHash ){
		if( this._labelActiveHash[l] ){
			var elLabels = this.getLabelsByName(l);
			if( elLabels ){
				for( var j = 0; j < elLabels.length; j++ ){
					GIPROTOTYPE.removeClassName( elLabels[j], "selected" );
				}
			}
			delete this._labelActiveHash[l];
		}
	}
	
	// Update show hiders:
	this.refreshShowHiderTitles(typeCount);
	
}catch(e){
	if( GTDDEBUGMODE ) alert("labelsui selected\n" + e.toString());
}
};
LabelSelectUI.prototype.refreshShowHiderTitles = function(typeCount){
	for( var j = 0; j < this._types.length; j++ ){
		var t = this._types[j];
		var showHider = this.getShowHiderByType(t);
		if( showHider ){
			if( typeCount && typeCount[t] ){
				if( typeCount[t].count==1 && t=="Statuses" ){
					showHider.setTitle( typeCount[t].lastLabel );
				}else{
					showHider.setTitle( this.gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + t, t) + " (" + typeCount[t].count + ")" );
				}
				GIPROTOTYPE.addClassName(showHider.elTitleTxt, "selected");
			}else{
				showHider.setTitle( this.gtdinboxPage.stringBundle.getStringSafe("Labels.Types." + t, t) );
				GIPROTOTYPE.removeClassName(showHider.elTitleTxt, "selected");
			}
		}
	}
};


LabelSelectUI.prototype.clickCreate = function(event){
	if( this._createWithAjax ){
		this.gtdinboxPage._moreActionsMenu.createLabelAjax();
	}else{
		this.gtdinboxPage._moreActionsMenu.createLabel();
	}
};

LabelSelectUI.prototype.destroy = function(){
	this.GtdEventObservers.destroy();
	this.eventHandlers.destroy();
	
	this.gtdinboxPage = null;
	this.doc = null;
	this.settings = null;
	this._labels = null;
	
	for( var i = 0; i < this._showHiders.length; i++ ) this._showHiders[i].destroy();
	for( var i = 0; i < this._inlineSelectors.length; i++ ) this._inlineSelectors[i].destroy();
	
	this._elLabelHash = null;
	this._labelActiveHash = null;
	this._elContainers = null;
	this._types = null;
};
