function MoreActionsMenu(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._eventObservers = new GtdEventObservers(this);
	this._eventHandlers = new GtdEventHandlers_Mutator(this);
	this._doc = gtdinboxPage.doc;
	this._multiToOne = new MultiToOne(gtdinboxPage, 100);
	
	this._queue = new GtdQueue(gtdinboxPage);
	
	this._customEntries = [];
	
	
	this._eventObservers.observe(this._doc, "keydown", function(event){
			if( event.keyCode==190) setTimeout(GIPROTOTYPE.bind(this, this.refresh), 1000);
		}, false);
	
}

MoreActionsMenu.prototype.viewChange = function(gmail){

try{
	
	if( this.elAlertBox ) this._eventObservers.stopObserving( this.elAlertBox, "DOMNodeInserted", this.alertBoxChange, false );
	this.elAlertBox = this._gtdinboxPage.gmailDOM.element("alert-box");
	this._eventObservers.observe( this.elAlertBox, "DOMNodeInserted", this.alertBoxChange, false );
	

	this._customEntries.length = 0; // Clear out. Means MoreActionsMenu viewChange must go first.
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu viewChange\n" + e.toString());
}

try{
	if( this.elMoreActionsCombo ){
		this._eventObservers.stopObserving( this.elMoreActionsCombo, "click", this.moreActionsComboClick, false );
		this._eventObservers.stopObserving( this.elMoreActionsCombo, "mousedown", this.restoreScrollTop, true);
	}
	if( this.elMoreActionsComboBottom ) this._eventObservers.stopObserving( this.elMoreActionsComboBottom, "click", this.moreActionsComboClick, false );
	
	
	this.elMoreActionsCombo = this._gtdinboxPage.gmailDOM.element("action-combo");
	this.elMoreActionsComboBottom = this._gtdinboxPage.gmailDOM.element("action-combo-bottom");
	
	this._eventObservers.observe( this.elMoreActionsCombo, "click", this.moreActionsComboClick, false );
	this._eventObservers.observe( this.elMoreActionsCombo, "mousedown", this.restoreScrollTop, true);
	this._eventObservers.observe( this.elMoreActionsComboBottom, "click", this.moreActionsComboClick, false ); // faulty line
	
	this._eventHandlers.broadcast("view-change");
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu viewChange 1\n" + e.toString());
}

};


MoreActionsMenu.prototype.moreActionsComboClick = function(event){

try{
	var fInhibitContextClick = GIPROTOTYPE.bindAsEventListener(this, function(event){
		if( event.button==2 ){
			GIPROTOTYPE.stop(event);
		}
		});
	var callback = GIPROTOTYPE.bind(this, function(){
		try{
			var result = this._gtdinboxPage.gmailDOM.elements("action-combo-lists");
			for( var i = 0; i < result.snapshotLength; i++ ){
				var el = result.snapshotItem(i);
				
				this._eventObservers.stopObserving( el, "click", this.moreActionsComboListClick, true );
				this._eventObservers.observe( el, "click", this.moreActionsComboListClick, true );
				this._eventObservers.observe( el, "mouseup", fInhibitContextClick, true);
				this.refresh(null, el);
			}
			this.elMoreActionsList = result.snapshotItem(0);
			
			this._eventHandlers.broadcast("actions-combo-click");
			
		}catch(e){
			if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboClick callback\n" + e.toString());
		}
	});
	//setTimeout(callback, 100);
	callback();
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboClick\n" + e.toString());
}


};

MoreActionsMenu.prototype.moreActionsComboListClick = function(event){

try{

	// Find the element clicked 
	var el = GIPROTOTYPE.element(event);
	
	var ceId = el.getAttribute("gtd-more-actions-id");
	if( ceId ){	// Find the associated callback
		for( var i = 0; i < this._customEntries.length; i++ ){
			if( this._customEntries[i].id==ceId && this._customEntries[i].callback ){
				this._customEntries[i].callback();
				break;
			}
		}
	}
	
	
	// Determine if label
	var label = el.innerHTML.replace(/<.+?>/g,"");
	var safelabel = label.replace(/\"/g, "\\\"");
	var act = el.getAttribute("act") || 0;
	if( !safelabel || !(act==12 || act==13) ){
		return;
	}

	this._eventHandlers.broadcast("actionlist-manual-click", {'label':label, 'act':act, 'safelabel':safelabel});
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu moreActionsComboListClick\n" + e.toString());
}
};



MoreActionsMenu.prototype.clickActionCombo = function(){
try{
	// Used to turn it off
	this._currentScrollTop = this._gtdinboxPage.gmailDOM.element("document").documentElement.scrollTop;
	GIPROTOTYPE.doMouseEvent(this._doc, this.elMoreActionsCombo, "mousedown");
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu clickActionCombo\n" + e.toString());
}
};
MoreActionsMenu.prototype.restoreScrollTop = function(event){

try{
	if( isNaN(this._currentScrollTop) ) return;
	this._gtdinboxPage.gmailDOM.element("window").scrollTo(0, this._currentScrollTop);
	this._currentScrollTop = null;	// make sure it doesn't start jumping after this
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu restoreScrollTop\n" + e.toString());
}
};

MoreActionsMenu.prototype.doMoreAction = function(f, forceOff, forceRemainOn){
try{
	
	this.elMoreActionsCombo = this._gtdinboxPage.gmailDOM.element("action-combo");
	this.clickActionCombo();
	this.elMoreActionsList = this._gtdinboxPage.gmailDOM.element("action-combo-list");
	if( this.elMoreActionsList ){
		this.elMoreActionsList.style.display = "none";
		
		var found = false;
		var children = this.elMoreActionsList.childNodes;
		for( var i = 0; i < children.length; i++ ){
			var el = children[i];
			if( f(el) ){
				found = true;
				break;
			}
		}
		
		if( (!found || forceOff) && !forceRemainOn ){
			//this.clickActionCombo();
			//GIPROTOTYPE.doMouseEvent(this._doc, this._doc.body, "mousedown");
			
			this.clickActionCombo();
			setTimeout( GIPROTOTYPE.bind(this, function(){
					GIPROTOTYPE.doMouseEvent(this._doc, this._doc.body, "mousedown");
				}), 100 );
			
		}
	}
	return found;
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu doMoreAction\n" + e.toString());
}
};








MoreActionsMenu.prototype.customEntries = function(v){
	if( typeof v=="undefined" ) return this._customEntries;
	
	if( a instanceof Array ) this._customEntries = a;
};

MoreActionsMenu.prototype.addCustomEntry = function(id, name, tooltip, callback){
	this._customEntries.push( {'id':id, 'name':name, 'tooltip':tooltip, 'callback':callback} );
};

MoreActionsMenu.prototype.removeCustomEntry = function(id){
	for( var i = 0; i < this._customEntries.length; i++ ){
		if( this._customEntries[i].id==id ){
			this._customEntries.splice(i,1);
			return;
		}
	}
};

MoreActionsMenu.prototype.refresh = function(event, elCombo){
try{
	if( !elCombo ) elCombo = GIPROTOTYPE.element(event);
	if( !elCombo ) elCombo = this._gtdinboxPage.gmailDOM.element("action-combo-list");
	if( !elCombo ) return;
	
	// Change height
	var dims = GIPROTOTYPE.viewport(this._doc, this._doc.defaultView, false );
	if( dims[1] > 600 ) elCombo.style.height = "400px";
	if( dims[1] > 800 ) elCombo.style.height = "600px";
		
	var fCreateTitle = GIPROTOTYPE.bind(this, function(name){
			var elTitle = this._doc.createElement("DIV");
			elTitle.innerHTML = name;
			elTitle.style.marginLeft = "12px";
			elTitle.style.padding = "2px 0px 2px 0px";
			elTitle.style.textIndent = "0px";
			elTitle.style.color = "#999999";
			elTitle.style.fontSize = "0.9em";
			elTitle.style.marginTop = "12px";
			elTitle.style.backgroundColor = "#eeeeee";
			return elTitle;
		});
	
	var fCreateEntry = GIPROTOTYPE.bind(this, function(elChild, id, name, tooltip, customClassName){
			if( !customClassName ) customClassName = "SenFne more-actions-line-item";
			var elLi = this._doc.createElement("DIV");
				elLi.className = customClassName;
				elLi.innerHTML = name;
				elLi.title = tooltip;
				elLi.setAttribute("gtd-more-actions-id", id);
				elCombo.insertBefore( elLi, elChild );
			return elLi;
		});
	
	var elChild = null;
	var elLastChild = null;
	var labelName = "";
	var labelTypes = this._gtdinboxPage.settings.labels.types;
	var elFirstItem = null;
	var statuses = {};
	var misc = [];
	var currentType = null;
	var foundPrefix = false;
	
	
	
	var childList = [];
	for( var i = 0; i < elCombo.childNodes.length; i++ ) childList[i] = elCombo.childNodes[i];	// CLone to stop it changing order on updates
	for( var i = 0; i < childList.length; i++ ){
		elChild = childList[i];
		if( this._gtdinboxPage.gmailDOM.test("is-more-action-apply-label", elChild) ){	// Add custom entries // elChild.getAttribute("act")=="3"
			if( this._customEntries.length > 0 ){
				fCreateEntry(elChild, "", this._gtdinboxPage.stringBundle.getString("MoreActions.GTDHeader"), null, "more-actions-gtd-header");
				i++;
				
				for( var j = 0; j < this._customEntries.length; j++ ){
					var ce = this._customEntries[j];
					fCreateEntry( elChild, ce.id, ce.name, ce.tooltip );
					i++;
				}
			}
		}
		
		
		if( elChild.getAttribute("act")=="12" ){
			if( !elFirstItem ) elFirstItem = elChild;
			labelName = elChild.innerHTML.replace(/<[^>]+>/g, "");
			elChild.setAttribute("gtdLabelName", labelName);
			// Strip prefix:
			foundPrefix = false;
			for( t in labelTypes ){
				if( labelName.indexOf( labelTypes[t].prefix )==0 ){	// Has known prefix
					labelName = labelName.replace(labelTypes[t].prefix, "");
					if( !currentType || labelTypes[currentType].prefix!=labelTypes[t].prefix ){	// changed types; add Title
						currentType = t;
						var elTitle = fCreateTitle(t);
						statuses["__gtdTitle"] = elTitle;
						//if( t=="Statuses" ){	// Found first status
						//	elChild.parentNode.insertBefore(elTitle, elFirstItem);
						//}else{
							elChild.parentNode.insertBefore(elTitle, elChild);
							if( elChild==elFirstItem ) elFirstItem = elTitle;
						//}
					}
					foundPrefix = true;
					break;
				}
			}
			if( !foundPrefix ){	// Misc item
				misc.push( elChild );
			}
			// Indent according to number of slashes:
			//var splitter = labelName.split("/");
			//elChild.style.paddingLeft = (22+((splitter.length-1) * 14)) + "px";
			// Update the name:
			//labelName = splitter[splitter.length-1];
			//elChild.innerHTML = labelName;
			
			if( currentType=="Statuses" ){	// See if have to move according to default
				statuses[labelName] = elChild;
			}
			elLastChild = elChild.nextSibling;
		}
	}
	
	
	// Now move and change the Status order:
	if( statuses["__gtdTitle"] ){	// Check it has statuses
		elFirstItem.parentNode.insertBefore( statuses["__gtdTitle"], elFirstItem );
		delete statuses["__gtdTitle"];
	}
	var statusDefaults = labelTypes.Statuses.defaults;
	for( d in statusDefaults ){
		var elChild = statuses[statusDefaults[d]];
		if( elChild ){	// Found the element; move it up
			elChild.parentNode.insertBefore(elChild, elFirstItem);
			delete statuses[statusDefaults[d]];
		}
	}
	for( s in statuses ){
		var elChild = statuses[s];
		elChild.parentNode.insertBefore(elChild, elFirstItem);
	}
	
	// And move the misc
	if( misc.length > 0 ){
		var elTitle = fCreateTitle("Misc");
		if( elLastChild ){
			elLastChild.parentNode.insertBefore(elTitle, elLastChild);
		}else{
			misc[0].parentNode.appendChild(elTitle);
		}
		for( var i = 0; i < misc.length; i++ ){
			if( elLastChild ){
				elLastChild.parentNode.insertBefore(misc[i], elLastChild);
			}else{
				misc[0].parentNode.appendChild( misc[i] );
			}
		}
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActions refresh\n" + e.toString());
}
}; 














MoreActionsMenu.prototype.labelThread = function(options, qItem){
	// options: {fPreAdd, fCallback, 
		
try{
	
	// Queue it up:
	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = options;
		qItem.start = {'callee':this, 'callback':this.labelThread, args:[qItem.options, qItem]};
		qItem.callback = options.callback;
		qItem.test = GIPROTOTYPE.bind(this, function(qItem){
			try{
				var msg = this.elAlertBox? this.elAlertBox.innerHTML : "";
				if( msg==this.elAlertBox_LastMsg ) return;
				if( msg.indexOf( "\"" + qItem.options.labelname + "\"" )>-1 ){
					this.elAlertBox_LastMsg = msg;
					return true;
				}
				}catch(e){
					if( GTDDEBUGMODE ) alert("MoreActionsMenu labelThread test\n" + e.toString());
				}
			});
		this._queue.createQueueItem(qItem);
		return;
	}

	// Load common use:
	var labelname = options.labelname;
	var on = options.on;
	var threads = options.threads;
	if( !(threads instanceof Array) ) threads = [threads];

	// Process each menu item to extract the required element:
	var result = {act:0, elAction:null};
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.innerHTML.replace(/<.+?>/g, "")==labelname ){
				result.act = el.getAttribute("act");
				result.elAction = el;
				if( el.getAttribute("act")=="13" ) return true;	// remove label overrides (remove & add can be on same label)
			}
		});
	this.doMoreAction(fLI, false, true);
	var elAction = result.elAction;
	var act = result.act;
	

	
	if( elAction && ((typeof on=="undefined") || (act==12 && on) || (act==13 && !on)) ){	// Toggle or turn on/off
		if( options.fPreAdd ) options.fPreAdd();
		
		GIPROTOTYPE.doMouseEvent(this._doc, elAction, "mouseup");	// Actually do the event
				
		/*
		if( act==12 ){
			for( var i = 0; i < threads.length; i++ ) threads[i].addLabel(labelname);	
		}else{
			for( var i = 0; i < threads.length; i++ ){
				threads[i].removeLabel(labelname);
			}
		}
		*/
		
		options.act = act;
		qItem.act = act;
		setTimeout( GIPROTOTYPE.bind(this, function(){this._queue.nextQueueItem()}), 2500 );	// call to make sure deadwood is cleared
	}else{
		options.act = 0;
		qItem.act = 0;
		if( !elAction ) this.clickActionCombo();	// turn it off
		this._queue.clearQueueItem(qItem);
	}
		
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu labelThread\n" + e.toString());
}
	
	
		
};


MoreActionsMenu.prototype.alertBoxChange = function(event){
	this._multiToOne.process("alert-box", GIPROTOTYPE.bind(this, function(){
		this._queue.nextQueueItem();
	}));
	return;

};

/*
Labels.prototype.labelThreadCallback = function(labelname, testToClearOnly){
	// Called after ajax response; and timeout period
	if( !this._labelThreadInProgress ) return;
	
	var callbacks = [];	// queue callbacks due to time senstive processing
	var d = (new Date()).valueOf() - 1000;	// TODO correct to 1000
	for( var i = 0; i < this._labelThreadInProgress.length; i++ ){
		if( (labelname && this._labelThreadInProgress[i].labelname==labelname) ||
			(!labelname && this._labelThreadInProgress[i].date < d)
			){
				for( var j = i; j>=0; j-- ){
					if( this._labelThreadInProgress[j].fCallback ){
						callbacks.push( [this._labelThreadInProgress[j].fCallback, this._labelThreadInProgress[j].act] );
					}
					this._labelThreadInProgress.splice(j,1);
				}
		}
	}
	for( var i = 0; i < callbacks.length; i++ ) 	callbacks[i][0]( callbacks[i][1] );	// process callbacks
	
	// Tell it that it may continue processing
	if( !testToClearOnly ) this.labelThread(null, true);
	
	if( this._labelThreadInProgress.length==0 ) this.eventHandlers.broadcast("label-thread-unlocked");
};
*/

MoreActionsMenu.prototype.createLabel = function(qItem){

	if( !qItem ){	// no callback
		var qItem = {};
		qItem.start = {'callee':this, 'callback':this.createLabel, args:[qItem]};
		/*
		qItem.start = GIPROTOTYPE.bind(this, function(qItem){
				this.createLabel(qItem);
			});
		*/
		this._queue.createQueueItem(qItem);
		return;
	}

	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")=="14" ){
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				return true;
			}
		});
	this.doMoreAction(fLI);
	
	
	this._queue.clearQueueItem(qItem);
};
MoreActionsMenu.prototype.createLabelAjax = function(labelname){
try{
	if( !labelname ) labelname = prompt(this._gtdinboxPage.stringBundle.getString("Labels.CreateLabel"));	
	if( !labelname ) return;
	
	var finalCallback = GIPROTOTYPE.bind(this, function(){
			this.addNewLabel(labelname);
		});
	this._gtdinboxPage.gmailDOM.addLabel(labelname, null, finalCallback);


}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu createlabelajax\n" + e.toString());
}
};

MoreActionsMenu.prototype.getActiveLabels = function(callee, callback, qItem){
try{
	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = {'callee':callee, 'callback':callback};	// external
		qItem.start = {'callee':this, 'callback':this.getActiveLabels, args:[null, null, qItem]};
		/*
		qItem.start = GIPROTOTYPE.bind(this, function(qItem){
				this.getActiveLabels(callee, callback, qItem);
			});
		*/
		this._queue.createQueueItem(qItem); 
		return; 
	}
	
	
	var result = {labels:[]};
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")=="13" ){	// remove a label - means its applied
				result.labels.push( el.innerHTML.replace(/<.+?>/g,"") );
			}
		});
	this.doMoreAction(fLI, true);
		
	// Now callback
	if( qItem.options.callback ) qItem.options.callback.call(qItem.options.callee, result.labels);
	//if( qItem.options.callback ) qItem.options.callback(result.labels);
	//return result.labels;
	
	this._queue.clearQueueItem(qItem);
}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu getactivelabels\n" + e.toString());
}
};

MoreActionsMenu.prototype.starSelectedMessage = function(options, qItem){
try{

	if( !qItem ){	// no callback
		var qItem = {};
		qItem.options = options;
		qItem.callback = GIPROTOTYPE.bind(this, function(){
				if( options.callback && (typeof options.callback=="function") ) setTimeout( options.callback, 800 );	// give it time to star off
			});
		qItem.start = {'callee':this, 'callback':this.starSelectedMessage, args:[options, qItem]};
		
		this._queue.createQueueItem(qItem); 
		return; 
	}
	
	
	var find = options.starOn? "3" : "4";
	var fLI = GIPROTOTYPE.bind(this, function(el){
			if( el.getAttribute("act")==find ){	
				GIPROTOTYPE.doMouseEvent(this._doc, el, "mouseup");
				return true;
			}
		});
	this.doMoreAction(fLI, true);
			
	this._queue.clearQueueItem(qItem);	// does the callback

}catch(e){
	if( GTDDEBUGMODE ) alert("MoreActionsMenu starSelectedMessage\n" + e.toString());
}
};