function PerfLogger(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._keys = {};
	this._callCount = {};
}

PerfLogger.prototype.log = function(key, msg, clear){
	if( !this._keys[key] || clear ) this._keys[key] = [];
	this._keys[key].push( {'date':(new Date()).valueOf(), 'msg':msg} );
};

PerfLogger.prototype.report = function(key, outputToConsole, clearLog){
	var s = "";
	if( this._keys[key] ){
		s += "Report for " + key + ":\n";
		var startDate = this._keys[key][0].date;
		s = "0 (" + this._keys[key][0].msg + ")";
		for( var i = 1; i < this._keys[key].length; i++ ){
			s += "\n" + (this._keys[key][i].date-startDate) + " (" + this._keys[key][i].msg + ")";
		}
	}
	if( this._callCount[key] ){
		s += "\nCount for '" + key + "': " + this._callCount[key].count + " (since last report: " + (this._callCount[key].count - this._callCount[key].countLastReport) + ")";
		this._callCount[key].countLastReport = this._callCount[key].count;
	}
	
	if( outputToConsole && GTDDEBUGMODE ) this._gtdinboxPage.unsafeWindow.console.log(s);
	
	if( clearLog ) this.clearLog(key); 
	
	return s;
};

PerfLogger.prototype.reportCountCalls = function(outputToConsole){
	var s = "";
	for( key in this._callCount ){
		s += "\nCount for '" + key + "': " + this._callCount[key].count + " (since last report: " + (this._callCount[key].count - this._callCount[key].countLastReport) + ")";
		this._callCount[key].countLastReport = this._callCount[key].count;
	}
	
	if( outputToConsole && GTDDEBUGMODE ) this._gtdinboxPage.unsafeWindow.console.log(s);
	
	return s;
};

PerfLogger.prototype.clearLog = function(key){
	this._keys[key] = [];
};

PerfLogger.prototype.countCall = function(key){
	if( !this._callCount[key] ) this._callCount[key] = {'count':1, 'countLastReport':0};
	else this._callCount[key].count++;
};