/*
	The Print button on the thread list.
	Repeats the current search, extracts the result threads, and loads into a new window. 
*/


function PrintButtonUI(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._doc = this._gtdinboxPage.doc;
	this._eventObservers = new GtdEventObservers(this);
};

PrintButtonUI.prototype.viewChange = function(){

try{
	var elDelete = this._gtdinboxPage.gmailDOM.element("delete-button");
	if( elDelete ) elContainer = elDelete.parentNode;

	if( !this._gtdinboxPage.settings.ui.hide.hipsterPrint ){
		// Test to see if the view is set to search
		var query = this._gtdinboxPage.gmailDOM.extractSearchQuery(this._gtdinboxPage.doc.defaultView.top.location.href) || "in:inbox";	
		
		if( !query ){	// Not a search page
			if( this.elButton ) this.elButton.style.display = "none";
			return;
		}else{
			if( this.elButton ) this.elButton.style.display = "";
		}
		
		if( !this.elButton ){	// Add it to the UI
			this.elButton = this._doc.createElement("BUTTON");
				this.elButton.className = "Gjckbb";
				this.elButton.setAttribute("name", "gtd-print");
				this.elButton.innerHTML = this._gtdinboxPage.stringBundle.getString("Print.Button");
				this.elButton.title = this._gtdinboxPage.stringBundle.getString("Print.Button.Tooltip");
			this._eventObservers.observe( this.elButton, "click", this.loadPrint, false );
		}
		if( elContainer && !this._gtdinboxPage.gmailDOM.element("search-print") ){
			//elContainer.appendChild( this.elButton );
			elContainer.insertBefore( this.elButton, elDelete );
		}
	}
	
}catch(e){
	if( GTDDEBUGMODE ) alert("PrintButton viewChange\n" + e.toString());
}	
};

PrintButtonUI.prototype.loadPrint = function(){
	// Repeat the current search in a data format; creating a set of threads. Then load a new window.
try{
	
	var query = this._gtdinboxPage.gmailDOM.extractSearchQuery(this._gtdinboxPage.doc.defaultView.top.location.href);
	this.id = (new Date()).valueOf();
	if( !this._gtdinboxPage.gtdinboxBrowser.printers ) this._gtdinboxPage.gtdinboxBrowser.printers = {};
	this._gtdinboxPage.gtdinboxBrowser.printers[this.id] = {'query': query, 'gtdinboxPage':this._gtdinboxPage};
	
	
	gBrowser.selectedTab = gBrowser.addTab("chrome://gtdinbox/locale/printer.htm?id=" + this.id);
		
}catch(e){
	if( GTDDEBUGMODE ) alert("PrintButton loadPrint\n" + e.toString());
}
};



PrintButtonUI.prototype.destroy = function(){
	this._eventObservers.destroy();
};