function RecentItems(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
};

RecentItems.prototype._extractArray = function(arr, prefix, number){
	if( !number ) number = arr.length;
	var newArr = [];
	for( var i = 0; i < arr.length; i++ ){
		if( prefix ){
			if( arr[i].indexOf(prefix)==0 ){
				newArr.push(arr[i]);
				number++;
			}
		}else{
			newArr.push(arr[i]);
			number++;
		}
	}
	
	return newArr;
};

RecentItems.prototype.labels = function(number){
	// Return [label]
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.labels ) return [];
	return this._extractArray( this._gtdinboxPage.settings.recent.labels, null, number );
};

RecentItems.prototype.projects = function(number){
	// Return [label]
	var projectPrefix = this._gtdinboxPage.settings.labels.types.Projects.prefix;
	
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.labels ) return [];
	
	// Check for old duds:
	var projectHash = this._gtdinboxPage._labels.getLabelsHash("Projects");
	var labels = this._gtdinboxPage.settings.recent.labels;
	for( var i = labels.length - 1; i >= 0; i-- ){
		if( !projectHash[labels[i]] ) labels.splice(i, 1);
	}
	
	return this._extractArray( this._gtdinboxPage.settings.recent.labels, this._gtdinboxPage.settings.labels.types.Projects.prefix, number );
};

RecentItems.prototype.threads = function(number){
	// Return [{id:,subject:}]
	if( !this._gtdinboxPage.settings.recent || !this._gtdinboxPage.settings.recent.threads ) return [];
	return this._extractArray( this._gtdinboxPage.settings.recent.threads, null, number );
};

RecentItems.prototype.addLabel = function(label){
	if( !this._gtdinboxPage.settings.recent ) this._gtdinboxPage.settings.recent = {};
	if( !this._gtdinboxPage.settings.recent.labels ) this._gtdinboxPage.settings.recent.labels = [];
	
	for( var i = 0; i < this._gtdinboxPage.settings.recent.labels.length; i++ ) if( this._gtdinboxPage.settings.recent.labels[i]==label ) return;
	
	this._gtdinboxPage.settings.recent.labels.unshift(label);
	if( this._gtdinboxPage.settings.recent.labels.length > 20 ) this._gtdinboxPage.settings.recent.labels.length = 20;
	this._gtdinboxPage.saveSettings();
};

RecentItems.prototype.addThread = function(thread){
	if( !this._gtdinboxPage.settings.recent ) this._gtdinboxPage.settings.recent = {};
	if( !this._gtdinboxPage.settings.recent.threads ) this._gtdinboxPage.settings.recent.threads = [];
	
	for( var i = 0; i < this._gtdinboxPage.settings.recent.threads.length; i++ ) if( this._gtdinboxPage.settings.recent.threads[i].id==thread.id ) return;
	
	this._gtdinboxPage.settings.recent.threads.unshift({id:thread.id, subject:thread.subject});
	if( this._gtdinboxPage.settings.recent.threads.length > 5 ) this._gtdinboxPage.settings.recent.threads.length = 5;
	this._gtdinboxPage.saveSettings();
};