/* Copyright Andy Mitchell 2007. No warranties */

function ThreadListUI(gtdinboxPage){
try{
	this.eventObservers = new GtdEventObservers(this);
	this.tlGtdEventObservers = new GtdEventObservers(this);
	this.gtdinboxPage = gtdinboxPage;
	this.doc = gtdinboxPage.doc;
	this._threadList = gtdinboxPage._threadList;
	this._labels = gtdinboxPage._labels;
	//this._threadListPopupUI = gtdinboxPage._threadListPopupUI;
	this._refreshQueue = [];
	//this._autoLabelSeen = {};
	this._multiToOne = new MultiToOne(gtdinboxPage, 100);
	
	this.gtdinboxPage._moreActionsMenu.addEventHandler( this, "actionlist-manual-click", this.manualThreadLabelChange );
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui constructor\n" + e.toString());
}
};

ThreadListUI.prototype.viewChange = function(gmail){
	// Add a column; and update each row.
	
	/*
	var result = this.doc.evaluate( "//table[@class='N2mZ7b']//tbody", elTL, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null );
	var elTable = result.singleNodeValue;
	*/

	if( this.listenDOM() ) this.listenDOM(false);
	this.elTL = this.gtdinboxPage.gmailDOM.element("ActiveViewElement", gmail);
	this.listenDOM(true);	
	
	if( !this.gtdinboxPage.settings.ui.hide.removeAllLabels ){
		this.gtdinboxPage._moreActionsMenu.addCustomEntry("tl-removealllabels", this.gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels"), this.gtdinboxPage.stringBundle.getString("MoreActions.RemoveAllLabels.Tooltip"), GIPROTOTYPE.bind(this, this.removeAllLabels));
	}

	this.refresh();
};

ThreadListUI.prototype.removeAllLabels = function(){
try{
	this.gtdinboxPage._lightbox.setType("updatingmessages");
	this.gtdinboxPage._lightbox.active(true);
		
	var range = this.gtdinboxPage.gmailDOM.parseElement( "threadlist-range", this.gtdinboxPage.gmailDOM.element("threadlist-range") );
	var searchStr = this.gtdinboxPage.gmailDOM.extractSearchQuery();
	var threadList = new ThreadList(this.gtdinboxPage);
	
	
	this.gtdinboxPage.gmailDOM.search(searchStr, threadList, range.start, range.end - range.start, GIPROTOTYPE.bind(this, function(searchArray, query, threadList, currentOffset){
		try{
			threadList.parseAjaxResponse(searchArray[0]);
			var rowIndices = this.gtdinboxPage.gmailDOM.parseElement("thread-list-index");

			var labelled = {count:0};
			var fOnDone = GIPROTOTYPE.bind(this, function(){
				if( labelled.found ){	// Refresh view since may have removed labels
					setTimeout( GIPROTOTYPE.bind(this.gtdinboxPage.gmailDOM, this.gtdinboxPage.gmailDOM.refreshView), 300 );
				}
				this.gtdinboxPage._lightbox.active(false);
			});
				
			// Deep load threads for faster label removal
			var threadIds = [];
			for( var i = 0; i < rowIndices.length; i++ ){
				threadIds.push( threadList._threads[rowIndices[i]].id );
			}
			this.gtdinboxPage.gmailDOM.getThreadData(threadIds, threadList, GIPROTOTYPE.bind( this, function(){
				try{
					for( var i = 0; i < rowIndices.length; i++ ){
						var thread = threadList._threads[rowIndices[i]];
					
						labelled.count++;
						if( thread.labels.length > 0 ){
							labelled.found = true;
							thread.removeLabel( GIPROTOTYPE.clone(thread.labels), GIPROTOTYPE.bind(this, function(){
										if( --labelled.count<=0 ){	// Finished
											fOnDone();
										}
									}), "ajax" );
						}
					
						/*
						for( var j = 0; j < thread.labels.length; j++ ){
							var l = thread.labels[j];
							labelled.count++;
							labelled.found = true;
							this.gtdinboxPage.gmailDOM.removeLabelFromThread(thread.id, l, GIPROTOTYPE.bind(this, function(){
									if( --labelled.count<=0 ){	// Finished
										fOnDone();
									}
								}), thread);
							
						}
						*/
						
					}
					if( !labelled.found ) fOnDone();
				}catch(e){
					if( GTDDEBUGMODE ) alert( "ThreadListUI  removealllabels search-callback deepdata-callback\n" + e.toString() );
				}
			}));
		}catch(e){
			if( GTDDEBUGMODE ) alert( "ThreadListUI  removealllabels search-callback\n" + e.toString() );
		}
	}));
}catch(e){
	if( GTDDEBUGMODE ) alert( "ThreadListUI  removealllabels\n" + e.toString() );
}
};

ThreadListUI.prototype.listenDOM = function(v){
	if( typeof v=="undefined" ) return this._listen;
	if( v ){
		if( !this._listen ) this.eventObservers.observe(this.elTL, "DOMNodeInserted", this.domNodeInserted, false);
	}else{
		if( this._listen ) this.eventObservers.stopObserving(this.elTL, "DOMNodeInserted", this.domNodeInserted, false);
	}
	this._listen = v;
};
ThreadListUI.prototype.domNodeInserted = function(event){
	this._multiToOne.process("threadListDomChange", GIPROTOTYPE.bind(this, this.refresh));
};


ThreadListUI.prototype.refresh = function(callback, forceProcess){
	this.listenDOM(false);
	
	if( !this.elTL ) return;
	
	if( !callback ) this._refreshQueue.push( {'elTL':this.elTL, 'forceProcess':(forceProcess||null)} );
	if( this._isRunning || this._refreshQueue.length==0 ) return;


	this.gtdinboxPage._perfLogger.countCall( "ThreadListUI.refresh" );

	this.tlGtdEventObservers.reset();
	if( !this.gtdinboxPage.settings.ui.hide.rightClick ){
		this.tlGtdEventObservers.observe( this.elTL, "mousedown", this.mouseDown, true);
		this.tlGtdEventObservers.observe( this.elTL, "contextmenu", this.contextMenu, true);
	}

	var elTL = this._refreshQueue[0].elTL;
	forceProcess = this._refreshQueue[0].forceProcess;
	this._refreshQueue.splice(0,1);
	
	if( !this.gtdinboxPage.settings.ui.hide.previewIcon ){
		try{
		this._isRunning = true;
		//var autoLabel = {count:0, checked:this.checkRows()};
		
		var view = this.gtdinboxPage.view();
		
		var elImg = this.doc.createElement("IMG");
		elImg.className = "gtd-row-button";
		elImg.style.position = "absolute";
		elImg.style.right = "0px";
		elImg.src = "chrome://gtdinbox/content/gtd_lineitem.png";
		elImg.setAttribute("onmouseover", "this.src='chrome://gtdinbox/content/gtd_lineitem-hover.png'");
		elImg.setAttribute("onmouseout", "this.src='chrome://gtdinbox/content/gtd_lineitem.png'");
		elImg.title = this.gtdinboxPage.stringBundle.getString("ThreadListUI.GTDBox.Tooltip");
		var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-lastcol"); 
		this.rowCount = result.snapshotLength;
		var tryAutoLabelAll = this.gtdinboxPage.gmailDOM.test("is-sent-mail");
		var repeatRefresh = false;
		if( result.snapshotLength>0 ){
			if( forceProcess || (result.snapshotItem(0).innerHTML.indexOf("gtd")==-1 || result.snapshotItem(result.snapshotLength-1).innerHTML.indexOf("gtd")==-1) ){
				for( var i = 0; i < result.snapshotLength; i++ ){
					var elImgC = elImg.cloneNode(true);
					if( !forceProcess || result.snapshotItem(i).innerHTML.indexOf("gtd")==-1 ){
						result.snapshotItem(i).appendChild( elImgC );
					}
					
 				}
			}
		}
		
		}catch(e){if( GTDDEBUGMODE ) alert("threadlistui refresh\n" + e.toString())}
	}
	this._isRunning = false;
	
	if( this._refreshQueue.length > 0 ){
		setTimeout( GIPROTOTYPE.bind(this, function(){this.refresh(true)}), 50);
	}
	
	
	if( this.gtdinboxPage._threadListPopupUI.poppedUp() ){	// Precipitate a refresh; used for Create Label (create label causes row update)	
		this.gtdinboxPage._threadListPopupUI.labelSelect.refresh();
		/*
		var elRows = this.getCheckedRows();
		if( elRows.length > 0 ){
			var row = this.parseRow(elRows[0].elRow);
			this.gtdinboxPage._threadListPopupUI.loadByRow( row, true );
		}
		*/
	}
	
	if( !forceProcess && repeatRefresh ){
		setTimeout( GIPROTOTYPE.bind(this, function(){
			this.refresh(null, true);
		}), 3000);
	}
	
	this.listenDOM(true);
};


ThreadListUI.prototype.checkRow = function(elCheck, v){
	if( (v && !elCheck.checked) || (!v && elCheck.checked) ){	// invert selection. must use keypress
		GIPROTOTYPE.doMouseEvent( this.doc, elCheck, "click");
	}
};
ThreadListUI.prototype.checkRows = function(a, update){
	// Get or set the status of the rows. 
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checkbox");
	if( typeof a=="undefined" || !a ){	// return array of checked items
		var a = [];
		for( var i = 0; i < result.snapshotLength; i++ ){
			a[i] = result.snapshotItem(i).checked;
			if( typeof update!="undefined" ) this.checkRow(result.snapshotItem(i), update);
		}
		return a;
	}else{	// check items
		for( var i = 0; i < result.snapshotLength; i++ ){
			this.checkRow(result.snapshotItem(i), (a[i] || false));
		}
	}
};
ThreadListUI.prototype.getCheckedRows = function(){
	var rows = [];
	//var result = this.doc.evaluate( "//div[@gtdviewid='" + this.gtdinboxPage.view("gtdviewid") + "']//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d AnqB9d rfza3e')]//td//input[@type='checkbox']", this.elTL, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checked-checkbox");
	for( var i = 0; i < result.snapshotLength; i++ ){
		if( result.snapshotItem(i).checked ){
			var row = this.parseRow(result.snapshotItem(i).parentNode.parentNode);
			rows.push( row );
		}
	}
	return rows;
};
ThreadListUI.prototype.uncheckOutOfView = function(){
	// Items that remain checked, even when not in view; affect the 'More Actions' drop down
	// Uncheck all checkboxes not currently in view
	// BEWARE: can cause problems on sent items. Checking sent item causes inbox variant to be checked; and unchecking outofview inbox variant consequently unchecks the sent item row.
try{
	var viewid = this.gtdinboxPage.view("gtdviewid");
	//var result = this.doc.evaluate( "//table[@class='N2mZ7b']//tr[starts-with(@class,'xweT7d AnqB9d rfza3e')]//td//input[@type='checkbox']", this.elTL, null, XPathResult.ORDERED_NODE_SNAPSHOT_TYPE, null);
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-rows-checked-checkbox");
	for( var i = 0; i < result.snapshotLength; i++ ){
		var el = result.snapshotItem(i);
		if( el.checked ){
			var inview = false;
			while( el.parentNode && el.getAttribute ){
				if( el.getAttribute("gtdviewid")==viewid ){
					inview = true;
					break;
				}
				el = el.parentNode;
			}
			if( !inview ){
				this.checkRow( result.snapshotItem(i), false );
			}
		}
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui uncheckOutOfView\n" + e.toString());
}
};

ThreadListUI.prototype.getRowByThread = function(thread){
try{
	// Scan all rows for a possible match to this thread (row to contain subset of subject, names, snippet).
	//	If possible candidate, reverse lookup the row to see if it returns the thread
	//	If so, return that row
	
	
	var result = this.gtdinboxPage.gmailDOM.elements("threadlist-allrows");
	for( var i = 0; i < result.snapshotLength; i++ ){
		var row = new ThreadRow(this, result.snapshotItem(i));
		

		if( thread.testSubject(row.subject) ){
			if( thread.testNames(row.names) ){
				if( thread.testSnippet(row.snippet) ){
					return row;
				}
			}
		}
		
	}	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui getRowByThread\n" + e.toString());
}
};

ThreadListUI.prototype.parseRow = function(elRow){
	try{
		/*
		var row = {};
		row.elRow = elRow;
		var result = this.gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
		GIPROTOTYPE.extend( row, result );
		
		row.thread = GIPROTOTYPE.bind(this, function(noCheck, debug){
							var thread = this._threadList.getThreadByRow( row.subject, row.snippet, row.names )
				if( thread ){
					return thread;
				}else if(!noCheck){	// Try to retrieve my taking an adjacent, more easily identified, row; and exploiting Gmail's chronological nature to work back/forward to find the first match with these credentials
					var adjRow = null;
					var usedNext = true;
					if( row.elRow.nextSibling && row.elRow.nextSibling.nodeName=="TR" ){
						adjRow = this.parseRow(row.elRow.nextSibling);
					}else{
						usedNext = false;
						adjRow = this.parseRow(row.elRow.previousSibling);
					}
					thread = adjRow.thread(true);
					if( thread ){
						var fNext = function(t){
								return usedNext? t.previous() : t.next();
							};
						while(thread = fNext(thread)){
							if( thread.testNames(row.names) && thread.testSnippet(row.snippet) ) return thread;
						}
					}
				}
			});
		*/
		var row = new ThreadRow(this, elRow);
		return row;
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui parseRow\n" + e.toString());
	}
};

function ThreadRow(threadListUI, elRow){
	this._threadListUI = threadListUI;
	this._gtdinboxPage = threadListUI.gtdinboxPage;
	this.elRow = elRow;
	this.executeAfterNextPopupRefresh = [];	// A list of functions to execute next time the ThreadListPopupUI refresh function (and callbacks) have completed
	
	var result = this._gtdinboxPage.gmailDOM.parseElement("thread-list-row", elRow);
	GIPROTOTYPE.extend( this, result );
};
ThreadRow.prototype.thread = function(fCallback, forceRefresh, noRefresh){
try{
		var fFirstCallback = GIPROTOTYPE.bind(this, function(thread){
				if( forceRefresh || (!noRefresh && this.messageCount && thread.messageCount < this.messageCount) ){	// Need to force a refresh
					this._threadListUI._threadList.getThreadById( thread.id, fCallback, true );
				}else{
					fCallback(thread); 
				}
			});
		this._threadListUI._threadList.getThreadByRow( this.subject, this.snippet, this.names, GIPROTOTYPE.bind(this, function(thread){
				if( thread ){
					fFirstCallback(thread);
				}else{
					this._threadListUI._threadList.getThreadByRowIndex( GIPROTOTYPE.bind(this, function(thread){
							if( thread ){
								fFirstCallback(thread);
							}else{
								fFirstCallback();
							}
						}) );
				}
				
			}) );
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadRow thread\n" + e.toString());
}
};


ThreadListUI.prototype.mouseDown = function(event){
	try{
		var el = GIPROTOTYPE.element(event);
		
		if( this.gtdinboxPage.settings.labels.starForNextAction && this.gtdinboxPage.gmailDOM.test("star", el) ){	// It's a star
			// Ensure el points at the row:
			var gmailDOM = this.gtdinboxPage.gmailDOM;
			var elRow = el;
			while( !gmailDOM.test("thread-row", elRow) && elRow.nodeName!="BODY" ) elRow = elRow.parentNode;
			if( !gmailDOM.test("thread-row", elRow) ) return;
			var row = this.parseRow(elRow);
			var starOn = !this.gtdinboxPage.gmailDOM.test("star-on", el); // (note: inverted due to event timing & icon updating)
			row.thread(GIPROTOTYPE.bind(this, function(thread){
				try{
					if( !thread ) return;
					// Check row:
					//this.uncheckOutOfView();
					//var checkedRows = this.checkRows(null, false);
					//this.checkRow(row.elCheck, true);
					// Test to see if star is on/off and respond
					var settings = this.gtdinboxPage.settings;
					var labelNextAction = settings.labels.types.Statuses.prefix + settings.labels.types.Statuses.defaults.NextAction;
					
					var fCallback = GIPROTOTYPE.bind(this, function(){
						//this.checkRows(checkedRows);	// restore
						setTimeout( GIPROTOTYPE.bind( this.gtdinboxPage.gmailDOM, this.gtdinboxPage.gmailDOM.refreshView ), 300 );
					});
					
					if( starOn ){
						thread.addLabel( labelNextAction, fCallback, "ajax", null, true );
					}else{
						thread.removeLabel( labelNextAction, fCallback, "ajax", null, true );
					}
					
					/*
					var labelsCount = {i:0};
					var fCallback = GIPROTOTYPE.bind(this, function(){
						if( --labelsCount.i==0 ){
							this.checkRows(checkedRows);	// restore
						}
					});
					
					if( !this.gtdinboxPage.gmailDOM.test("star-on", el) ){	// its on, add label (note: inverted due to event timing & icon updating)
						var statusPrefix = settings.labels.types.Statuses.prefix;
						labelsCount.i++;
						this.gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':true, 'threads':thread, 'fCallback':fCallback});
										
						if( settings.labels.onlyOneStatus  ){	// It's a status, there can only be one!
							for( var i = 0; i < thread.labels.length; i++ ){
								if( thread.labels[i].indexOf(statusPrefix)==0 && thread.labels[i]!=labelNextAction ){
									labelsCount.i++;
									this.gtdinboxPage._labels.labelThread({'labelname':thread.labels[i], 'on':false, 'threads':thread, 'fCallback':fCallback});
								}
							}
						}
						
					}else{	// Off, make sure it's off
						labelsCount.i++;
						this.gtdinboxPage._labels.labelThread({labelname:labelNextAction, 'on':false, 'threads':thread, 'fCallback':fCallback});
					}
					*/
				}catch(e){
					if( GTDDEBUGMODE ) alert("ThreadListUI mousedown star row.thread-callback\n" + e.toString());
				}
			}));
			return;
		}
		
		if( el.className=="gtd-row-button" ){
			GIPROTOTYPE.stop(event);
			var hadLastEventDetail = this._lastEventDetail;
			this._lastEventDetail = event.detail;
			if( !hadLastEventDetail ) setTimeout( GIPROTOTYPE.bind(this, function(){this.gtdIconClick(event,el)}), 200);
		}else if( event.button==2 ){
			GIPROTOTYPE.stop(event);
		}
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui mouse down\n" + e.toString());
	}
};
ThreadListUI.prototype.gtdIconClick = function(event, el){
try{
	var lastEventDetail = this._lastEventDetail;
	this._lastEventDetail = null;
	
	var elRow = el.parentNode.parentNode;
	if( lastEventDetail==1 ){
		this.popupRow(elRow, el);
	}else{
		var row = this.parseRow(elRow);
		row.thread(GIPROTOTYPE.bind( this, function(thread){
				this.gtdinboxPage._threadListPopupUI.threadActions.refresh(thread);
				this.uncheckOutOfView();
				if( event.button==0 && !event.shiftKey ){	// Finish it
					this.checkRow(row.elCheck, true);
					this.gtdinboxPage._threadListPopupUI.threadActions._clickFinish();
				}else if( (event.button==0 && event.shiftKey) || event.button==2 ){ // Delete it
					this.checkRow(row.elCheck, true);
					this.gtdinboxPage._threadListPopupUI.threadActions._clickDelete();
				}
			}));
		
	}
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI gtdIconClick\n" + e.toString());
}
};

ThreadListUI.prototype.contextMenu = function(event){
try{
	GIPROTOTYPE.stop(event);
	var el = GIPROTOTYPE.element(event);
	
	if( el.className=="gtd-row-button" ) return;
	
	// Ensure el points at the row:
	var gmailDOM = this.gtdinboxPage.gmailDOM;
	while( !gmailDOM.test("thread-row", el) && el.nodeName!="BODY" ) el = el.parentNode;
	if( !gmailDOM.test("thread-row", el) ) return;
	
	this.popupRow(el, event, {location: "bottomLeft", margin: 15} );

}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI contextMenu\n" + e.toString());
}
};

/*
ThreadListUI.prototype.contextMenu = function(event){
	var lastContextEventDetail = this._lastContextEventDetail;
	this._lastContextEventDetail = event.detail;
	var el = GIPROTOTYPE.element(event);
	GIPROTOTYPE.stop(event);
	if( !lastContextEventDetail ) setTimeout( GIPROTOTYPE.bind(this, function(){this.contextMenuClick(event,el)}), 200);
};
ThreadListUI.prototype.contextMenuClick = function(event, el){
	try{
		var lastContextEventDetail = this._lastContextEventDetail;
		this._lastContextEventDetail = null;
	
		
		if( lastContextEventDetail==1 ){
			
			this.gtdinboxPage.unsafeWindow.console.log(el);
			
			
			// Ensure el points at the row:
			var gmailDOM = this.gtdinboxPage.gmailDOM;
			while( !gmailDOM.test("thread-row", el) && el.nodeName!="BODY" ) el = el.parentNode;
			if( !gmailDOM.test("thread-row", el) ) return;
			
			this.popupRow(el, event, {location: "bottomLeft", margin: 15} );
		}else if( lastContextEventDetail==2 ){
			var elRow = el.parentNode.parentNode;
			var row = this.parseRow(elRow);
			this.gtdinboxPage._threadListPopupUI.threadActions.refresh(row.thread());
			this.checkRow(row.elCheck, true);
			this.gtdinboxPage._threadListPopupUI.threadActions._clickDelete();
		}
	}catch(e){
		if( GTDDEBUGMODE ) alert("threadlistui context menu\n" + e.toString());
	}
};
*/

ThreadListUI.prototype.popupRow = function(elRow, popupType, popupOptions){
try{
	this.gtdinboxPage._threadListPopupUI.popupOff();	// clear out checked rows
		
	var row = this.parseRow(elRow);
	this.gtdinboxPage._threadListPopupUI.popup( popupType, popupOptions );
	this.uncheckOutOfView();
	this.checkRow(row.elCheck, true);
	
	/*
	row.executeAfterNextPopupRefresh.push( GIPROTOTYPE.bind(this, function(){	// Ensure this executes after the popup finishes loading:
		this.gtdinboxPage._threadListPopupUI.labelSelect.closeKeepClosedShowHiders();
	}) );
	*/
	
	
	
	setTimeout( GIPROTOTYPE.bind(this, function(){
		this.gtdinboxPage._threadListPopupUI.loadByRow( row, true );
		}), 5 );
	//this.gtdinboxPage._threadListPopupUI.setRow( row );	// Something to do with the stack originating from the context-event, and later hitting a .apply, was causing heavy cyclical problems
}catch(e){
	if( GTDDEBUGMODE ) alert("ThreadListUI popupRow\n" + e.toString());
}
};


ThreadListUI.prototype.manualThreadLabelChange = function(event, label){
	// Called when user manually selects label on drop down
	// Kept seperate from Labels because ThreadList/Conversation would handle it differently

try{
	if( this.gtdinboxPage.view("view")!="tl" ) return;	// i should be active view
	
	var rows = this.getCheckedRows();	
	if( rows.length==0 ) return;
		
	//if( !label.safelabel.indexOf( this.gtdinboxPage.settings.labels.types.Projects.prefix )==0 ) return;
	
	
	var statusPrefix = this.gtdinboxPage.settings.labels.types.Statuses.prefix;
	var statusNextAction = statusPrefix + this.gtdinboxPage.settings.labels.types.Statuses.defaults.NextAction;
	var statusFinished = statusPrefix + this.gtdinboxPage.settings.labels.types.Statuses.defaults.Finished;
	var onlyOneStatus = this.gtdinboxPage.settings.labels.onlyOneStatus;
	
	if( label.act=="12" && label.safelabel.indexOf( statusPrefix )==0 ){
		// It's a status label; and rules may apply that dictate only one status can exist at once
		// The problem is that theres no guarentee each selected row's thread object is synced with the labels on that item
		// So, need to process each selected row, and verify labels
		// If Finished, remove all non-finished labels then mark as read & archive
		// If only one status, remove all non-finished labels
		var f = GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._lightbox.setType("updatingmessages");
				this.gtdinboxPage._lightbox.active(true);
				
				var range = this.gtdinboxPage.gmailDOM.parseElement( "threadlist-range", this.gtdinboxPage.gmailDOM.element("threadlist-range") );
				var searchStr = this.gtdinboxPage.gmailDOM.extractSearchQuery();
				var threadList = new ThreadList(this.gtdinboxPage);
							
				this.gtdinboxPage.gmailDOM.search(searchStr, threadList, range.start, range.end - range.start, GIPROTOTYPE.bind(this, function(searchArray, query, threadList, currentOffset){
						threadList.parseAjaxResponse(searchArray[0]);
						var rowIndices = this.gtdinboxPage.gmailDOM.parseElement("thread-list-index");
						
						var threadActionsUI = new ThreadActionsUI(this.gtdinboxPage, null, true);


						var labelled = {count:0};
						var fOnDone = GIPROTOTYPE.bind(this, function(){
								var fOnDone2 = GIPROTOTYPE.bind(this, function(){
										if( labelled.found ){	// Refresh view since may have removed labels
											this.gtdinboxPage.gmailDOM.refreshView();
										}
										this.gtdinboxPage._lightbox.active(false);
									});
																		
								if( this.gtdinboxPage.settings.labels.starForNextAction ){	// It's a Next Action, add a star
									if( statusNextAction==label.safelabel ){
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:true, callback: fOnDone2});
									}else{
										this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false, callback: fOnDone2});
									}
								}
								if(statusFinished==label.safelabel){
									threadActionsUI._doMarkReadAndArchive(fOnDone2); // Archive it
								}else{
									fOnDone2();
								}		
							});
						
						if( statusFinished==label.safelabel || onlyOneStatus ){	// remove non-current status labels		
							
							// Deep load threads for faster label removal
							var threadIds = [];
							for( var i = 0; i < rowIndices.length; i++ ){
								threadIds.push( threadList._threads[rowIndices[i]].id );
							}
							this.gtdinboxPage.gmailDOM.getThreadData(threadIds, threadList, GIPROTOTYPE.bind( this, function(){
								
															
								for( var i = 0; i < rowIndices.length; i++ ){
									var thread = threadList._threads[rowIndices[i]];									
								
									for( var j = 0; j < thread.labels.length; j++ ){
										if( thread.labels[j].indexOf(this.gtdinboxPage.settings.labels.types.Statuses.prefix)==0 && thread.labels[j]!=label.safelabel ){
											var l = thread.labels[j];
											labelled.count++;
											labelled.found = true;
											/*
											thread.removeLabel(l, GIPROTOTYPE.bind(this, function(){
												if( --labelled.count<=0 ){	// Finished
													fOnDone();
												}
											}), "ajax");
											*/
											
											this.gtdinboxPage.gmailDOM.removeLabelFromThread(thread.id, l, GIPROTOTYPE.bind(this, function(){
													if( --labelled.count<=0 ){	// Finished
														fOnDone();
													}
												}), thread);
											thread.removeLabel(l, null, null, true);
											
										}
									}
									
								}
								
								if( !labelled.found ) fOnDone();
							}));
						}else{
							fOnDone();
						}					
						
					}));
				
			});
		setTimeout(f, 100);
	}else if( label.act=="13" && label.safelabel.indexOf( statusPrefix )==0 ){
		if( this.gtdinboxPage.settings.labels.starForNextAction && statusNextAction==label.safelabel ){	// It's removing a next action; remove star
			var f = GIPROTOTYPE.bind(this, function(){
				this.gtdinboxPage._moreActionsMenu.starSelectedMessage({starOn:false});
			});
			setTimeout(f, 100);
		}
	}
	
	// Sync the threads
	
	for( var i = 0; i < rows.length; i++ ){
		//var thread = rows[i].thread();
		
		rows[i].thread( GIPROTOTYPE.bind( this, function(thread){		
			if( thread ){
				if( label.act=="12" ){
					var f = function(){					
						thread.addLabel(label.label, null, null, true);
					}
					setTimeout(f, 200);
				}else{
					thread.removeLabel(label.label, null, null, true);
				}
			}
		}));
		
	}
	
	
	
}catch(e){
	if( GTDDEBUGMODE ) alert("threadlistui manualThreadLabelChange\n" + e.toString());
}
};

ThreadListUI.prototype.destroy = function(){
	this._isRunning = true;
	this._refreshQueue.length = 0;
	this.eventObservers.destroy();
	this.tlGtdEventObservers.destroy();
	this._multiToOne.destroy();
};