/* Copyright Andy Mitchell 2007. No warranties */

function GIXMLHttpRequest(gtdinboxPage){
	this._gtdinboxPage = gtdinboxPage;
	this._httpRequests = [];
};

GIXMLHttpRequest.prototype.queueAndProcess = function(request){
	// request: {url:"", callback:function}
try{
	
	if( request ) this._httpRequests.push(request);
	if( this._httpRequestInProgress ){	// in action
		return;
	}
	if( this._httpRequests.length==0 ) return;
	
	var request = this._httpRequests[0];
	var url = request.url;
	var callback = request.callback;
	this._httpRequestInProgress = url;
	this._httpRequests.splice(0,1);
		
	var req = new XMLHttpRequest();
	req.open('GET', url, true);
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(aEvt){
		try{
		if (req.readyState==4) {
			if( req.status==200 ){
				if( callback ) callback(req);
			}
			this._httpRequestInProgress = null;
			this.queueAndProcess();
		}
		}catch(e){
			if( GTDDEBUGMODE ) alert("gixmlhttprequest queueAndProcess statechange\n" + e.toString());
		}
	});
	req.send(null);
}catch(e){
	if( GTDDEBUGMODE ) alert("GIXMLHttpRequest processHttpRequest\n" + e.toString());
}
};

GIXMLHttpRequest.prototype.process = function(url, params, callback, callbackFail){
	// request: {url:"", callback:function}
try{
	var type = params? (params.type||"GET") : "GET";
	
		
	var req = new XMLHttpRequest();
	req.open(type, url, true);
	if( params && params.headers ){
		for( h in params.headers ) req.setRequestHeader( h, params.headers[h] );
	}
	if( type=="POST" && params.data ){
		req.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
		req.setRequestHeader("Content-length", params.data.length);
		req.setRequestHeader("Connection", "close");
	}
	req.onreadystatechange = GIPROTOTYPE.bind(this, function(aEvt){
		try{
		if (req.readyState==4) {
			if( req.status==200 ){
				if( callback ) callback(req);
			}else{
				if( callbackFail ) callbackFail(req);
			}
		}
		}catch(e){
			if( callbackFail ) callbackFail(req);
			if( GTDDEBUGMODE ) alert("gixmlhttprequest process statechange\n" + url + "\n" + callback + "\n\n" + e.toString());
		}
	});
	var data = params? (params.data||null) : null;
	req.send(data);
}catch(e){
	if( GTDDEBUGMODE ) alert("GIXMLHttpRequest processHttpRequest\n" + e.toString());
}
};